<?php
//
// $Id: GetSysHealth.php,v 1.0 2007/06/15 20:14:23 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
/************************************************************************/

//customer ID

//variable to hold customer info
$sInfo = "";
//database information
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');


$getParams = array( "disp");

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
}


function audit_system () {
     global $username, $uroles, $dbconn;

     $sInfo = "";

     if ($uroles['admin'] || $uroles['uadmin']) {

          $query = "SELECT uname, host_addr FROM sessions";
          $result = $dbconn->Execute($query);

$sInfo .= "<h5>Current Portal Sessions</h5>
<table border=1>
<tr>
<td>Name</td>
<td>Host IP</td></tr>";

         while ( !$result->EOF ) {
              list( $nname, $nhostip ) = $result->fields;
              $sInfo .= "<tr><td>$nname</td><td>$nhostip</td></tr>";
              $result->MoveNext();
         }
         $sInfo .= "</table><BR>";

         $query = "SELECT DISTINCT dtRecorded , username, ip, url, action FROM log ORDER BY id DESC LIMIT 20";
         $result = $dbconn->Execute($query);
$sInfo .= "<h5>Recent Activity</h5>
<table border=1>
<tr>
<td>Date</td>
<td>Name</td>
<td>Host IP</td>
<td>URL</td>
<td>ACTION</td>
</tr>";

         while ( !$result->EOF ) {
              list($ndate, $nname, $nhostip, $url, $action )  = $result->fields;
              $url = activateHyperlink($url);
              $sInfo .= "<tr><td>$ndate</td><td>$nname</td><td>$nhostip</td><td>$url</td><td>$action</td></tr>";
              $result->MoveNext();
         }

         $sInfo .= "</table><BR>";

     }




     echo "$sInfo";



}


function health() {
     global $username, $uroles, $dbconn;

     $sInfo = "";

     if ($uroles['admin'] || $uroles['uadmin']) {

          $sInfo .= "<h5>SCAN Requests</h5>";
          $query = "SELECT count(id) as count FROM I3_jobs WHERE job_TYPE= 'R' AND authorized='0'";
          $scanrequests = $dbconn->GetOne($query);

          if ($scanrequests > 0) { $sInfo .= "<a href=\"sched.php?disp=auth_request\">"; }
          $sInfo .= "$scanrequests";
          if ($scanrequests > 0 ) { $sInfo .= "</a>"; }
          $sInfo .= " scan request";
          if ($scanrequests!=1) { $sInfo .= "s"; }
          $sInfo .= " have been submitted.<BR>";     

     }

     $query = "SELECT hostname, server_nversion, server_feedtype, server_feedversion, 
         current_scans, max_scans, checkin_time, status
         FROM nessus_servers
         WHERE enabled='1' AND (owner='$username' OR type='G')
         GROUP BY id";

     $result = $dbconn->Execute($query);
     $sInfo .= "<h5>Server Status</h5>
          <table border=1>
          <tr>
          <td>Host IP</td>
          <td>Ver</td>
          <td>Feed Type</td>
          <td>Feed (at Last Scan)</td>          
          <td>Last Checkin</td>
          <td>Run</td>
          <td>Max</td>
          <td>Status</td></tr>";

     while ( !$result->EOF ) {
         list($nhostname, $nver, $ntype, $nfeed, $ncurrent, $nmax, $checkin, $serv_status ) =
          $result->fields;

          $ntype = trim(str_replace("Registered", "", $ntype));

          $sInfo .= "<tr>
               <td>$nhostname</td><td>$nver</td><td>$ntype</td><td>$nfeed</td>
               <td>$checkin</td><td>$ncurrent</td><td>$nmax</td>";

          switch ($serv_status) {
               case "N":
                    $srv_stat_desc= "Off-Line";
                    break;
               case "C":
                    $srv_stat_desc= "Checking";
                    break;
               case "A":
                    $srv_stat_desc= "On-Line";
                    break;
               default:
                    $srv_stat_desc= "Unknown";
                    break;
          }
          $sInfo .= "<td>$srv_stat_desc</td>
               </tr>";
          $result->MoveNext();

     }
     $sInfo .= "</table><BR>";

     $running = shell_exec('ps -ef | grep "nessusCron"| grep -v "grep|/bin/sh" | wc -l'); 

     if ( $running == "" ) {
          $running = 0;
     }


     $sInfo .= "<h5>Scan Details</h5>";


     $query = "SELECT count(id) as count FROM I3_jobs WHERE status = 'S'";
     $queued =  $dbconn->GetOne($query);

     $sInfo .= "<b><table border=0>";

     $sInfo .= "<tr><td align=\"right\">Queued Scans:</td><td> $queued</td></tr>";
     $sInfo .= "<tr><td align=\"right\">Currently Running:</td><td> $running</td></tr>";
     $sInfo .= "</table></b><p></p>";

     $sInfo .= "<h5>Running Scans</h5>";


     $sInfo .= "
          <table width=\"100%\" summary=\"Search results\" 
          border=1 cellspacing=\"0\" cellpadding=\"0\" 
          style=\"border-collapse: collapse\" >";

     $sInfo .= "<tr>
          <td>&nbsp;</td>
          <td>Job Name</td>
          <td>Hosts</td>
          <td>Scan Server</td>
          <td>Scan Time</td>
          <td>Site</td>
          <td>Location</td>
          <td>POC</td>
          </tr>";

     $query = "SELECT t1.id, t1.name, t2.site_code, t2.cntHosts, t2.location, t2.poc, 
          t1.scan_START, t1.scan_END, t1.scan_SUBMIT, t1.status, t1.notify, t3.hostname
          FROM I3_jobs t1
          LEFT JOIN I3_subnets t2 ON t1.meth_TARGET = t2.CIDR
          LEFT JOIN nessus_servers t3 on t1.scan_SERVER = t3.id
          WHERE t1.status = 'R'";

     $result = $dbconn->Execute($query);

     while ( !$result->EOF ) {
          list ($nid, $nname, $nsite, $nhosts, $nlocation, $poc, $start_date, $end_date, $submit_date,
               $nstatus, $nnotify, $shostname ) = $result->fields;

          if ( $nnotify != "" ) { $poc = $nnotify; }

          if ( $start_date && $end_date ) {
               if ( $scntHosts ) {
                    $nhosts = $scntHosts;
               }
               $scantime = $end_date;
               $scantime = str_replace("-", "", $scantime);
               $scantime = str_replace(" ", "", $scantime);
               $scantime = str_replace("/", "", $scantime);
               $scantime = str_replace(":", "", $scantime);

               if ( $siScantime ) {
                    $nmins = "$siScantime mins";
               } else { 
                    $nmins = datediff("n", $end_date, $start_date ) . " mins";
               }
               if ($uroles['admin'] || $uroles['uadmin']) {
                  $buttons = "<a href=\"sched.php?disp=kill_scan&job_id=$nid\"><img src=\"images/delete.png\" border=0></a>";
               }
          } elseif ( $start_date ) {
               $buttons = "<img src=\"images/running.png\" border=0>";
               $curtime = gen_strtotime("now", "");
               $nmins = "RUN..>" . datediff("n",  $curtime, $start_date );
               $nmins .= " mins";
          } elseif ( $submit_date ) {
               $buttons = "<img src=\"images/sched.png\" border=0>";
               $nmins = "&nbsp";
          } else { 
               $nmins = "&nbsp";
               $start_date = "";
               $end_date = "<i>Never</i>";
          }

          $add_info = "ct=$curtime st=$start_date fd=$end_date";
          $arrIP = split('[/.]', $nname);

          $searchIP = "$arrIP[0].$arrIP[1].$arrIP[2].";

          $sInfo .= "
               <tr>
               <td>$buttons</td><td>$nname</td>
               <td>$nhosts</td>
               <td>$shostname</td>
               <td>$nmins</td>
               <td>$nsite</td>
               <td>$nlocation</td>
               <td>$poc</td>
               </tr>";
          $result->MoveNext();

     }

     $sInfo .= "</table><br>";

     echo "$sInfo";

}

switch($disp) {

     case "audit":
       audit_system();
        break;

     default:
       health();
        break;
}


?>

