<?php
//
// $Id: exclusions.php,v 1.10 2008/05/22 20:15:01 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Manage Infrastructure";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "disp", "zid", "op" );
$postParams = array( "disp", "zid", "subid", "op", "ip_range", "hostname", "sdescription", "requestee", "active" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}


function navbar ( $zid ) {
   global $uroles, $dbconn;

   $eid = "";

   echo <<<EOT
<center><h3>Manage Scan Exclusions</h3>
      [ <a href="exclusions.php">Main</a> ]
EOT;
   if ($zid) {

      $query = "SELECT ip_range
           FROM I3_scan_exclusions
           WHERE id=$zid";
      $result = $dbconn->execute($query);
      list($range  ) = $result->fields;

      echo <<<EOT
 -> Edit Exception [ <font color=red>$range</font> ]
EOT;
   }
   echo "</center>";
}



function delete_exclusion ( $nid ){
     global $uroles, $username, $dbconn;

     navbar( "" );

     $query = "SELECT ip_range FROM I3_scan_exclusions WHERE id = '$nid'";

     $result=$dbconn->Execute($query);
     list($nname) = $result->fields;

    if ( $uroles['admin'] ) {

       $query = "DELETE FROM I3_scan_exclusions WHERE id = '$nid' LIMIT 1";
       $result=$dbconn->Execute($query);

       echo "Deleted Server <i>\"$nname\"</i>";
       logAccess( "DELETED NESSUS SCAN EXCLUSION $nname" );
    } else {
       echo "ACCESS DENIED";
       logAccess( "UNAUTHORIZED ATTEMPT TO DELETED EXCLUSION [$nname]" );
    }

}


function edit_exclusion($zid, $op ){
   global $subid, $ip_range, $hostname, $sdescription, $requestee, $active, $arrStatus, $module_name, $username, $dbconn;

   navbar ( $zid );
   $now = gen_timeasstr();

   if ( $op=="save" ) {

      $query = "UPDATE I3_scan_exclusions
         SET ip_range ='$ip_range', hostname='$hostname', description='$sdescription',
         requestee='$requestee', updatedBy='$username', dtModified='$now', active='$active'
         WHERE id='$zid'";
      $result = $dbconn->execute($query);
      echo "sub - $ip_range has been updated.</br>";
   } elseif ( $op=="savenew" ) {
      $flag=1;
      $problemtext= "Subnet name can not be blank<br />";

      if($ip_range==""){
         $flag=0;
         $problemtext="";
      } else {

         //check for duplicates
         $query = "SELECT count(id)
               FROM I3_scan_exclusions
            WHERE ip_range ='$ip_range'";

         $result = $dbconn->execute($query);
         list($exfound) = $result->fields;

         if( $exfound > 0 ){
            $flag=0;
            $problemtext.="Subnet '$ip_range' already exist in the database<br />";
         }
      }
      if($flag==1){
         $query="INSERT INTO I3_scan_exclusions
            ( sub_id, ip_range, hostname, description, requestee, dtAdded, updatedBy, active) 
            VALUES ('$subid', '$ip_range', '$hostname', '$sdescription',
               '$requestee', '$now', '$username', '1')";
         $result = $dbconn->execute($query);

         #echo "sql=$query<br>";

         echo "<h4>EXCEPTION ADDED[ $ip_range ]</h4>";
         #Multiadd
         echo "<h5>Add another similar EXCEPTION?: </h5>";
         $op="savenew";
         $zid="";
         $ip_range="";

      } else {
         echo <<<EOT
<center><b>Error</b></center><br><br>
There was a problem saving configuration:<br />
$problemtext<br><br>[ <a href="javascript:history.go(-1)">Go Back</a> ]
EOT;

      }
   } elseif ( $op=="edit" ) {
   //check input
      if(is_numeric($zid)){

         $query = "SELECT id, sub_id, ip_range, hostname, description, requestee, active
            FROM I3_scan_exclusions
            WHERE id=$zid";
         $result = $dbconn->execute($query);

         list($zid, $subid, $ip_range, $hostname, $sdescription, $requestee, $active ) = $result->fields;

         echo "<h5>Edit exceptions:  $zid</h5>";
         $op="save";
      } else{
         echo "It was a problem accessing the data";
      }
   } else {
      echo "<h5>Add Exception: </h5>";
      $op="savenew";
   }

   if ( $active ) {
      $active_checked = "checked ";
   } else {
      $active_checked = "";
   }

   echo <<<EOT
<form method="POST" action="exclusions.php">
<input type="hidden" name="disp" value="ex_edit">
<input type="hidden" name="op" value="$op">
<input type="hidden" name="zid" value="$zid">
<table>
<tr><td>IP Range</td>
<td><input type="text" name="ip_range"  size="40" value="$ip_range"></td>
</tr>
   <tr><td>HOSTNAME</td>
<td><input type="text" name="hostname"  size="40" value="$hostname"></td>
</tr>   
<tr><td>Description</td>
   <td><textarea wrap="virtual" cols="70" rows="15" name="sdescription">$sdescription</textarea></td>
</tr>
<tr><td>Requestee</td>
   <td><input type="text" name="requestee"  size="40" value="$requestee"></td>
<tr><td>Active Exception</td>
   <td><input type="checkbox" name="active" value="1" $active_checked ></td>
</tr>

</table>
<input type="submit" name="submit" value="Save"></FORM>
EOT;


}

function exception_list ( ) {
   global $dbconn;

   navbar ( "" );

   $query = "SELECT id, sub_id, ip_range, hostname, description, requestee, dtAdded, active
         FROM I3_scan_exclusions";
   $result = $dbconn->execute($query);

   echo <<<EOT
<font color="red">
<h5>ALL SCAN EXCLUSIONS</h5></font>

<table width="%100" summary="Search results" border=1 >
<tr>
   <td>&nbsp;</td>
   <td width="%25">IP RANGE</td>
   <td>HOSTNAME</td>
   <td>DESCRIPTION</td>
   <td>USERNAME</td>
   <td>DATE ADDED</td>
   <td>&nbsp;</td>
</tr>
EOT;
   while( !$result->EOF ) {
      list($zid, $sub_id, $ip_range, $hostname, $description, $username, $dtAdded, $active ) = $result->fields;

      $image_name = "";
      if ( $active ) { 
         $image_name = "active.gif";
      } else {
         $image_name = "inactive.gif";
      }
      echo <<<EOT
<tr>
<td>&nbsp;<img src="images/$image_name">&nbsp;</td>
<td>$ip_range</td>
<td>$hostname</td>
<td>$description</td>
<td>$username</td>
<td>$dtAdded</td>
<td align="center">
   <a href="exclusions.php?disp=ex_edit&zid=$zid&op=edit"><img src="images/pencil.png"></a>
   <a href="exclusions.php?disp=ex_delete&zid=$zid" onclick="return confirmDelete();"><img src="images/delete.png"></a>
   </td>
</tr>
EOT;
      $result->MoveNext();
   }

echo <<<EOT
</table><br><br>
<a href="exclusions.php?disp=ex_edit">Add New Exclusion</A>
EOT;

}


switch($disp) {

   case "ex_delete":
      delete_exclusion($zid );
   break;

   case "ex_edit":
      edit_exclusion($zid, $op );
   break;

   default:
      exception_list();
      break;

}

   include ("footer.php");
?>