<?php

//
// $Id: threats-db.php,v 1.0 2008/02/21 12:34:35 kkline Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Inprotect FeedBack";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$myhostname="";


$postParams = array( 'requestee_email', 'type', 'message' 
                   );


switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         if(is_array($_GET[$gp])) {
            foreach ($_GET[$gp] as $i=>$tmp) {
               ${$gp}[$i] = sanitize($tmp);
            }
         } else {
            $$gp = sanitize($_GET[$gp]);
         }
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         if(is_array($_POST[$pp])) {
            foreach($_POST[$pp] as $i=>$tmp) {
               ${$pp}[$i] = sanitize($tmp);
//echo $pp . "[" . $i . "] = " . $$pp[$i] . "<br>";
            }
         } else {
            $$pp = sanitize($_POST[$pp]);
//echo $pp . " = " . $$pp . "<br>";
         }
      } else { 
         $$pp=""; 
      }
//echo $pp . " = " . $$pp . "<Br>";
   }
   break;
}

function feedback () {

     global $sitename, $useremail;

     echo <<<EOT

<center><h3>$sitename - FEEDBACK</h3></center>

<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width='100%'>
<form method="post" action="feedback.php">
<INPUT TYPE=HIDDEN NAME="disp" VALUE="submit">
<tr><td align="Right" width="25%">My EMAIL Address:</td>
     <td><input type="text" name="requestee_email" size="40" value="$useremail"><td>
</tr>
<tr>
     <td align="Right" width="25%">Request Type:  </td>
     <td align=LEFT><SELECT NAME="type">
          <OPTION VALUE="" SELECTED>Please Select Appropriate Type</OPTION>
          <OPTION VALUE="scan_question" >Question regarding Scans</OPTION>
          <OPTION VALUE="suggestion" >Make a Suggestion</OPTION>
          <OPTION VALUE="bug" >Report a Bug</OPTION>
          <OPTION VALUE="exception" >Request an Exception to Scanning</OPTION>
          <OPTION VALUE="exception" >Other</OPTION>
     </SELECT></td>
</tr>
<tr>
     <td align="Right" width="25%">Message:</td>
     <td><textarea wrap="virtual" cols="70" rows="15" name="message"></textarea></td>
</tr>
<tr> <td align="Right" width="25%" colspan="2">
     <input type="submit" name="submit" value="Submit" class="mainoption">
     </TD>
</tr></form>
</table>
EOT;

}

function submit_feedback ( $requestee_email, $type, $message ) {
     global $sitename, $suggestionEmailAddress;


     if ( $requestee_email != "" && $type != "" && $message != "" ) {
          $subject = "$sitename REQUEST - ".$type;
          mail($suggestionEmailAddress, $subject, $message, "From: $requestee_email\nX-Mailer: PHP/" . phpversion());
          echo "<center><h4>Request Submitted</h4></center>";
     } else {
          echo "<center><h4>Request Submission Failed!</h4></center>
               Please select a request type and ensure a message was supplied with this feedback!,
               thank you, <br><br>$sitename<br><br><center>[ <a href=\"javascript:history.go(-1)\">Go Back</a> ]</center>";
     }

}


switch($disp) {
     case "submit":
          submit_feedback ( $requestee_email, $type, $message );
          break;     

    default:
        feedback();
        break;
}
     include_once('footer.php');
?>