<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<head>
<?php
if (isset($pageTitle)) {
   echo "<title>InProtect - $pageTitle</title>";
} else {
   echo "<title>InProtect</title>";
}

// Insert META information tags if applicable
if( isset($meta_info) && is_array($meta_info) ) {
    foreach( $meta_info as $tag_info ) {
        $meta_string = "<meta";
        foreach( $tag_info as $tag_property=>$tag_value ) {
            $meta_string .= " " . $tag_property . "=\"" . $tag_value ."\"";
        }
        $meta_string .= " />";
        echo $meta_string;
    }
}

if ( !$siteLogo ) { $siteLogo = "images/logo-blue.png"; }
if ( !$siteBranding ) { $siteBranding = "Inprotect"; }
$now = date("m/d/Y H:i:s");

echo <<<EOT

<link rel="stylesheet" type="text/css" href="./css/inprotect.css" />
<script type="text/javascript" src="inprotect.js"></script>
<script type="text/javascript">
<!--
function confirmDelete(){
    return confirm("Are you sure you wish to delete this entry?");
}

function CheckEm(cbObj, Name, CheckValue ){
	var elems = document.getElementById(Name).getElementsByTagName("input");
	for(var i=0;i<elems.length;i++){
		if (elems[i].type=="checkbox") {
			elems[i].checked=CheckValue;
		}
	}
}

startList = function() {
   if (document.all&&document.getElementById) {
      navRoot = document.getElementById("menu");
      for (i=0; i<navRoot.childNodes.length; i++) {
         node = navRoot.childNodes[i];
         if (node.nodeName=="LI") {
            node.onmouseover=function() {
               this.className+=" over";
            }
            node.onmouseout=function() {
               this.className=this.className.replace(" over", "");
            }
         }
      }
   }
}
window.onload=startList;
-->
</script>

<script type="text/javascript" src="overlib/overlib.js"><!-- overLIB (c) Erik Bosrup --></script>

</head>
<body>
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
<div id="header">
<div class="leftheader">
   <img alt="Logo" src="$siteLogo">
</div>

<div class="rightheader">
   Logged in as: <I>$username</I>&nbsp;&nbsp;<BR/>
   $siteBranding <I>v $version</I><br/>
   System Time: <I> $now </I>
</div>
</div>
<div style="{clear:both;}"></div>
<div id="container">

<div id="nav">
<div>
<ul id="menu">
   <li id="first">
      <div><A HREF="index.php" Class="navlink"> Home</a></div>
   </li>
   <li>
   <div><A HREF="dashboard.php" Class="navlink">Dashboard</a></div>
      <ul>
      	 <li><a href="monitor.php" class="navlink">Summary</a></li>
EOT;
 if( $uroles['admin'] ) {
   echo <<<EOT
      <li><a href="nessus_activity.php" class="navlink">Recent Scans/Queue</a></li>
EOT;
}


if (  $enableSub ) {
   echo <<<EOT
	<li><a href="nessus_cron.php" class="navlink">Network Health</a></li>
	<li><a href="nessus_host.php" class="navlink">Host Health</a></li>
EOT;
	
}
 if( $enableSub && ( $uroles['admin'] || $uroles['infrastructure'] || $uroles['sys_access'] )) {
   echo <<<EOT
      	<li><a href="nessus_systems.php" class="navlink">Systems Health</a></li>
EOT;
}   
   echo <<<EOT
         <li><a href="threats-db.php" class="navlink">Threats Database</a></li>
         <li><a href="trend_history.php" class="navlink" target="_blank">Trend Network Health</a></li>
EOT;
 if( $uroles['admin'] ) {
   echo <<<EOT
      <li><a href="monitor.php?disp=audit" class="navlink">Audit (Recent Activity)</a></li>
EOT;
}
   echo <<<EOT
      </ul>
   </li>

   <li>
      <div><A HREF="control.php" Class="navlink">Settings</a></div>
      <ul>

EOT;

if($uroles['admin'] || $uroles['profile'] || $uroles['zones'] || $uroles['uadmin']) {
   if($uroles['admin']) {
      echo "<li><a href='webconfig.php' class='navlink'>Inprotect Settings</a></li>";
   }
   if($uroles['profile'] && $enComplianceChecks ) {
      echo "<li><a href='csettings.php' class='navlink'>Compliance Profiles</A></li>";
   }
   if($uroles['profile']) {
      echo "<li><a href='settings.php' class='navlink'>Nessus Scan Profiles</A></li>";
   }

   if($uroles['zones']) {
      echo "<li><a href='servers.php' class='navlink'>Nessus Servers</A></li>";
      echo "<li><a href='zones.php' class='navlink'>Network Zones</A></li>";
   }
   if($uroles['admin'] || $uroles['uadmin']) {
      echo "<li><a href='admin.php' class='navlink'>Manage Users</A></li>";
      echo "<li><a href='gadmin.php' class='navlink'>Manage Groups</A></li>";
   }
}

echo "<li><a href='user.php' class='navlink'>My Settings</a></li>";

if ($enableUpdates && $uroles['admin']) {
   echo "<li><A HREF='updates.php' Class='navlink'>Updates</a></li>";
}
echo <<<EOT
      </ul>
   </li>

   <li>
        <div><A HREF="scan.php" Class="navlink">Security Scan</a></div>
        <ul>
             <li><A HREF="sched.php" Class="navlink">New Scan Job</a></li>
             <li><A HREF="scheduler.php" Class="navlink">Manage Recurring Jobs</a></li>
EOT;

if ( $enablePS ) {
   echo <<<EOT
	<li><a href="portscan.php" class="navlink">New NMap Scan</a></li>
EOT;
	
}

echo <<<EOT
        </ul>
   </li>
   <li>
      <div><A HREF="reports.php" Class="navlink">Reports</a></div>
      <ul>
         <li><A HREF="results.php" Class="navlink">Nessus Scan Results</a></li>
         <li><A HREF="filters.php" Class="navlink">Incident Reporting</a></li>
EOT;
         if( $enableSub && ( $uroles['admin'] || $uroles['executive'] )) {
            echo "<li><a href='executive.php' class='navlink' target='_blank'>Executive Report</a></li>";
         }
         if($enablePS) {
            echo "<li><a href='portscanres.php' class='navlink'>Nmap Scan Results</a></li>";
         }
   echo <<<EOT
         <li><a href="plugins.php" class="navlink">Latest Plugins</a></li>
         <li><a href="top10v.php" class="navlink">Top 10 Vulns</a></li>
         <li><a href="top10h.php" class="navlink">Top 100 Hosts</a></li>
      </ul>
   </li>
   <li>
      <div><A HREF="search.php" Class="navlink">Search</a></div>
   </li>
   <li>
      <div><A HREF="infrastructure.php" Class="navlink">Infrastructure</a></div>
      <ul>
EOT;
 if( $uroles['admin'] || $uroles['infrastructure'] ) {
   echo <<<EOT
      	<li><A HREF="hosts.php" Class="navlink">Hosts</a></li>
      	<li><A HREF="systems.php" Class="navlink">Accredited Systems</a></li>
EOT;
}

 if ( $enableISVM && ( $uroles['isvmView'] || $uroles['isvmAdmin'] )) {
   echo <<<EOT
      	<li><A HREF="isvm.php" Class="navlink">ISVM</a></li>
EOT;
}
// only display the exceptions tab if user has rights to access it
 if( $enableSub && ( $uroles['admin'] || $uroles['infrastructure'] )) {
   echo <<<EOT
      	<li><A HREF="orgs.php" Class="navlink">Orgs</a></li>
EOT;
}
 if( $enableSub && ( $uroles['admin'] || $uroles['infrastructure'] || $uroles['selfservice'] )) {
   echo <<<EOT
      	<li><A HREF="sites.php" Class="navlink">Sites</a></li>
      	
EOT;
} 


// only display the exceptions tab if user has rights to access it
if( $uroles['eview'] || $uroles['esubmit'] || $uroles['eapprove'] ) {
   echo <<<EOT
   <li><A HREF="exclusions.php" Class="navlink">Scan Exclusions</a></li>
   <li><A HREF="exceptions.php?view=all" Class="navlink">All Exceptions</a></li>
   <li><a href="exceptions.php?view=pending" Class="navlink">Pending Exceptions</a></li>
EOT;
}

   echo <<<EOT
      </ul>
   </li>
   <li>
      <div><A HREF="help.php" Class="navlink">Help</a></div>
   </li>
   <li>
      <div><A HREF="index.php?logout=true" Class="navlink">Logout</a></div>
   </li>
   <li id="last">
      <div>
      <a href="feedback.php" class="navlink"><img src="images/email_link.png" alt="Make a Suggestion"></a>
      </div>
   </li>
</ul>
</div>
<div style="{clear: left;}"></div>
</div>

<div id="mainBody" class="column">
EOT;

online();   
   
?>
