<?php
//
// $Id: graph1.php,v 1.5 2006/08/10 17:19:32 airwofl Exp $
//

require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once("jpgraph/jpgraph.php");
require_once("jpgraph/jpgraph_pie.php");
require_once("jpgraph/jpgraph_pie3d.php");

$getParams = array( "caption", "totalvulns" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp = ""; 
      }
   }
	break;
}

if ($caption=="" || $totalvulns=="" ) { JpGraphError::Raise(" No vulnerability data or incomplete data to chart. "); }

if ($totalvulns > 0) {
$graph = new PieGraph(550,250,"auto");
$graph->SetAntiAliasing();
$graph->SetShadow();

$graph->title->Set("$caption - $totalvulns");
$graph->title->SetFont(FF_FONT1,FS_BOLD);

$p1 = new PiePlot3D($data);
$p1->SetSize(0.5);
$p1->SetStartAngle(290);
$p1->SetAngle(50);
$p1->SetCenter(0.30);




$p1->SetLegends($legend);
$colors=array("red", "cornsilk", "yellow", "magenta", "orange", "navy","khaki", "green", "blue","ivory", "lavender" );
$p1->SetSliceColors($colors);
$p1->ExplodeAll(8);
//$dplot[0]->SetFillColor("blue");
//$dplot[1]->SetFillColor("green");
//$dplot[2]->SetFillColor("navy");
//$dplot[3]->SetFillColor("orange");
//$dplot[4]->SetFillColor("magenta");
//$dplot[5]->SetFillColor("yellow");
//$dplot[6]->SetFillColor("red");

$graph->Add($p1);
$graph->Stroke();
}

?>


