<?php 

$pageTitle = "Vulnerability Trend by Subnet";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
#require_once('header2.php');
//require_once('permissions.inc.php');

include ( "jpgraph/jpgraph.php"); 
include ("jpgraph/jpgraph_line.php"); 

$getParams = array( "subnet" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp = ""; 
      }
   }
   break;
}




$query = "SELECT t1.fk_name, UNIX_TIMESTAMP(t1.scantime), t2.vSerious, t2.vHigh, t2.vMed, t2.vLow 
   FROM nessus_reports t1
   LEFT JOIN nessus_report_stats t2 on t1.report_id = t2.report_id 
   WHERE t2.name is not Null";

$result = $dbconn->execute($query);

#HOLD SUM OF VULNERABILITIES FOR KNOWN SCANS
$totalSerious = 0;
$totalHigh = 0;
$totalMedium = 0;
$totalLow = 0;

$lastScantime = "";

#echo "<html><head><title>test</title></head><body>";

$i  = 0;

while ( $row = $result->fields ) {
   
   $CIDR = str_replace("/", "-", $row[0] );
   $scantime = date("m.d.y", $row[1] );
   
   #ADD NEW VAULES
   $totalSerious = $totalSerious + $row[2];
   $totalHigh = $totalHigh + $row[3];
   $totalMedium = $totalMedium + $row[4];
   $totalLow = $totalLow + $row[5];

   #SUBTRACT PREVIOUS VALUE
   if ( $r["$CIDR"]['serious']  != "" ) {   
      $totalSerious = $totalSerious - $r["$CIDR"]['serious'];
      $totalHigh = $totalHigh - $r["$CIDR"]['high'];
      $totalMedium = $totalMedium - $r["$CIDR"]['medium'];
      $totalLow = $totalLow - $r["$CIDR"]['low'];
   }
   
   #UPDATE PREVIOUS VALUE TRACKER
   $r["$CIDR"]['serious'] = $row[2];
   $r["$CIDR"]['high'] = $row[3];
   $r["$CIDR"]['medium'] = $row[4];
   $r["$CIDR"]['low'] = $row[5];

   #echo "{$r["$CIDR"]['serious']} <br>";

   #KEEP TOTAL FOR ONLY NEW DATES ( ALL HOURS OF A DAY SHOULD BE SUMMED IN THIS VALUE )
   if ( $scantime != $lastScantime ) {   
      $lastScantime = $scantime;
      $arrScantime[] = "$scantime";
      $arrSerious[] = $totalSerious;
      $arrHigh[] = $totalHigh;
      $arrMedium[] = $totalMedium;
      $arrLow[] = $totalLow;
      $i = $i + 1;
   }
   $result->MoveNext();
}

$arrScantime[] = date("m.d.y"); 
$arrSerious[] = end( $arrSerious );
$arrHigh[] = end( $arrHigh );
$arrMedium[] = end( $arrMedium );
$arrLow[] = end ( $arrLow );

#echo "</body></html>";

#exit;
#$ydata = array($serious);
#$y2data = array(354,200,265,99,111,91,198,225,293,251);

// Create the graph and specify the scale for both Y-axis
$graph = new Graph(800,600,"auto");    
$graph->SetScale("textlin");
$graph->SetShadow();

// Adjust the margin
$graph->img->SetMargin(40,40,20,90);

// Create the two linear plot

// Adjust the axis color
$graph->yaxis->SetColor("blue");

$graph->title->Set("TREND PLOT ");
$graph->xaxis->title->Set("ScanTime");
$graph->yaxis->title->Set("Vulnerabilities");
$graph->xaxis-> SetTickLabels( $arrScantime ); 


$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

// Set the colors for the plots 

if ( $i > 10 ) { 
   $interval =  (( $i / 10 )); 
} else {
   $interval = $i;
}

$graph->xaxis->SetTextLabelInterval($interval);

if ( $show == "serious" ) { 
   

   $lnSerious=new LinePlot($arrSerious);
   $lnSerious->SetStepStyle();
   $lnSerious->SetColor("red");
   $lnSerious->SetWeight(2);
   $lnSerious->SetLegend("Serious");
   $graph->Add($lnSerious);

} elseif ( $show == "high" ) { 
   $lnHigh=new LinePlot($arrHigh);
   $lnHigh->SetStepStyle();
   $lnHigh->SetColor("orange");
   $lnHigh->SetWeight(2);
   $lnHigh->SetLegend("High");
   $graph->Add($lnHigh);
} elseif ( $show == "medium" ) { 
   $lnMedium=new LinePlot($arrMedium);
   $lnMedium->SetStepStyle();
   $lnMedium->SetColor("yellow");
   $lnMedium->SetWeight(2);
   $lnMedium->SetLegend("Medium");
   $graph->Add($lnMedium);
} elseif ( $show == "low" ) { 
   $lnLow=new LinePlot($arrLow);
   $lnLow->SetStepStyle();
   $lnLow->SetColor("green");
   $lnLow->SetWeight(2);
   $lnLow->SetLegend("Low");
   $graph->Add($lnLow);
} else {
   
   $lnSerious=new LinePlot($arrSerious);
   $lnSerious->SetStepStyle();
   $lnSerious->SetColor("red");
   $lnSerious->SetWeight(2);
   $lnSerious->SetLegend("Serious");
   $graph->Add($lnSerious);


   $lnHigh=new LinePlot($arrHigh);
   $lnHigh->SetStepStyle();
   $lnHigh->SetColor("orange");
   $lnHigh->SetWeight(2);
   $lnHigh->SetLegend("High");
   $graph->Add($lnHigh);

   $lnMedium=new LinePlot($arrMedium);
   $lnMedium->SetStepStyle();
   $lnMedium->SetColor("yellow");
   $lnMedium->SetWeight(2);
   $lnMedium->SetLegend("Medium");
   $graph->Add($lnMedium);

   $lnLow=new LinePlot($arrLow);
   $lnLow->SetStepStyle();
   $lnLow->SetColor("green");
   $lnLow->SetWeight(2);
   $lnLow->SetLegend("Low");
   $graph->Add($lnLow);

}





// Adjust the legend position
$graph->legend->SetLayout(LEGEND_HOR);
$graph->legend->Pos(0.4,0.95,"center","bottom");

// Display the graph
$graph->Stroke();
?>