#USING PLUGIN 60000 as plugin ID to not step on any existing plugin ID

# REENGINEERED THE nessus_checks table to not have duplicate names otherwise will only be able to support a single
# audit file as default

DROP TABLE IF EXISTS `nessus_checks`;
CREATE TABLE `nessus_checks` (
  `id` int(11) NOT NULL auto_increment,
  `enabled` char(1) character set latin1 NOT NULL default 'Y',
  `name` varchar(255) character set latin1 default NULL,
  `created` varchar(14) collate latin1_bin default NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_bin AUTO_INCREMENT=60000 ;

-- --------------------------------------------------------

-- 
-- Table structure for table `nessus_checks_audits`
-- 

DROP TABLE IF EXISTS `nessus_checks_audits`;
CREATE TABLE `nessus_checks_audits` (
  `id` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL,
  `enabled` char(1) NOT NULL default 'Y',
  `created` varchar(14) default NULL,
  `modified` varchar(14) default NULL,
  `deleted` varchar(14) default NULL,
  `value` varchar(255)  NOT NULL,
  `auditfile` varchar(255) NOT NULL, 
  `cce_id` VARCHAR( 255 ) NOT NULL, 
  PRIMARY KEY  (`id`),
  KEY `name` (`cid`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

ALTER TABLE `I3_subnets` ADD `creport_id` INT( 11 ) NOT NULL DEFAULT '0' AFTER `report_id` ;
ALTER TABLE `I3_systems` ADD `creport_id` INT( 11 ) NOT NULL DEFAULT '0' AFTER `report_id` ;


UPDATE inprotect_settings SET settingValue='1.00.0_alpha_07' WHERE settingName='version';