<?php
//
// $Id: livestats.php,v 1.9 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "Live Stats";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

print "<script src='prototype.js' type='text/javascript'></script>";
if (isset($_REQUEST['refresh'])) { 
   $req_refresh=htmlspecialchars(mysql_real_escape_string(trim($_REQUEST['refresh'])), ENT_QUOTES); 
} else { 
   $req_refresh=""; 
}
if (isset($_REQUEST['sortby'])) { 
   $sortby=htmlspecialchars(mysql_escape_string(trim($_REQUEST['sortby'])), ENT_QUOTES); 
} else { 
   $sortby=""; 
}

$getParams = array( "op", "host", "schedid" );
switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
}

if(is_numeric($req_refresh) && ($req_refresh >= 1) ) { 
   if( isset($meta_info) && is_array($meta_info) ) {
       $meta_info_count = count($meta_info);
   } else {
       $meta_info_count = 0;
   }
   $meta_info[$meta_info_count]["http-equiv"] = "refresh";
   $meta_url = "livestats.php?refresh=".$req_refresh;
   if (is_numeric($sortby)) {
      $meta_url.="&sortby=".$sortby;
   }
   $meta_info[$meta_info_count]["content"] = $req_refresh.";url=".$meta_url; 
}

$logh->log($username . " : " . $_SERVER['PHP_SELF']  .
           " : Accessed Page", PEAR_LOG_DEBUG);

if ($op=="stop") {
    $logh->log("$username : " . $_SERVER['PHP_SELF']  .
               " : Requested stop for schedid=" . $schedid . 
               " host=" . $host, PEAR_LOG_DEBUG);
    if (!is_numeric($schedid)) {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Security violation - Requested to stop non numeric 
                    scheduleid " . $schedid, PEAR_LOG_CRIT);
       die("Can not access this page");
    }
    $query="select count(id) 
            from nessus_schedule 
            where username='$username' and id=$schedid";
    $result=$dbconn->execute($query);

    list($allowaccess)=$result->fields;
    if ($allowaccess<>1) {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Security violation - Schedule not owned by this 
                    user: id " . $scheduleid, PEAR_LOG_CRIT);
       echo "Can not access this page";
       require_once('footer.php');
       die();
    }

    $query="select count(host) 
            from nessus_scan 
            where host='$host' and status='R' and sched_id=$schedid";
    $result=$dbconn->execute($query);
    list($allowaccess)=$result->fields;
    if ($allowaccess==1) {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Sending stop message for schedid=" . 
                  $schedid . " host=" . $host, PEAR_LOG_NOTICE);
       $query="update nessus_scan 
               set status='P' 
               where sched_id=$schedid and host='$host' and status='R'";
       $result=$dbconn->execute($query);
       $stophost=$host;
       $stopschedid=$schedid;
    } else {
       $logh->log("$username : " . $_SERVER['PHP_SELF']  . 
                  " : Security violation - Attempt to stop invalid 
                    schedule or schedule owned by another user - 
                    scheduleid " . $schedid, PEAR_LOG_CRIT);
       echo "Can not access this page";
       require_once('footer.php');
       die();
    }
}

$sql_order="order by ";
$sql_order2="nessus_schedule.name, inet_aton(nessus_live_stats.host)";

if ($sortby=="" || !is_numeric($sortby)) { $sortby=0; }
if ($sortby==0) { // Do nothing as the required sql gets appended at the end of this IF block
} elseif ($sortby==1) {
   $sql_order2="nessus_schedule.name DESC, inet_aton(nessus_live_stats.host)"; 
} elseif ($sortby==2) { 
   // Can't sort by scanner id currently as this is not retrieved until
   //  the while loop when printing the results.
   // Would need to rewrite the whole PHP script to get this working - 
   //  sorry, don't have time.
   //
   // This is only here to maintain order on the sortby IDs used in the 
   //  links and also to make sure nothing breaks.
} elseif ($sortby==3) { 
   // Same comment as above.
} elseif ($sortby==4) { $sql_order2="inet_aton(nessus_live_stats.host), nessus_schedule.name"; }
elseif ($sortby==5) { $sql_order2="inet_aton(nessus_live_stats.host) DESC, nessus_schedule.name"; }
elseif ($sortby==6) { $sql_order.="nessus_live_stats.action, "; }
elseif ($sortby==7) { $sql_order.="nessus_live_stats.action DESC, "; }
elseif ($sortby==8) { $sql_order.="nessus_live_stats.percent, "; }
elseif ($sortby==9) { $sql_order.="nessus_live_stats.percent DESC, "; }
elseif ($sortby==10) { $sql_order.="nessus_live_stats.username, "; }
elseif ($sortby==11) { $sql_order.="nessus_live_stats.username DESC, "; }

$sql_order.=$sql_order2;

echo <<<EOT
<b>Live Scanning Status</b>
<br>
EOT;

$query="select nessus_live_stats.host, nessus_live_stats.action, 
               nessus_live_stats.percent, nessus_schedule.name, 
               nessus_live_stats.username, nessus_schedule.id 
        from nessus_live_stats
        left join nessus_schedule on nessus_live_stats.sid=nessus_schedule.id 
        where nessus_schedule.status='R' " . $sql_order;
$result=$dbconn->execute($query);

$refreshurl = "livestats.php";
$uriparam_refresh = "refresh=".$req_refresh;
$uriparam_sortby = "sortby=".$sortby;

if( $req_refresh<>"" || $sortby<>"" ) {
   $refreshurl .= "?";
}
if( $req_refresh<>"" ) {
   $refreshurl .= $uriparam_refresh;

   if( $sortby<>"" ) {
      $refreshurl .= "&";
   }
}
if( $sortby<>"" ) {
   $refreshurl .= $uriparam_sortby;
}

$query3="select count(*) 
         from nessus_scan 
         where server_id='0'";
$result3=$dbconn->execute($query3);
list($numstill2btested)=$result3->fields;

$query4="select count(*) 
         from nessus_scan 
         where server_id>0 and status='R'";
$result4=$dbconn->execute($query4);
list($numtesting)=$result4->fields;
?>
<p></p>
<a href="<?php echo $refreshurl;?>">Refresh Stats</a>&nbsp;|&nbsp;
<A HREF="schedstats.php?refresh=<?php echo $req_refresh;?>">Hosts still to be Scanned</A>&nbsp;|&nbsp;
Auto Refresh:
<select id="refreshInt" name="refresh" onChange="setRepeater(this.value)">
<option value="0">None</option>
<option value="15">15 Seconds</option>
<option value="60">1 Minute</option>
<option value="300">5 Minutes</option>
</select>
<p></p>
<div id="stats">No running scans to show.</div>
<script type="text/javascript">
  var ajr;
  function setRepeater(refreshInt) {
      if(refreshInt == 0) {
         ajr.stop();
      } else {
         ajr = new Ajax.PeriodicalUpdater('stats','./livestats_table.php', {
          method: 'get',
          frequency: refreshInt,
          decay: 2 });
      }
      return false;
  }
  new Ajax.Updater('stats','./livestats_table.php', {method: 'get'});
  //getPage('livestats_table.php', 'stats');
</script>
<?php

include ('footer.php');

?>
