<?php 

$pageTitle = "Visitors by date";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
#require_once('header2.php');
//require_once('permissions.inc.php');

include ( "jpgraph/jpgraph.php"); 
include ("jpgraph/jpgraph_line.php"); 
global $dbconn;

$query = "SELECT DATE(dtRecorded) AS vdate, count(DISTINCT(username)) AS visitors
	FROM log WHERE action='ACCOUNT LOGIN' GROUP BY vdate ORDER BY vdate";
$result = $dbconn->execute($query);

#echo "<html><head><title>test</title></head><body>";
#echo "sql=$query<br>";

$i  = 0;
while ( !$result->EOF ) {
   list($vdate, $vcount ) = $result->fields;

   $arrScantime[] = $vdate;
   $arrVisitors[] = $vcount;
   $i = $i + 1;

   #echo "i=$i date=$vdate count=$vcount<br>";
   $result->MoveNext();
}

#echo "</body></html>";

#exit;


$arrScantime[] = date("m.d.y"); 
$arrVisitors[] = end( $arrVisitors );
$i = $i + 1;

// Create the graph and specify the scale for both Y-axis
$graph = new Graph(800,600,"auto");    
$graph->SetScale("textlin");
$graph->SetShadow();

// Adjust the margin
$graph->img->SetMargin(40,40,20,90);

// Create the two linear plot

// Adjust the axis color
$graph->yaxis->SetColor("blue");

$graph->title->Set("VISITOR TREND");
$graph->xaxis->title->Set("ScanTime");
$graph->yaxis->title->Set("Unique Visitors");
$graph->xaxis-> SetTickLabels( $arrScantime ); 


$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

// Set the colors for the plots 

if ( $i > 10 ) { 
   $interval =  (( $i / 10 )); 
} else {
   $interval = $i;
}

$graph->xaxis->SetTextLabelInterval($interval);

$lnSerious=new LinePlot($arrVisitors);
$lnSerious->SetStepStyle();
$lnSerious->SetColor("red");
$lnSerious->SetWeight(2);
$lnSerious->SetLegend("Visitors");
$graph->Add($lnSerious);


// Adjust the legend position
$graph->legend->SetLayout(LEGEND_HOR);
$graph->legend->Pos(0.4,0.95,"center","bottom");

// Display the graph
$graph->Stroke();
?>