-- adds new field to nessus_results to store the FQDN for a scan result
alter table `nessus_results` add `fqdn` VARCHAR(255) NULL;

-- adds more new fields to nessus_results for break out of the "service" field
ALTER TABLE `nessus_results` ADD `port` INT NULL AFTER `service` ,
ADD `protocol` VARCHAR( 5 ) NULL AFTER `port` ,
ADD `app` VARCHAR( 20 ) NULL AFTER `protocol` ;

-- add 2 new fields to the nessus_live_stats for better reporting of exact
--   status to the user
ALTER TABLE `nessus_live_stats`
ADD `current_action` INT(11) NULL,
ADD `max_action` INT(11) NULL;
