#!/bin/sh
REV=`cat ../install/REV`

rm -Rf ../.Trash-500/
rm -f ../install/sql/clean_install_inprotect*
rm  Inprotect_*.tar.gz

chown root:root -Rf /opt/Inprotect
cp -f ../etc/inprotect.cfg inprotect.bak
cp -f ../html/config.php config.bak
cp -f ../install/configs/inprotect.cfg ../etc/inprotect.cfg
cp -f ../install/configs/config.php ../html/config.php

echo "Writing CLEAN_INSTALL SQL clean_install_inprotect_${REV}.sql"
cat clean_install.sql | \
sed "s#<REV>#${REV}#" | \
cat > ../install/sql/clean_install_inprotect_${REV}.sql
cp ../install/sql/clean_install_inprotect_${REV}.sql /data2/Projects/kkline/workspace/merge_kkline/Inprotect/install/sql/clean_install_inprotect_${REV}.sql

rm -f "Inprotect_${REV}.tar.gz"
cd ../../

tar -zcvf "Inprotect_${REV}.tar.gz" Inprotect --exclude "Inprotect/html/config.php" --exclude "Inprotect/etc/inprotect.cfg" --exclude "Inprotect/html/phpMyAdmin" --exclude "Inprotect/html/demo" --exclude "Inprotect/html/jpgraph/*" --exclude "Inprotect/var/tmp/*" --exclude "Inprotect/var/log/*" --exclude "Inprotect/backup" --exclude "Inprotect/tmp/*" --exclude "Inprotect/builds" --exclude "Inprotect/usr/share/Inprotect/compliance/unix/*" --exclude "Inprotect/usr/share/Inprotect/compliance/win/*" --exclude "Inprotect/usr/share/Inprotect/compliance/win_file_contents/*" --exclude "Inprotect/var/lib/Inprotect/nessus/*" --exclude "Inprotect/var/lib/Inprotect/nmap/*"

mv "Inprotect_${REV}.tar.gz" Inprotect/builds
cd Inprotect/builds

cp Inprotect_${REV}.tar.gz ../html/demo/Latest_build.tar.gz
cp Inprotect_${REV}.tar.gz /data2/Projects/kkline/workspace/merge_kkline/Inprotect/builds/Inprotect_${REV}.tar.gz

cp -f inprotect.bak ../etc/inprotect.cfg
cp -f config.bak ../html/config.php

rm -f config.bak
rm -f inprotect.bak
chown root:klineusers -Rf /opt/Inprotect

