<?php

//
// $Id: profiles.php,v 1.10 2006/09/19 04:57:01 airwofl Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Compliance Settings";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "disp", "delete",  "uid", "cid",
           "op", "confirm",  );
$postParams = array( "disp", "cid", "sname", "sdescription", "stype" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

if(isset($_POST['authorized_users'])) {
   foreach($_POST['authorized_users'] as $user) {
      $users[] = htmlspecialchars(mysql_real_escape_string(trim($user)), ENT_QUOTES); 
   }
}

if (!($uroles['profile'] || $uroles['admin'])) {
   echo "Access Denied!!!<br>";
   logAccess( $username . " : " . $_SERVER['PHP_SELF'] . " : Unauthorized Access" );
   require_once('footer.php');
   die();
}

$query = "select count(*) from nessus_audits";
$result = $dbconn->execute($query);
list($auditcount)=$result->fields;

if ($auditcount==0) {
   die ("<h2>Please run import_auditsettings.pl script first before managing compliance interface interface.</h2>");
}

function navbar( $cid ) {
   global $dbconn;

   echo <<<EOT
<center><h3>Manage Compliance Audits</h3>
[ <a href="csettings.php">Main</a> ]
EOT;
   if ($cid) {
      $query = "SELECT name FROM nessus_audits WHERE id='$cid'";
      $result = $dbconn->execute($query);
      list($profilename) = $result->fields;

      echo <<<EOT
 -> EDIT PROFILE [ <font color=red>$profilename</font> ] ( 
    <a href="csettings.php?disp=editdata&amp;cid=$cid">EDIT</a>
       | <a href="csettings.php?disp=editusers&amp;cid=$cid">USERS</a> )
EOT;
   }
   echo <<<EOT
   </center><br>
EOT;

}

function edit_data($cid) {
   global $module_name, $dbconn;

   navbar( $cid );

   $query = "select id, name, description, check_type, type, owner FROM nessus_audits where id=$cid";
   $result=$dbconn->execute($query);

   echo <<<EOT
<form method="post" action="csettings.php">
<input type="hidden" name="disp" value="update">
<input type="hidden" name="cid" value="$cid">
EOT;
   list ($cid, $sname, $sdescription, $ctype, $stype, $sowner )=$result->fields;
   if($stype=='G') { $stc = "checked"; } else { $stc=""; }
   echo <<<EOT
<table>
<tr>
   <th>Name:</th>
   <td><input type="text" name="sname" value="$sname" size=50>
</tr>
<tr>
   <th>Description:</th>
   <td><input type="text" name="sdescription" value="$sdescription" size=50></td>
</tr>
<tr>
<th>Make this policy available to all users</th>
<td><input type='checkbox' name='stype' $stc>Global Policy</input></td>
</tr>
</tr>
</table><BR>
<input type="submit" name="submit" value="Update">
      </form>
EOT;


}

function edit_profile($cid) {
   global $dbconn;

   navbar( $cid );

   $query = "select name, description from nessus_audits where id=$cid";
   $result = $dbconn->execute($query);
   list($sname, $sdescription) = $result->fields;
   echo <<<EOT
Profile: $sname - $sdescription<br>
<p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p>
EOT;

}

function manage_profile_users($cid) {
   global $dbconn;

   navbar( $cid );

   $query = "select name from nessus_audits where id=$cid";
   $result = $dbconn->execute($query);
   list($nname) = $result->fields;


     echo <<<EOT
<br>
<form action="/csettings.php" method="POST" onSubmit="selectAllOptions('authorized');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4> "$nname" - User Access:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Authorized Users<br>
      <input type="hidden" name="disp" value="updateusers">
      <input type="hidden" name="cid" value="$cid">
    <select name="authorized_users[]" id="authorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;

   $query = "SELECT t1.username FROM nessus_audit_users t1
      LEFT JOIN users t2 ON t1.username = t2.pn_uname
      WHERE t1.cid=$cid ORDER BY t1.username";
   $result = $dbconn->execute($query);

   while( list($uname) = $result->fields ) {
      echo "<OPTION value=\"$uname\">$uname</OPTION>\n";
      $result->MoveNext();
   }


     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.unauthorized,this.form.authorized )"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.authorized,this.form.unauthorized)"></td>
     <td valign=top align="left">
          <select name="unauth_users[]" id="unauthorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;

   $query = "SELECT t1.pn_uname FROM users t1
      LEFT JOIN nessus_audit_users t2 ON t1.pn_uname = t2.username
      AND t2.cid = '$cid'
      WHERE t2.username is Null ORDER BY t1.pn_uname";

   $result = $dbconn->execute($query);

   while( list($nname) = $result->fields ) {
      echo "<OPTION value=\"$nname\" >$nname</OPTION>\n";
      $result->MoveNext();

   }
     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Access'></input></td></tr>
</TABLE></form>
EOT;

}

function select_profile(){
   global $cid, $username, $dbconn;

   navbar( $cid );

   $query="SELECT id, name, description, check_type, type FROM nessus_audits
      WHERE deleted != '1' ORDER BY name";
   $result=$dbconn->execute($query);

   echo <<<EOT
<B>Imported Compliance Audits</B>
<p>
Please select a audit to edit access:
</p>
<table>
<tr>
   <th>Profile</th>
   <th>Description</th>
   <th>Owner</th>
   <th>Type</th>
   <th></th>
</tr>
EOT;
   while (!$result->EOF) {
      list($cid, $sname, $sdescription, $sowner, $stype)=$result->fields;
      echo <<<EOT
<tr>
<td>$sname</td>
<td>$sdescription</td>
<td>$sowner</td>
<td>$stype</td>
<td>
<a href="csettings.php?disp=edit&amp;&amp;cid=$cid"><img src="images/pencil.png"></a>
<a href="csettings.php?disp=edit&amp;op=delete&amp;cid=$cid" onclick="return confirmDelete();"><img src="images/delete.png"></a>
</td>
</tr>
EOT;
      $result->MoveNext();
   }
   echo <<<EOT
</table>
EOT;
   // end else

   
}


function update_profile($cid, $sname, $sdescription, $stype ) {
   global $username, $uroles, $dbconn;

      $result = $dbconn->execute("select owner 
                                  from nessus_audits 
                                  where id = $cid");
      list ($myowner)=$result->fields;
      if ($myowner <> $username && !$uroles['admin']) {
         echo "Access denied: You do not own this profile and are not an admin 
               - (owner = $myowner)\n";
         require_once('footer.php');
         die ();
      }
      // "G" is global, blank is a private scan profile
      if($stype == TRUE) { $stype = "G"; } else { $stype = ""; }
      $query = "update nessus_audits
                set name='$sname', description='$sdescription', 
                   type='$stype'
                where id=$cid";
      $result=$dbconn->execute($query);

      echo "Profile Updated<BR>";

   logAccess( "Updated Autoenable Settings for Profile $cid" );

   edit_profile($cid);

}


function update_users($cid, $users ){
   global $username, $dbconn;

   if ( $cid ) {
      $query = "delete from nessus_audit_users where cid=$cid";
      $result = $dbconn->execute($query);
   }

   if ( $cid && $users ) {

      $query = "SELECT name FROM nessus_audits WHERE id='$cid'";
      $result = $dbconn->execute($query);
      list($name) = $result->fields;
      echo "Updated Users Access for Profile: [$name]<br>";

   foreach( $users as $uname ) {
         if ( $uname ) {
            $query = "INSERT INTO nessus_audit_users (cid, username) VALUES ('$cid', '$uname' );";
            $result = $dbconn->execute($query);
            #echo "sql=$query<br>";
            #echo "inserting server=$nserver   zid=$zid<br>";
         }
      }
   }

   echo "<br>";

   logAccess( "Updated Users Associated to Profile $cid" );


   manage_profile_users($cid);
}

switch($disp) {

   case "edit":
      edit_profile($cid);
      break;

   case "editdata":
      edit_data($cid);
      break;      
      
   case "editusers":
      manage_profile_users($cid);
      break;

     case "update":
      update_profile($cid, $sname, $sdescription, $stype );
      break;

   case "updateusers":
      update_users( $cid, $users );
      break;

   default:
      select_profile();
      break;

}

require_once('footer.php');

?>
