<?php
//
// $Id: control.php,v 1.4 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "Dashboard";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

// number of hosts to show per page with viewing all
$pageSize = 50;


$getParams = array( "disp", "mac" , "hostname", "hostip", "offset", "type", "os", "status",
                    "value", "sortby", "sortdir", "likefilter", "site_code" );
$postParams = array( "disp", "op", "mac" , "hostname", "hostip", "status", "os",
                    "id", "scanstate", "sortby", "sortdir", "likefilter", "site_code");

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
      } else { 
         $$gp="";
      }
   }
   $range_start="";
   $range_end="";
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else { 
         $$pp="";
      }
   }
   break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}

global $uroles, $user_sites, $site_code, $filter, $likefilterm, $sortby;

$user_sites = getSiteCodes ($username);

function navbar ( ) {
     global $uroles, $user_sites, $likefilter, $site_code, $sortby, $dbconn;

     echo "<center><h3>HOST HEALTH</h3></center>";

     if ( $uroles['reports'] ||  $uroles['admin'] ) {
         echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width='100%'>
<tr><form method="post" action="nessus_host.php">
<td align="Right" width="25%">Filter by Sitename:  </td>
<TD align=LEFT><SELECT NAME="site_code">
<OPTION VALUE="" SELECTED >Filter Hosts by Sitename</OPTION>
EOT;
         $query = "SELECT name, site_code from I3_sites order by name";
         $result=$dbconn->Execute($query);

         while ( !$result->EOF ) {
             list($nname, $nsite )  = $result->fields;
             if ( $site_code == $nsite ) {
                 $txtselected = "SELECTED";
             } else {
                 $txtselected ="";
             }
             echo "<OPTION VALUE=\"$nsite\" $txtselected >$nname</OPTION>\n";
             $result->MoveNext();
         }
         echo <<<EOT
</SELECT></td></tr>
<tr><td align="Right" width="25%">Filter by Hostname/IP (Whole/Partial):  </td>
<TD align=LEFT><input type="text" name="likefilter" value="$likefilter">
</td></tr>
<tr><td></td><td>
<input type="submit" name="submit" value="Filter" class="mainoption"></TD>
</form></tr>
</table><br>
EOT;
     } elseif ( count( $user_sites ) > 1 ) {
        echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width="100%">
<tr><td align="Right" width="25%">Associated Sites:  </td>
<form method="post" action="nessus_host.php">
<TD align=LEFT><SELECT NAME="site_code">
EOT;

        $keys_sites = array_keys($user_sites);
        foreach($keys_sites as $value) {
            if ( $site_code == "" ) {
                $site_code = $value;
            }
            if ( $site_code == $value ) {
                $txtselected = "SELECTED";
            } else {
                $txtselected ="";
            }
            echo "<OPTION VALUE=\"$value\" $txtselected >$value</OPTION>\n";
        }
        echo <<<EOT
<tr>
  <td></td>
  <td><input type="submit" name="submit" value="Filter" class="mainoption"></td>
  </form>
</tr>
</table>
EOT;
    } elseif ( count( $user_sites ) == 1 ) {
        $keys_sites = array_keys($user_sites);
        foreach($keys_sites as $value) {
            $site_code = $value;
        }
    }
    echo "</center>";
}

function mouseover_subnet ( $nid ) {
    global $dbconn;

    $content = "<a href=\"javascript:void(0);\" onclick=\"return overlib('$subnet_info', STICKY, CAPTION,
   'Sticky!', CENTER);\" onmouseout=\"nd();\">$nname</a>";

    return $content;

}

function remove_duplicate ( $host_id, $likefilter, $sortby, $sortdir ) {
    global $uroles, $dbconn;

    if ( $uroles['admin'] )  {
        $query = "SELECT hostname FROM hosts WHERE id = '$host_id'";
        echo "query=[$query]<br>";
        $result = $dbconn->execute($query);       
        list($hostname) = $result->fields;        

        $query = "SELECT count(hostname) FROM hosts WHERE hostname LIKE '%$hostname%'";
        echo "query=[$query]<br>";
        $result = $dbconn->execute($query);
        list($count) = $result->fields;

        if ( $hostname != "" && $count > 1 ) {        
            echo "REMOVING THIS DUPLICATE HOST: [ $hostname ]<br>";
            $query = "DELETE FROM hosts WHERE id='$host_id'";
            #echo "query=[$query]<br>";
            $result = $dbconn->execute($query);

            $query = "SELECT id FROM hosts WHERE hostname LIKE '%$hostname%' AND id !='$host_id' LIMIT 1";
            #echo "query=[$query]<br>";
            $result2 = $dbconn->execute($query);    
            list( $replace_id ) = $result2->fields;        

            if ( $replace_id ) {
                $query = "UPDATE host_macs SET host_id='$replace_id' WHERE host_id='$host_id'";
                #echo "query=[$query]<br>";
                $result = $dbconn->execute($query);

                $query = "UPDATE host_stats SET host_id='$replace_id' WHERE host_id='$host_id'";
                #echo "query=[$query]<br>";
                $result = $dbconn->execute($query);

                $query = "UPDATE I3_Incidents SET host_id='$replace_id' WHERE host_id='$host_id'";
                #echo "query=[$query]<br>";
                $result = $dbconn->execute($query);
            }
            echo "COMPLETE<BR>";
            network_status( $likefilter, $sortby, $sortdir );
        } else {
            echo "NO DUPLICATE FOUND<br>";
            network_status( $likefilter, $sortby, $sortdir );  
        }
    } else {
        network_status( $likefilter, $sortby, $sortdir );  
    }

}


function network_status( $likefilter, $sortby, $sortdir ) {
    global $username, $offset, $pageSize, $sitename, $adminmail, $uroles, $user_sites, $site_code, $dbconn;

    navbar ();

    if ($sortby == "" ) { $sortby = "vSerious"; }
    if ($sortdir == "" ) { $sortdir = "ASC"; }
    if ( $likefilter != "" ) {$type = "hostip"; $value = $likefilter; } else { $type = ""; }

    if (  !$site_code && !$uroles['reports'] && !$uroles['admin']  ) {
         $org_code = getUserOrg ($username);    
    } else { $org_code = ""; }
    
    $url_sitecode = "";
    if ( $site_code ) { $url_sitecode = "site_code=$site_code&"; }      
    

    $viewAll = FALSE;
    $querys="SELECT t1.id, t1.hostip, t1.hostname, t1.lastscandate, t1.os,
t2.vSerious, t2.vHigh, t2.vMed, t2.vLow, t2.vInfo,  t1.ORG,
t3.scantime, t3.scantype, t3.report_key,
t4.vHigh as cHigh, t4.vMed as cMed, t4.vLow as cLow,
t5.scantime, t5.scantype, t5.report_key
FROM hosts t1 
LEFT JOIN host_stats t2 on t1.id = t2.host_id AND t1.report_id = t2.report_id
LEFT JOIN nessus_reports t3 on t2.report_id = t3.report_id
LEFT JOIN host_stats t4 on t1.id = t4.host_id AND t1.creport_id = t4.report_id
LEFT JOIN nessus_reports t5 on t4.report_id = t5.report_id"; 
    $sql_sitefilter = "";

    // set up the SQL query based on the search form input (if any)
    switch($type) {
    case "hostip":
        $q = $value;
        if ( $site_code ) {  $sql_sitefilter = "AND ORG='$site_code'"; }   
        $queryw = " WHERE t1.inactive='0' AND ( t1.hostip LIKE '%$q%' OR t1.hostname LIKE '%$q%' ) $sql_sitefilter ";
        $queryw ."ORDER BY INET_ATON(t1.hostip) $sortdir limit $offset,$pageSize"; 
        $stext =  "Search for hostip = '*$q*'";
        break;
    default:
        $viewAll = TRUE;
        if ( $site_code ) {  $sql_sitefilter = " AND site_code='$site_code'"; }
        if ( !$site_code && $org_code ) { $sql_sitefilter = " AND ORG='$org_code'"; }   
        $queryw = " WHERE t1.inactive='0' $sql_sitefilter order by $sortby $sortdir";
        // add the limit for the paging
        $queryw .= " limit $offset,$pageSize"; 
        $stext = "Viewing all Hosts";
        break;
    }

    
    $hostCount = 0;
    if($viewAll) {
        $hostCount = $dbconn->GetOne("SELECT count(hostip) FROM hosts WHERE inactive='0' $sql_sitefilter");
        $previous = $offset - $pageSize;
        if ($previous < 0) {
            $previous = 0;
        }
        $last = $hostCount - $pageSize;
        if ( $last < 0 ) { $last = 0; }
        $next = $offset + $pageSize;
        if ($next > $last) {
            $next = $last;
        }
        $pageEnd = $offset + $pageSize;
        #echo "<p>There are $hostCount fully identifiable hosts on the Network.";

        // output the pager
        echo "<p align=center><a href=\"nessus_host.php?".$url_sitecode."offset=0\" class=\"pager\">&lt&lt First</a> | ";
        if($offset != 0) {
            echo "<a href=\"nessus_host.php?".$url_sitecode."offset=$previous\" class=\"pager\">&lt Previous </a> | ";
        }
        if($pageEnd >= $hostCount) { $pageEnd = $hostCount; }
        echo "[ $offset - $pageEnd of $hostCount ] | ";
        if($next < $last) {
            echo "<a href=\"nessus_host.php?".$url_sitecode."offset=$next\" class=\"pager\">| Next &gt;</a> | ";
        }
        echo "<a href=\"nessus_host.php?".$url_sitecode."offset=$last\" class=\"pager\"> Last &gt;&gt;</a></p>";
    } else {
        // get the search result count
        $queryc = "SELECT count(id) FROM hosts ";
        $scount=$dbconn->GetOne($queryc.$queryw);
        echo "<p>$scount host";
        if($scount != 1) {
            echo "s";
        } else {
        }
        echo "found matching search criteria | "; 
        echo " <a href='nessus_host.php' alt='View All Hosts'>View All Hosts</a></p>";
    }

    $result = $dbconn->Execute($querys.$queryw);

    if($result === false) {
        $errMsg[] = "Error getting hosts: " . $dbconn->ErrorMsg();
        $error++;
        dispSQLError($errMsg,$error);
    }

    echo <<<EOT
<table width="100%" summary="Search results" border=1>
<t>
EOT;

    if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
    $arr = array("", "HostIP",  "Hostname", "LastScanDate", "OS", "vSerious", "vHigh", "vMed", "vLow", "vInfo", "ORG" );
    foreach ( $arr as $value) {
        echo "<th><a href=\"nessus_host.php?".$url_sitecode."offset=$offset&sortby=$value&sortdir=$sortdir\">$value</a></th>";        
    }

    echo <<<EOT
   </tr>
EOT;

    while ( !$result->EOF ) {
        list( $host_id, $hostip, $hostname, $lastscandate, $os, 
        $svSerious, $svHigh, $svMed, $svLow, $svInfo , $sORG, $scantime, $scantype, $report_key, 
        $cvHigh, $cvMed, $cvLow, $cscantime, $cscantype, $creport_key )  = $result->fields;

        $htmldetails = "";
        $buttons ="";

        $base_pdf_url = "respdf.php?scantime=$scantime&scantype=$scantype&key=$report_key&filterip=$hostip";  
        $cbase_pdf_url = "respdfc.php?scantime=$cscantime&scantype=$cscantype&key=$creport_key&filterip=$hostip";

        $query = "SELECT count(host_id) as incident_count FROM I3_Incidents 
            WHERE host_id='$host_id' and status != 'resolved'";
        $result2 = $dbconn->execute($query);
        list( $icount ) = $result2->fields;

        $no_results = 1;

        if ( ( $svSerious + $svHigh + $svMed + $svLow + $svInfo ) >= 1  ) {
           $buttons .= "&nbsp;<a href=\"reshtml.php?disp=html&amp;output=full"
            ."&scantime=$scantime&scantype=$scantype\" target=\"_blank\">"
            ."<img alt=\"HTML\" src=\"images/html.png\" border=0 title=\"Report in HTML format\"></A>&nbsp;"
            ."<a href=\"$base_pdf_url\" target=\"_blank\">"
            ."<img alt=\"PDF\" src=\"images/pdf.png\" border=0 title=\"Report in PDF format\"></A>&nbsp;";
           $no_results = 0;
        } else {
           $buttons .= "&nbsp;<img alt=\"HTML\" src=\"images/noreport.png\" border=0 "
                ." title=\"NO RESULTS\">&nbsp;";
        }

        if ( ( $cvHigh + $cvMed + $cvLow ) >= 1 ) {
            $buttons .= "<a href=\"$cbase_pdf_url\" target=\"_blank\">"
               ."<img alt=\"PDF\" src=\"images/blue_pdf.png\" border=0 title=\"Compliance Audit\"></A>&nbsp;";    
        }

        $buttons .= "&nbsp;<a href=\"trend_hosts.php?host_id=$host_id\" target=\"_blank\">"
            ."<img alt=\"HTML\" src=\"images/trend.png\" border=0 title=\"Trend\"></A>&nbsp;";

        if ( $icount > 0 ) {
            $buttons .= "&nbsp;<a href=\"incidents.php?host_id=$host_id\" target=\"_blank\">"
                ."<img alt=\"Incidents\" src=\"images/incidents.png\" border=0 "
                ."title=\"Incident Tracker\"></A>&nbsp;";
        }
        if ( $uroles['admin'] )  {
            if ( preg_match("/\./", $hostname) ) {

            } else {
                $query = "SELECT count(hostname) FROM hosts WHERE hostname LIKE '%$hostname%'";
                $result2 = $dbconn->execute($query);
                list($count) = $result2->fields;
                if ( $count > 1 ) {
                    $buttons .= "&nbsp;<a href=\"nessus_host.php?disp=checkdup&host_id=$host_id\" >"
                        ."<img alt=\"CHECK_DUPE\" src=\"images/delete.png\" border=0 "
                        ." title=\"DUPE_CHECK\"></A>&nbsp;";
                }
            }
        }


        #COMPLIANCE ISSUES

        if ( $svSerious >= 1 ) {
            $htmldetails .= "<td><a href=\"$base_pdf_url&critical=1\" target=\"_blank\">$svSerious</td>";
        } else {
            $htmldetails .= "<td>$svSerious</td>";
        }
        if ( $svHigh >= 1 ) {
            $htmldetails .= "<td><a href=\"$base_pdf_url&critical=2\" target=\"_blank\">$svHigh</td>";
        } else {
            $htmldetails .= "<td>$svHigh</td>"; 
        }
        if ( $svMed >= 1 ) {
            $htmldetails .= "<td><a href=\"$base_pdf_url&critical=3\" target=\"_blank\">$svMed</td>";
        } else {
            $htmldetails .= "<td>$svMed</td>";
        }
        if ( $svLow >= 1 ) {
            $htmldetails .= "<td><a href=\"$base_pdf_url&critical=6\" target=\"_blank\">$svLow</td>";
        } else {
            $htmldetails .= "<td>$svLow</td>";
        }
        if ( $svInfo >= 1 ) {
            $htmldetails .= "<td><a href=\"$base_pdf_url\" target=\"_blank\">$svInfo</td>";
        } else {
            $htmldetails .= "<td>$svInfo</td>";
        }

        echo <<<EOT
<tr><td>$buttons</td>
  <td>$hostip</td>
  <td>$hostname</td>
  <td>$lastscandate</td>
  <td>$os</td>
  $htmldetails
  <td>$sORG</td>
</tr>
EOT;
        $result->MoveNext();
    }
    echo "</table>";
   // draw the pager again, if viewing all hosts
   if($viewAll) {
      echo
"<p align=center>
<a href=\"nessus_host.php?".$url_sitecode."offset=0\" class=\"pager\">&lt&lt First</a>
<a href=\"nessus_host.php?".$url_sitecode."offset=$previous\" class=\"pager\">&lt Previous </a>
<a href=\"nessus_host.php?".$url_sitecode."offset=$next\" class=\"pager\">| Next &gt;</a>
<a href=\"nessus_host.php?".$url_sitecode."offset=$last\" class=\"pager\"> Last &gt;&gt;</a>
</p>";
   }    
    
}


switch($disp) {

    case "checkdup":
        remove_duplicate ( $host_id, $likefilter, $sortby, $sortdir );
        break;

     default:
        network_status( $likefilter, $sortby, $sortdir);
        break;
}

     include ('footer.php');

?>
