<?php
//
// $Id: respdf.php,v 1.11 2006/09/19 04:57:00 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
#error_reporting(E_ALL);
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
//include ('permissions.inc.php');

//php4 version of htmlspecialchars_decode which is only available in php5 upwards
if (!function_exists('htmlspecialchars_decode'))
{
     function htmlspecialchars_decode($str)
     {
          $str = preg_replace("/&gt;/",">",$str);
          $str = preg_replace("/&lt;/","<",$str);
          $str = preg_replace("/&quot;/","\"",$str);
          $str = preg_replace("/&#039;/","'",$str);
          $str = preg_replace("/&amp;/","&",$str);

          return $str;
     }
}

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
     if (isset($_GET['scantime'])) { 
          $scantime=htmlspecialchars(mysql_escape_string(trim($_GET['scantime'])), ENT_QUOTES); 
     } else { $scantime=""; }
     if (isset($_GET['scantype'])) { 
          $scantype=htmlspecialchars(mysql_escape_string(trim($_GET['scantype'])), ENT_QUOTES); 
     } else { $scantype=""; }
     if (isset($_GET['key'])) { 
          $report_key=htmlspecialchars(mysql_escape_string(trim($_GET['key'])), ENT_QUOTES); 
     } else { $report_key=""; }
     if (isset($_GET['critical'])) { 
          $critical=htmlspecialchars(mysql_escape_string(trim($_GET['critical'])), ENT_QUOTES); 
     } else { $critical="0"; }          
     if (isset($_GET['filterip'])) { 
          $filterip=htmlspecialchars(mysql_escape_string(trim($_GET['filterip'])), ENT_QUOTES); 
     } else { $filterip=""; }     
     break;
}

if ( $critical ) {
     $query_critical = "AND risk <= '$critical'";
}

online();


//Generated date
$gendate = date("Y-m-d H:i:s");

if ( $uname == $ip ) {
     $query_byuser = "AND report_key='$report_key'"; # AND DATEDIFF ( $scantime, now ) <= 15 )";

     $curtime=gen_timeasstr();
     #if ( datediff($curtime, $scantime, $unit="D") > 30 ) {
     #     die ("Email link access for requested report has expired:  Please <a href=\"$tns_url/modules.php?name=Your_Account\">login</a>" );
     #}
     
}

ini_set("max_execution_time","360");
ini_set("memory_limit","64M");

$query = "SELECT report_id FROM nessus_reports WHERE scantime='$scantime'
     AND scantype='$scantype' $query_byuser LIMIT 1";

$result=$dbconn->execute($query);
list ( $report_id ) = $result->fields;


if ( ! $report_id ) {
    logAccess( "ATTEMPT TO ACCESS INVALID NESSUS REPORT" );
    die("Report not found");
}

$query = "select count(scantime) from nessus_results
       where report_id='$report_id'";
$result=$dbconn->execute($query);
list ( $numofresults ) = $result->fields;

if ($numofresults<1) {
    logAccess( "NESSUS REPORT [ $report_id / NO RESULTS ] ACCESSED" );
    die("No vulnerabilities recorded");
}

//include pdf libraries

    $query = "select distinct t1.username, t1.name, t2.name, t2.description, t3.description
   	FROM nessus_reports t1
   		LEFT JOIN nessus_settings t2 on t1.sid=t2.id
   		LEFT JOIN I3_subnets t3 on t1.fk_name = t3.CIDR 
   	where t1.report_id='$report_id' $query_host 
   	order by scantime DESC";
    $result = $dbconn->execute($query);
    list ($query_uid, $job_name, $profile_name, $profile_desc, $sub_desc) = $result->fields;

    logAccess( "XLS REPORT [ $report_id - $job_name ] GENERATED" );

// send the right content headers
header("Content-Type: application/vnd.ms-excel; name='excel'");
header("Content-disposition:  attachment; filename=scanresults-$uid-$scantime.xls");

// Set up the output table
//$dataHead = <<<EOT
echo <<<EOT
<table border=1>
<tr>
   <th colspan=5>Nessus scan results:</th>
</tr>
<tr>
   <th>Scan time:</th>
   <td colspan=4 align=left>$scandate</td>
</tr>
<tr>
   <th>Generated:</th>
   <td colspan=4 align=left>$gendate</td>
</tr>
<tr>
   <th>Profile:</th>
   <td colspan=4 align=left>$profile_name - $profile_desc</td>
</tr>
<tr>
   <th>Job Name:</th>
   <td colspan=4 align=left>$job_name</td>
</tr>
<tr>
   <th>Scanned By:</th>
   <td colspan=4 align=left>$query_uid</td>
</tr>
<tr>
   <th>Subnet Description:</th>
   <td colspan=4 align=left>$sub_desc</td>
</tr>
<tr>
   <th>IP</th>
   <th>Service</th>
   <th>Severity</th>
   <th>ScriptID</th>
   <th width=50%>Description</th>
EOT;

    $query = "select distinct hostip from nessus_results where report_id='$report_id' $query_host order by INET_ATON(hostip) ASC";
    $result = $dbconn->execute($query);

    while ( list($hostip) = $result->fields ) {

        $query1 = "select hostname, service, risk, falsepositive, result_id, msg, scriptid from nessus_results 
             WHERE report_id='$report_id' and hostip='$hostip' and msg<>''
             order by risk ASC, result_id ASC";
          $result1 = $dbconn->execute($query1);
        $arrResults="";

          while ( list($hostname, $service, $risk, $falsepositive, $resid, $msg, $scriptid) = $result1->fields ){
              $tmpport1=preg_split("/\(|\)/",$service);
              if (sizeof($tmpport1)==1) { $tmpport1[1]=$tmpport1[0]; }
               #$htmldetails .= "$tmpport1[0] $tmpport1[1]<BR>";
              $tmpport2=preg_split("/\//",$tmpport1[1]);
               #$htmldetails .= "$tmpport2[0] $tmpport2[1]<BR>";
              $service_num=$tmpport2[0];
              $service_proto=$tmpport2[1];
               $risk_txt = getrisk($risk);
             echo "<tr valign=top>
                  <td>IP=$hostip<br>
                       NAME=$hostname</td>
                       <td>$service</td>
                       <td>$risk_txt</td>
                       <td>$scriptid</td>
                       <td>$msg</td>";
               $result1->MoveNext();
          }
          $result->MoveNext();
    }


//$data .= "</table>";
echo "</table>";

// start the output
//header('Content-Type: text/tab-separated-values');
//header('Content-Disposition: attachment; filename="scanresults.txt"');
//echo $data;

?>
