<?php
//
// $Id: top10v.php,v 1.5 2006/08/10 17:19:33 airwofl Exp $
//

$pageTitle = "Top 10 Vulnerabilities";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

// array of possible date ranges
$allRanges = array( "all" => "All Time",
                    "7" => "Last 7 Days",
                    "14" => "Last 14 Days",
                    "30" => "Last 30 Days",
                    "60" => "Last 60 Days",
                    "90" => "Last 90 Days",
                    "180" => "Last 180 Days",
                    "365" => "Last Year"
                  );

$getParams = array( "disp", "daterange" );
$postParams = array( "disp", "likefilter", "site_code" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
case "POST" :
   $post = TRUE;
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) {
        $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else {
        $$pp = "";
      }
   }
	break;
}

global $username, $uroles, $user_sites, $site_code;

$user_sites = getSiteCodes ($username);

function navbar ( ) {
     global $uroles, $user_sites, $likefilter, $site_code, $sortby, $dbconn;

     echo "<center><h3>TOP 10 Vulns by Risk</h3></center>";
     $txtselected = "";
     if ( $uroles['reports'] ||  $uroles['admin'] ) {
          echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width='100%'>
<form method="post" action="top10v.php">
<tr><td align="Right" width="25%">Filter by Sitename:  </td>
<TD align=LEFT><SELECT NAME="site_code">
<OPTION VALUE="" $txtselected ></OPTION>
EOT;
          $query = "SELECT name, site_code from I3_sites order by name";
          $result=$dbconn->Execute($query);

          while ( !$result->EOF ) {
               list($nname, $nsite )  = $result->fields;
               if ( $site_code == $nsite ) {
                    $txtselected = "SELECTED";
               } else {
                    $txtselected ="";
               }
               echo "<OPTION VALUE=\"$nsite\" $txtselected >$nname</OPTION>\n";
               $result->MoveNext();
          }
          echo <<<EOT
</SELECT></td></tr>
<tr><td align="Right" width="25%">Filter by Subnet (Whole/Partial):  </td>
<TD align=LEFT><input type="text" name="likefilter" value="$likefilter">
</td></tr>
<tr><td></td><td>
<input type="submit" name="submit" value="Filter" class="mainoption"></TD>
</form></tr>
</table><br>
EOT;

     } elseif ( count( $user_sites ) > 1 ) {

          echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width="100%">
<tr><td align="Right" width="25%">Associated Sites:  </td>
<form method="post" action="top10v.php">
<TD align=LEFT><SELECT NAME="site_code">
EOT;

         $keys_sites = array_keys($user_sites);

          foreach($keys_sites as $value) {
               if ( $site_code == "" ) {
                         $site_code = $value;
                    }
               if ( $site_code == $value ) {
                    $txtselected = "SELECTED";
               } else {
                    $txtselected ="";
               }
               echo "<OPTION VALUE=\"$value\" $txtselected >$value</OPTION>\n";

          }

          echo <<<EOT
          <tr><td></td><td>
          <input type="submit" name="submit" value="Filter" class="mainoption"></TD>
          </form></tr>
          </table><br>
EOT;
     } elseif ( count( $user_sites ) == 1 ) {
          $keys_sites = array_keys($user_sites);
          foreach($keys_sites as $value) {
               $site_code = $value;
          }

     }
     echo "</center>";
}

function top10A() {   #ALLTIME HIGH
   global $allRanges, $sitename, $username, $dbconn;

    echo "<h2><i>Top 10 Vulnerabilities</i></h2>";
    echo "Sorted by Nessus Risk<hr>";

    // set up the user restrictions based on rights
    $whereclause_user = " and t2.username = '$username'";
    if($uroles['admin'] || $uroles['reports']) {
       $whereclause_user = "";
    }

    // generate the necessary SQL to limit results based on daterange
    if(is_numeric($daterange)) {
       $dsql = "and TO_DAYS(NOW()) - TO_DAYS(t2.scantime) < $daterange";
    } else {
       $dsql = "";
    }


    // draw the pulldown for the date ranges
    echo "<form name='drange' action='" . $_SERVER['PHP_SELF'] . "' method='GET'>";
    echo "<select name='daterange' onChange='drange.submit();'>";

    foreach($allRanges as $key=>$desc) {
       $sel = "";
       if($daterange == $key) { $sel = "selected"; }
       echo "<option value='$key' $sel>$desc</option>\n";
    }

    echo "</select></form>";

    // get the risks
    $query = "select distinct risk 
          from nessus_results t1
          Left join nessus_reports t2 on t1.report_id = t2.report_id
          where t1.scriptid <> '' $whereclause_user 
             and t1.falsepositive<>'Y' and t1.msg<>'' 
             and t1.scriptid <>10180 
             $dsql
          order by t1.risk";
    $result=$dbconn->execute($query);

    while(!$result->EOF) {
        list ($riskval)= $result->fields;

        //   echo $riskval."<br>";

        $query1="select count(t1.scriptid) as vcount, t1.scriptid, t3.name  
             from nessus_results t1
             left join nessus_reports t2 on t1.report_id = t2.report_id 
             left join plugins t3 on t1.scriptid = t3.id 
             where t1.scriptid <> '' 
                  and t1.risk = $riskval 
                  $whereclause_user 
                  and t1.falsepositive<>'Y' 
                  and t1.scriptid <>10180  
                  $dsql
             group by t1.scriptid 
             order by vcount desc 
             limit 0,10";
        $result1=$dbconn->execute($query1);

        echo "<br><b><u>".getrisk($riskval)."</u></b><br>";

        echo "<table summary=\"".getrisk($riskval)."\" width='100%'>
            <tr><td width='15%'>ID</td><td width='60%'>Name</td><td>Count</td></tr>";
        while(!$result1->EOF) {
            list ($vcount, $vscriptid, $vname)=$result1->fields;

            echo <<<EOT
<tr>
   <td><a href="lookup.php?disp=details&id=$vscriptid">$vscriptid</a></td>
   <td><a href="lookup.php?disp=details&id=$vscriptid">$vname</a></td>
   <td>$vcount</td>
</tr>
EOT;

            $result1->MoveNext();
        }
        echo "</table>";

        $result->MoveNext();
    } //End of while

}

function top10C() {      #CURRENT TOP 10 (BASED ON MOST RECENT SCAN OF SUBNET
   global $sitename, $username, $site_code, $user_sites, $uroles, $dbconn;

   navbar ();

   echo <<<EOT
<h2><i>
      <font face="Verdana" color="#6797BF">Top 10 Vulnerabilities - Most Recent Scan</font>
      </i></h2>By Nessus Risk
EOT;

   $vsite_sql = "";
   if ( $site_code ) { $vsite_sql = "t1.ORG = '$site_code' AND "; }

   $arrRisks = array("1", "2", "3", "6");
      #AND username='$username' 
   #$result = $db->sql_query($sql);

   #while($row = $db->sql_fetchrow($result)) {
   foreach ( $arrRisks as $riskval ) {

      $query_risks="SELECT t4.Name, count( t3.scriptid ) AS vcount, t3.scriptid
        FROM I3_subnets t1
          LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
           ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
	      LEFT JOIN nessus_results t3 ON t2.report_id = t3.report_id
    	  LEFT JOIN plugins AS t4 ON t4.id = t3.scriptid
      	WHERE $vsite_sql t1.status != 'available' and t1.serial_flag='N' AND 
          t3.risk = $riskval AND t3.scriptid <> '' AND t3.falsepositive <> 'Y'
          AND t3.scriptid <>10180
      GROUP BY t3.scriptid
      ORDER BY vcount DESC 
      LIMIT 0 , 10";

       $result = $dbconn->execute($query_risks);

        echo "<br><b><u>".getrisk($riskval)."</u></b><br>";
        echo "<table summary=\"".getrisk($riskval)."\" width='100%'>
            <tr><td width='15%'>ID</td><td width='60%'>Name</td><td>Count</td></tr>";

         while(!$result->EOF) {
            list ($vname, $vcount, $vscriptid )=$result->fields;

         echo <<<EOT
<tr>
<td><a href="lookup.php?disp=details&id=$vscriptid">$vscriptid</a></td>
<td><a href="lookup.php?disp=details&id=$vscriptid">$vname</a></td>
<td><a href="lookup.php?disp=scriptid&id=$vscriptid">$vcount</a></td></tr>
EOT;

            $result->MoveNext();
      }
      echo "</table>";

   } //Endo fo While
   
}

function allC() {      #CURRENT TOP 10 (BASED ON MOST RECENT SCAN OF SUBNET
   global $sitename, $username, $user_sites, $uroles, $dbconn;

   echo <<<EOT
<h2><i>
      <font face="Verdana" color="#6797BF">All Vulnerabilities Current Subnet Scans</font>
      </i></h2>
EOT;

   $vsite_sql = "";
   if ( ! $uroles['reports'] ) {
      if ( count( $user_sites ) == 1 ) {
         $keys_sites = array_keys($user_sites);
         foreach($keys_sites as $value) {
            $site_code = $value;
         }
      }
      if ( $site_code ) { $vsite_sql = "t1.ORG = '$site_code' AND "; }
   }

   $query_risks="SELECT t4.Name, count( t3.scriptid ) AS vcount, t3.scriptid, t3.risk, t5.created 
        FROM I3_subnets t1
          LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name AND 
           ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
	      LEFT JOIN nessus_results t3 ON t2.report_id = t3.report_id
    	  LEFT JOIN plugins AS t4 ON t4.id = t3.scriptid
    	  LEFT JOIN nessus_plugins AS t5 ON t5.id = t3.scriptid
      	WHERE $vsite_sql t1.status != 'available' and t1.serial_flag='N' AND 
          t3.scriptid <> '' AND t3.falsepositive <> 'Y' 
          AND t3.scriptid <>10180
      GROUP BY t3.scriptid
      ORDER BY risk, vcount DESC";

       $result = $dbconn->execute($query_risks);

        echo "<table summary=\"\" width='100%'>
            <tr><td>Risk</td><td width='15%'>ID</td><td width='60%'>Name</td><td>Count</td><td>Vuln Age</td></tr>";

        $curtime = gen_strtotime("now", "");
         while(!$result->EOF) {
            list ($vname, $vcount, $vscriptid, $risk, $plugin_created )=$result->fields;

            $risk_val = getrisk($risk);
            $plugin_created = gen_strtotime($plugin_created);
            $plugin_age = datediff ( "d", $curtime, $plugin_created );

         echo <<<EOT
<tr>
<td>$risk_val</td>
<td><a href="lookup.php?disp=details&id=$vscriptid">$vscriptid</a></td>
<td><a href="lookup.php?disp=details&id=$vscriptid">$vname</a></td>
<td><a href="lookup.php?disp=scriptids&id=$vscriptid">$vcount</a></td><td>$plugin_age</td></tr>
EOT;

            $result->MoveNext();
      }
      echo "</table>";
}


switch($disp) {

   case "alltime":
      top10A();
      break;

   case "allcurrent":
      allC();
      break;

   case "current":
      top10C();
      break;

   default:
      top10C();
      break;
}

require_once('footer.php');

?>
