<?php 

$pageTitle = "Vulnerability Trend by Subnet";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
#require_once('header2.php');
//require_once('permissions.inc.php');

include ( "jpgraph/jpgraph.php"); 
include ("jpgraph/jpgraph_line.php"); 

$getParams = array( "subnet" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp = ""; 
      }
   }
   break;
}


$query = "SELECT UNIX_TIMESTAMP(t1.scantime), t2.vSerious, t2.vHigh, t2.vMed, t2.vLow FROM nessus_reports t1
LEFT JOIN nessus_report_stats t2 on t1.report_id = t2.report_id 
WHERE t1.fk_name='$subnet'";

$result = $dbconn->execute($query);

while ($row = $result->fields) {
	$arrScantime[] = date("m.d.y", $row[0] );
	$arrSerious[] = $row[1];
	$arrHigh[] = $row[2];
	$arrMedium[] = $row[3];
	$arrLow[] = $row[4];
	$result->MoveNext();
}


$arrScantime[] = date("m.d.y"); 
$arrSerious[] = end( $arrSerious );
$arrHigh[] = end( $arrHigh );
$arrMedium[] = end( $arrMedium );
$arrLow[] = end ( $arrLow );
	


#$ydata = array($serious);
#$y2data = array(354,200,265,99,111,91,198,225,293,251);

// Create the graph and specify the scale for both Y-axis
$graph = new Graph(800,600,"auto");    
$graph->SetScale("textlin");
$graph->SetShadow();

// Adjust the margin
$graph->img->SetMargin(40,40,20,90);

// Create the two linear plot

// Adjust the axis color
$graph->yaxis->SetColor("blue");

$graph->title->Set("TREND PLOT for subnet [ $subnet ]");
$graph->xaxis->title->Set("ScanTime");
$graph->yaxis->title->Set("Vulnerabilities");
$graph->xaxis-> SetTickLabels( $arrScantime ); 


$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

// Set the colors for the plots 
$lnSerious=new LinePlot($arrSerious);
$lnSerious->SetStepStyle();
$lnSerious->SetColor("red");
$lnSerious->SetWeight(2);
$lnSerious->SetLegend("Serious");
$graph->Add($lnSerious);

$lnHigh=new LinePlot($arrHigh);
$lnHigh->SetStepStyle();
$lnHigh->SetColor("orange");
$lnHigh->SetWeight(2);
$lnHigh->SetLegend("High");
$graph->Add($lnHigh);

$lnMedium=new LinePlot($arrMedium);
$lnMedium->SetStepStyle();
$lnMedium->SetColor("yellow");
$lnMedium->SetWeight(2);
$lnMedium->SetLegend("Medium");
$graph->Add($lnMedium);

$lnLow=new LinePlot($arrLow);
$lnLow->SetStepStyle();
$lnLow->SetColor("green");
$lnLow->SetWeight(2);
$lnLow->SetLegend("Low");
$graph->Add($lnLow);







// Adjust the legend position
$graph->legend->SetLayout(LEGEND_HOR);
$graph->legend->Pos(0.4,0.95,"center","bottom");

// Display the graph
$graph->Stroke();
?>