<?php
//
// $Id: zones.php,v 1.7 2006/08/10 17:19:33 airwofl Exp $
//

$pageTitle = "Network Zones";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$netedit="";

$getParams = array( "disp", "item", "op", "zid", "netid", "nid", "uid", "confirm" );
$postParams = array( "disp", "item", "op", "zname", "zdescription", "zid", 
			"range_start", "range_end", "netid", "submit" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
       if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
      } else { 
         $$gp="";
      }
   }
    $range_start="";
    $range_end="";
    break;
case "POST" :
   foreach($postParams as $pp) {
       if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else { 
         $$pp="";
      }
   }
    break;
}

   if(isset($_POST['auth_servers'])) {
      foreach($_POST['auth_servers'] as $server) {
         $zoneservers[] = htmlspecialchars(mysql_real_escape_string(trim($server)), ENT_QUOTES); 
      }
   }

if(isset($_POST['authorized_users'])) {
   foreach($_POST['authorized_users'] as $user) {
      $users[] = htmlspecialchars(mysql_real_escape_string(trim($user)), ENT_QUOTES); 
   }
}

//$allowedAccess = (strpos($_SESSION['roles'],"zones") === false) ? FALSE : TRUE;

if (!$uroles['zones']) {
   echo "Access Denied!!!<br>";
   logAccess( "ACCESS DENIED TO ZONES" );
   require_once('footer.php');
   die();
} 

function navbar ( $zid ) {
    global $dbconn;

    echo <<<EOT
<center><h3>Manage Nessus Scan Zones</h3>
[ <a href="zones.php">Main</a> ]
EOT;
    if ($zid) {

        $query = "SELECT name FROM nessus_zones WHERE id='$zid'";
        $result = $dbconn->execute($query);
        list( $zonename ) = $result->fields;

        echo <<<EOT
 -> Edit Zone [ <font color=red>$zonename</font> ] (
<a href="zones.php?disp=info&zid=$zid">OVERVIEW</a>
| <a href="zones.php?disp=editname&zid=$zid">NAME</a>
| <a href="zones.php?disp=editrange&zid=$zid">IP RANGE</a>
| <a href="zones.php?disp=editservers&zid=$zid">SERVERS</a>
| <a href="zones.php?disp=editusers&zid=$zid">USERS</a> )
EOT;

    }
echo "</center><br>";

}

function add_zone() {
    global $module_name, $username, $dbconn;

    navbar ( '' );

    echo <<<EOT
<b>Add New Network Zone</b><br><form method="POST" action="zones.php">
<input type="hidden" name="disp" value="save_zone">
<table>
<tr><td>Zone Name:</td>
<td><input type="text" name="zname" value=""><td>
</tr>
<tr><td>Zone Description:</td>
<td><input type="text" name="zdescription" value=""><td>
</tr></table>
<input type="submit" name="submit" value="Add Zone">
</form>
EOT;
}

function delete_zone($zid){
    global $username, $dbconn;

    $query="select name from nessus_zones where id=$zid";
    $zname=$dbconn->getOne($query);


    $query="delete from nessus_server_zones where zoneid=$zid";
    $result=$dbconn->execute($query);
    $query="delete from nessus_user_zones where zid=$zid";
    $result=$dbconn->execute($query);
    $query="delete from nessus_zone_ranges where zoneid=$zid";
    $result=$dbconn->execute($query);

    $query="delete from nessus_zones where id=$zid";
    $result=$dbconn->execute($query);

    echo <<<EOT
<p>Zone "$zname" has been deleted</p>
<p><a href="zones.php">Edit Zones</a></p>
EOT;
    logAccess( "DELETED ZONE $zid" );

}

function edit_range($zid, $op, $netid, $range_start, $range_end){
    global $username, $dbconn;

    navbar ( $zid );

    if ($op=="delrange") {
         $query="SELECT range FROM nessus_zone_ranges WHERE id=$netid";
         $rname=$dbconn->getOne($query);
         $query="DELETE FROM nessus_zone_ranges WHERE id=$netid";
         $result=$dbconn->execute($query);
         $netid="";
         logAccess( "DELETED RANGE [ $netid ] FROM ZONE $zid" );
    }
    if ($op=="addrange") {
         if (validateip($range_start)==1 and validateip($range_end)==1) {
            if ($netid=="") {
               $query="Insert into nessus_zone_ranges ( zoneid, range_start, range_end ) values (
                   $zid, inet_aton('$range_start'), inet_aton('$range_end'))";
               $result=$dbconn->execute($query);
               logAccess( "ADDED RANGE TO ZONE $zid" );
            } elseif(is_numeric($netid)) {
               $query="UPDATE nessus_zone_ranges SET range_start=inet_aton('$range_start'),
                   range_end=inet_aton('$range_end') WHERE zoneid=$zid AND id=$netid";
               $result=$dbconn->execute($query);
               logAccess( "UPDATED RANGE [ $netid ] IN ZONE $zid" );
               $netid="";
            } else{
            echo "There was a problem with your input";
        }
         }
    }

    $query="select name from nessus_zones where owner='$username' and id=$zid";
    $result = $dbconn->execute($query);
    list($zname) = $result->fields;

    $netrange="";

    if ($netid<>"") {
        $query="select inet_ntoa(range_start), inet_ntoa(range_end) from nessus_zone_ranges 
            where zoneid=$zid and id=$netid order by range_start ASC";
        $result = $dbconn->execute($query);
        while($row = $result->fields) {
            $range_start = $row['range_start'];
            $range_end = $row['range_end'];
            $result->MoveNext();
        }
        $netedit=$netid;
        //          $query="delete from nessus_zone_ranges where id=$netid";
        //          $result = $dbconn->execute($query);
    }

    $query="Select t1.id, t1.zoneid, inet_ntoa(t1.range_start), inet_ntoa(t1.range_end) from nessus_zone_ranges as t1, 
        nessus_zones as t2 where t1.zoneid=t2.id and (t2.owner='$username' or t2.type='G') 
        and t1.zoneid=$zid order by t1.range_start";
    $result = $dbconn->execute($query);

    echo <<<EOT
<B>Zone Network Range</b><br>
<table width=100% border=1><tr><td></td><td>Network Range/IP Address</td></tr>
EOT;

    while(list($netid, $zoneid, $drange_start, $drange_end) = $result->fields) {
        echo "<tr><td><a href=\"zones.php?disp=editrange&op=delrange&netid=$netid&zid=$zid\">Del</a></td>
            <td>$drange_start-$drange_end</td></tr>";
        $result->MoveNext();
    }

    echo <<<EOT
</table><BR>
    <form method="post" action="zones.php">
        <input type="hidden" name="disp" value="editrange">
        <input type="hidden" name="zid" value="$zid">
        <input type="hidden" name="op" value="addrange">
        <input type="hidden" name="netid" value="$netid">
        Network Range/IP Address<br>
        <input type="text" name="range_start" value="$range_start"> 
        - <input type="text" name="range_end" value="$range_end"><br>
        <input type="submit" name="submit" value="Add Range">
    </form>
EOT;


}

function edit_zonename( $zid, $op ){
    global $zname, $zdescription, $username, $dbconn;

    navbar ( $zid );

    if ( $op=="save" ) {
           $query = "UPDATE nessus_zones SET name='$zname', description='$zdescription' WHERE id='$zid'";
        $result = $dbconn->execute($query);
        logAccess( "UPDATED ZONE [ $zid ] INFORMATION" );
        echo <<<EOT
Zone - $zname has been updated.</br><br>
EOT;
    } 

    //check input
    if(is_numeric($zid)){

            $query = "SELECT name, description FROM nessus_zones WHERE id=$zid";
            $result = $dbconn->execute($query);

            list($zname,$zdescription) = $result->fields;

        echo <<<EOT

<B>Edit Zone</B><br>
<br><form method="POST" action="zones.php">
<input type="hidden" name="disp" value="editname">
<input type="hidden" name="op" value="save">
<input type="hidden" name="zid" value="$zid">
<table>
    <tr><td>Name</td>
        <td><input type="text" name="zname" value="$zname"></td>
    </tr>
    <tr><td>Description</td>
        <td><input type="text" name="zdescription" value="$zdescription"></td>
    </tr>
</table>
<input type="submit" name="submit" value="Save">
EOT;
    } else{
        echo "It was a problem accessing the data!";
    }


}

function save_zone($zonename, $zonedescription){
    global $username, $dbconn;

    $flag=1;
    $problemtext="";

    if($zonename==""){
        $flag=0;
        $problemtext="Zone name can not be blank<br />";
    }

    //check for duplicates
    $query="SELECT count(*) FROM nessus_zones WHERE name='$zonename'";
    $result = $dbconn->execute($query);
    list($iszonefound) = $result->fields;

    if($iszonefound>0){
        $flag=0;
        $problemtext.="Zone '$zonename' already exist in the database<br />";
    }

    if($flag==1){
        $query="INSERT into nessus_zones ( name, description, owner ) VALUES (
            '$zonename', '$zonedescription', '$username')";
        $result=$dbconn->execute($query);

        // removed owner check - hsh
       //$query="SELECT id from nessus_zones where name = '$zonename' and owner = '$username'";
       $query="SELECT id from nessus_zones where name = '$zonename'";
       $result=$dbconn->execute($query);
       list ($zid)=$result->fields;

       $query="insert into nessus_user_zones (zid, username) values ($zid, '$username')";
       $result=$dbconn->execute($query);
       logAccess( "CREATED NEW ZONE [ $zid ]" );

       echo <<<EOT
Zone added<br />
<p></p>
EOT;
    } else {
       echo "There was a problem creating a new zone, please review details below:<br />$problemtext";
       logAccess( "FAILED TO CREATE NEW ZONE: $problemtext" );
    }

    show_zones( $zid );

}

function show_zones( $zid ) {
    global $uroles, $enableManZones, $username, $dbconn;

    navbar ( $zid );

    $query = "SELECT id, name, description, TYPE, owner FROM nessus_zones 
        WHERE owner='$username' or type='G'";

    $result = $dbconn->execute($query);

    echo <<<EOT
<B>Manage Network Zones</B><BR>
<table border=1 ><tr><td>Zone Name</td><td>Zone Description</td>
EOT;
	if ( $enableManZones ) {
		echo "<td>&nbsp;</td>";
	}
    echo <<<EOT
</tr>
EOT;
    while (!$result->EOF) {
        list( $zoneid, $zonename, $zonedescription, $zonetype, $zoneowner ) = $result->fields;
        echo <<<EOT
<tr>
    <td>$zonename</td><td>$zonedescription</td>
EOT;

        if ( $enableManZones ) {
        	echo <<<EOT
    <td><A href="zones.php?disp=info&zid=$zoneid"><img src="images/zoom.png"></A>&nbsp;
        <A href="zones.php?disp=editname&zid=$zoneid"><img src="images/pencil.png"></A>&nbsp;
        <A href="zones.php?disp=delete&zid=$zoneid" onclick="return confirmDelete();"><img src="images/delete.png"></A></td>
EOT;

        }
        echo <<<EOT
</tr>
EOT;
        $result->MoveNext();
    }

   if ( $enableManZones && $uroles['zones'] ) {
   	  echo <<<EOT
</table><a href="zones.php?disp=add">Add new zone</A>
EOT;
   }
}

function manage_zone_servers($zid) {
    global $dbconn;

    navbar ( $zid );

    $query = "SELECT name FROM nessus_zones WHERE id='$zid'";
    $result = $dbconn->execute($query);
    list($zonename) = $result->fields;
    logAccess( "MANAGE ZONE SERVERS FOR ZONE [ $zonename ]" );
    echo <<<EOT
<br>
<form action="/zones.php" method="POST" onSubmit="selectAllOptions('auth_servers');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4>Zone "$zonename" Access:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Authorized<br>
        <input type="hidden" name="disp" value="updateservers">
        <input type="hidden" name="zid" value="$zid">
    <select name="auth_servers[]" id="auth_servers" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;

    $query = "SELECT nessus_servers.id, nessus_servers.name FROM nessus_server_zones
        LEFT JOIN nessus_servers ON nessus_server_zones.nessusid = nessus_servers.id
        WHERE nessus_server_zones.zoneid = '$zid'";
    $result = $dbconn->execute($query);

    while (!$result->EOF) {
        list($nid, $nname) = $result->fields;
        echo "<OPTION value=\"$nid\">$nname</OPTION>\n";
        $result->MoveNext();
    }

     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.available_servers,this.form.auth_servers)"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.auth_servers,this.form.available_servers)"></td>
     <td valign=top align="left">Available<br>
          <select name="all_available_servers[]" id="available_servers" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;

    $query = "SELECT nessus_servers.id, nessus_servers.name 
        FROM nessus_servers
        LEFT JOIN nessus_server_zones ON nessus_servers.id = nessus_server_zones.nessusid
        AND nessus_server_zones.zoneid = '$zid'
        WHERE nessus_server_zones.nessusid is Null";


    $result = $dbconn->execute($query);

    while(list($nid, $nname) = $result->fields) {
        echo "<OPTION value=\"$nid\" >$nname</OPTION>\n";
        $result->MoveNext();
    }


     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Servers'></input></td></tr>
</TABLE></form>
EOT;

}

function manage_zone_users($zid) {
    global $module_name, $dbconn;

    navbar ( $zid );

    $query = "SELECT name FROM nessus_zones WHERE id='$zid'";
    $result = $dbconn->execute($query);
    list($zonename) = $result->fields;

    logAccess( "MANAGE ZONE USERS FOR ZONE [ $zonename ]" );
    echo <<<EOT
<br>
<form action="/zones.php" method="POST" onSubmit="selectAllOptions('authorized');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4>Zone "$zonename" Access:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Authorized Users<br>
        <input type="hidden" name="disp" value="setusers">
        <input type="hidden" name="zid" value="$zid">
    <select name="authorized_users[]" id="authorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;
        $query = "SELECT username FROM nessus_user_zones WHERE zid = '$zid'";
        $result = $dbconn->execute($query);

        while(list($nuname) = $result->fields) {
            echo "<OPTION value=\"$nuname\">$nuname</OPTION>\n";
            $result->MoveNext();
        }
     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.unauthorized,this.form.authorized )"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.authorized,this.form.unauthorized)"></td>
     <td valign=top align="left">
          <select name="unauth_users[]" id="unauthorized" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;

        $query = "SELECT users.pn_uname
            FROM users
            LEFT JOIN nessus_user_zones ON users.pn_uname = nessus_user_zones.username
                AND nessus_user_zones.zid = '$zid'
            WHERE nessus_user_zones.username is Null ORDER BY users.pn_uname";
        $result = $dbconn->execute($query);

        while(list($nuname) = $result->fields) {
            echo "<OPTION value=\"$nuname\" >$nuname</OPTION>\n";
            $result->MoveNext();
        }

     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Access'></input></td></tr>
</TABLE></form>
EOT;

}

function update_zone_servers( $zid, $zoneservers ) {
    global $username, $sitename, $dbconn;

    if ( $zid ) {
        $query = "DELETE FROM nessus_server_zones WHERE zoneid='$zid'";
        $result = $dbconn->execute($query);
    }

    if ( $zid && $zoneservers ) {

        $query = "SELECT name FROM nessus_zones WHERE id='$zid'";
        $result = $dbconn->execute($query);
        list($name) = $result->fields;
        echo "UPDATING SERVERS FOR ZONE: [$name]<br>";
        logAccess( "UPDATING SERVERS FOR ZONE [ $name ]" );

        foreach( $zoneservers as $nserver ) {

            if ( $nserver ) {
                $query = "INSERT INTO nessus_server_zones (zoneid, nessusid) VALUES ('$zid', '$nserver' );";
                $result = $dbconn->execute($query);
                #echo "sql=$query<br>";
                #echo "inserting server=$nserver    zid=$zid<br>";
            }
        }
    }

    echo "<br>";

    manage_zone_servers($zid);
}

function update_zone_users( $zid, $users ) {
    global $module_name, $sitename, $dbconn;

    if ( $zid ) {
        $query = "DELETE FROM nessus_user_zones WHERE zid='$zid'";
        $result = $dbconn->execute($query);
    }

    if ( $zid && $users ) {

        $query = "SELECT name FROM nessus_zones WHERE id='$zid'";
        $result = $dbconn->execute($query);
        list($name) = $result->fields;
        echo "UPDATING USERS FOR ZONE: [$name]<br>";
        logAccess( "UPDATING USERS FOR ZONE [ $name ]" );

        foreach( $users as $nuser ) {

            if ($nuser) {
                $query = "INSERT INTO nessus_user_zones (username, zid) 
                    VALUES ('$nuser', $zid );";
                $result = $dbconn->execute($query);
                #echo "sql=$query<br>";
                #echo "inserting username=$nuser    zid=$zid<br>";
            }
        }
    }
    echo "<br>";

    manage_zone_users($zid);
}

function zone_overview($zid) {
    global $username, $dbconn;

    navbar ( $zid );

    $query = "SELECT name, description FROM nessus_zones WHERE id='$zid'";
    $result = $dbconn->execute($query);

    echo <<<EOT
<B>Zone Overview</B><BR><BR>
<table border=1><tr><td>Zone Name</td>
    <td>Zone Description</td></tr>
EOT;

    while (!$result->EOF) {
        list($zonename, $zonedescription ) = $result->fields;
        echo "<tr>
        <td>$zonename</td>
        <td>$zonedescription</td></tr>";
        $result->MoveNext();
    }

    echo "</table><BR><BR>";

    $query="Select t1.id, t1.zoneid, inet_ntoa(t1.range_start), inet_ntoa(t1.range_end) from nessus_zone_ranges as t1, 
        nessus_zones as t2 where t1.zoneid=t2.id and (t2.owner='$username' or t2.type='G') 
        and t1.zoneid=$zid order by t1.range_start";
    $result = $dbconn->execute($query);

    echo "<table border=1><tr><td>Network Range/IP Address</td></tr>";

    while (!$result->EOF) {
        list($netid, $zoneid, $drange_start, $drange_end) = $result->fields;
        echo "<tr><td>$drange_start-$drange_end</td></tr>";
        $result->MoveNext();
    }

    echo "</table><BR><BR>";

    $query = "SELECT nessus_servers.id, nessus_servers.name FROM nessus_server_zones
        LEFT JOIN nessus_servers ON nessus_server_zones.nessusid = nessus_servers.id
        WHERE nessus_server_zones.zoneid = '$zid'";
    $result = $dbconn->execute($query);

    echo "<table border=1><tr><td>Zone Servers</td></tr>";
    while (!$result->EOF) {
        list($nid, $nname) = $result->fields;
        echo "<tr><td>$nname</td></tr>";
        $result->MoveNext();
    }
    echo "</table><BR><BR>";

    $query = "SELECT username FROM nessus_user_zones WHERE zid = '$zid'";

    $result = $dbconn->execute($query);

    echo "<table border=1><tr><td>Zone Users</td></tr>";
    while (!$result->EOF) {
        list($nname) = $result->fields;
        echo "<tr><td>$nname</td></tr>";
        $result->MoveNext();
    }
    echo "</table><BR><BR>";

}

switch($disp) {

    case "add":
        add_zone();
        break;

    case "delete":
        delete_zone($zid );
        break;

    case "editrange":
        edit_range($zid, $op, $netid, $range_start, $range_end);
        break;

    case "editname":
        edit_zonename($zid, $op );
        break;

    case "editusers":
        manage_zone_users($zid);
        break;

    case "editservers":
        manage_zone_servers($zid);
        break;

    case "info":
        zone_overview($zid);
        break;

    case "save_zone":
        save_zone($zname, $zdescription);
        break;

    case "setusers":
        update_zone_users( $zid, $users );
        break;

    case "updateservers":
        update_zone_servers( $zid, $zoneservers );
        break;

    default:
        show_zones('');
        break;

}


?>
