

UPDATE `inprotect_settings` SET `settingSection` = 'Subnets' WHERE settingName='enableADSubs' LIMIT 1 ;
UPDATE `inprotect_settings` SET `settingSection` = 'Subnets' WHERE settingName='baselineNewSubnet' LIMIT 1 ;
UPDATE `inprotect_settings` SET `settingSection` = 'Subnets' WHERE settingName='credAudit' LIMIT 1 ;
UPDATE `inprotect_settings` SET `settingSection` = 'Subnets' WHERE settingName='defaultVSet' LIMIT 1 ;

ALTER TABLE `I3_ISVM` ADD `topic` VARCHAR( 100 ) NOT NULL AFTER `name` ,
ADD `priority` VARCHAR( 25 ) NOT NULL DEFAULT 'High' AFTER `topic` ,
ADD `cve_ids` TEXT NOT NULL AFTER `priority` ,
ADD `soft_affected` TEXT NOT NULL AFTER `cve_ids` ;

ALTER TABLE `I3_ISVM` ADD `req_ack` ENUM( '0', '1' ) NOT NULL DEFAULT '1' AFTER `isvm_LINK` ,
ADD `req_comp` ENUM( '0', '1' ) NOT NULL DEFAULT '1' AFTER `req_ack` ;

ALTER TABLE `I3_ISVM` ADD `rev_summary` VARCHAR( 100 ) NOT NULL AFTER `dt_complied` ,
ADD `overview` TEXT NOT NULL AFTER `rev_summary` ,
ADD `action` TEXT NOT NULL AFTER `overview` ,
ADD `disclaimer` TEXT NOT NULL AFTER `action` ,
ADD `notice_sent` ENUM( '0', '1' ) NOT NULL DEFAULT '0' AFTER `disclaimer` ;


UPDATE inprotect_settings SET settingValue='1.00.0_alpha_19' WHERE settingName='version';

