<?php
//
// $Id: sched.php,v 1.14 2006/09/21 12:34:35 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Nessus Scan Schedule";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('Crypt/CBC.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$myhostname="";

$getParams = array( 'disp', 'op', 'rid', 'sname', 'notify_email', 'tarSel', 'ip_list', 'ip_start', 
                     'ip_end', 'named_list', 'subnets',  'schedule_type', 'cred_type'
                   );


$postParams = array( 'disp','op', 'rid', 'sname', 'notify_email', 'schedule_type', 'ROYEAR', 'ROMONTH', 'ROday',
                     'time_hour', 'time_min', 'week_days', 'dayofmonth', 'timeout', 'SVRid',
                     'sid', 'tarSel', 'ip_list', 'ip_start', 'ip_end', 'named_list', 'subnet',
                     'cred_type', 'credid', 'smbacc', 'smbdomain', 'smbpass', 'passtype', 'passstore'
                   );


$schedOptions = array(      "N" => "Immediately",
                     "O" => "Run Once", 
                     "D" => "Daily", 
                     "W" => "Weekly", 
                     "M" => "Monthly" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         if(is_array($_GET[$gp])) {
            foreach ($_GET[$gp] as $i=>$tmp) {
               ${$gp}[$i] = sanitize($tmp);
            }
         } else {
            $$gp = sanitize($_GET[$gp]);
         }
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         if(is_array($_POST[$pp])) {
            foreach($_POST[$pp] as $i=>$tmp) {
               ${$pp}[$i] = sanitize($tmp);
//echo $pp . "[" . $i . "] = " . $$pp[$i] . "<br>";
            }
         } else {
            $$pp = sanitize($_POST[$pp]);
//echo $pp . " = " . $$pp . "<br>";
         }
      } else { 
         $$pp=""; 
      }
//echo $pp . " = " . $$pp . "<Br>";
   }
   break;
}

function main_page($op){
   global $profileid, $timeout, $uroles, $username, $useremail, $dbconn;

     echo <<<EOT
     <ul id="countrytabs" class="shadetabs">
     <li><a href="#" rel="hosts" class="selected">Host</a></li>
     <li><a href="#" rel="subnets">Subnet Health</a></li>
     <li><a href="#" rel="systems">System</a></li>
     <li><a href="#" rel="queue">Scan Queue</a></li>
     <li><a href="#" rel="recent">Recent Jobs</a></li>
     </ul>
     <br>
     <div id="content" style="WIDTH: 1000px; HEIGHT: 390px">

     <div id="hosts" class="tabcontent" align="top" >
EOT;
     tab_hosts();

echo <<<EOT

     </div>
     <div id="subnets" class="tabcontent">
EOT;
     tab_subnets();
echo <<<EOT
     </div>
     <div id="systems" class="tabcontent">
EOT;
     tab_systems();
echo <<<EOT

     </div>
     <div id="queue" class="tabcontent">
EOT;
     tab_queue();
echo <<<EOT

     </div>
     <div id="recent" class="tabcontent">
EOT;
     tab_recent();

echo <<<EOT
     </div>
     <script type="text/javascript">

          var countries=new ddtabcontent("countrytabs")
          countries.setpersist(true)
          countries.setselectedClassTarget("link") //"link" or "linkparent"
          countries.init()

     </script>

EOT;

   require_once("footer.php");

}

function tab_hosts () {
   global $useremail, $dbconn;

     echo <<<EOT
<table style="WIDTH: 1000px; HEIGHT: 390px"><tr valign="top"><td>
</tr></td></table>
EOT;

}

function tab_subnets () {
   global $useremail, $dbconn;

     echo <<<EOT
<table style="WIDTH: 1000px; HEIGHT: 390px"><tr valign="top"><td>
</tr></td></table>
EOT;

}

function tab_systems () {
   global $useremail, $dbconn;

     echo <<<EOT
<table style="WIDTH: 1000px; HEIGHT: 390px"><tr valign="top"><td>
</tr></td></table>
EOT;

}

function tab_queue () {
   global $useremail, $dbconn;

     echo <<<EOT
<table style="WIDTH: 1000px; HEIGHT: 390px"><tr valign="top"><td>
</tr></td></table>
EOT;

}

function tab_recent () {
   global $useremail, $dbconn;

     echo <<<EOT
<table style="WIDTH: 1000px; HEIGHT: 390px"><tr valign="top"><td>
</tr></td></table>
EOT;

}


switch($disp) {

   default:
      main_page($op);
      break;
}

?>
