<?php
//
// $Id: lookup.php,v 1.9 2006/09/20 13:03:48 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net                        */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Lookup";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$getParams = array( "disp", "id", "op", "nid", "eventid", "site_code" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
}


function subtractTime($hours=0, $minutes=0, $seconds=0, $months=0, $days=0, $years=0) {
	$totalHours = date("H") - $hours;
	$totalMinutes = date("i") - $minutes;
	$totalSeconds = date("s") - $seconds;
	$totalMonths = date("m") - $months;
	$totalDays = date("d") - $days;
	$totalYears = date("Y") - $years;
	$timeStamp = mktime($totalHours, $totalMinutes, $totalSeconds, $totalMonths, $totalDays, $totalYears);
	$myTime = date("Y-m-d H:i:s", $timeStamp);
	return $myTime;
}


function script_details($id, $op, $nid) {
	global $enableNotes, $sitename, $username, $site_code, $user_sites, $dbconn;

if ($op=="delnote" and $nid<>"") {
    if(!is_numeric($nid)) { 
       require_once('footer.php');
       echo "Cannot access this page - nid is non numeric"; 
       die();
    }
    logAccess ( "Security violation - Requested non numeric noteid " . $nid );

    $query="delete from nessus_notes 
            where id=$nid and username='$username'";
    $result=$dbconn->execute($query);
}

$result=$dbconn->Execute("select * 
                          from plugins 
                          where ID='$id'");
list($pid, $pname, $pfamily, $pcategory, $pcopyright, $psummary, $pdescription, $pversion, $pcve_id, $pbugtraq_id)= $result->fields;

$pdescription=htmlspecialchars($pdescription, ENT_QUOTES);

echo "
<B>Nessus plugin details:</B><BR>
<B>ID:</B> $pid<BR><BR>
<B>Name:</B> $pname<BR><BR>
<B>Family:</B> $pfamily<BR><BR>
<B>Category:</B> $pcategory<BR><BR>
<B>Copyright:</B> $pcopyright<BR><BR>
<B>Summary:</B> $psummary<BR><BR>
<B>Description:</B> ".preg_replace("/\n/","<br>",$pdescription)."<BR><BR>
<B>Version:</B> $pversion<BR><BR>
<B>CVE IDs: </B>";
$CVEs = preg_split ("/[\s,]+/", $pcve_id);
foreach($CVEs as $CVE){
   echo"<a href=\"http://cve.mitre.org/cgi-bin/cvename.cgi?name=$CVE\">$CVE</a> ";
}
$Bugtraqs = preg_split ("/[\s,]+/", $pbugtraq_id);
echo"<br/><B>Bugtraq IDs: </B>";
foreach($Bugtraqs as $Bugtraq){
   echo"<a href=\"http://www.securityfocus.com/bid/$Bugtraq\">$Bugtraq</a>  ";
}

$result->Close();
echo <<<EOT
<BR/><BR/>
<B>
<a href="search.php?plugin=$id&amp;showInfo=true&amp;submit=Search">
<img alt="View Systems with this vulnerability" src="images/info.png" border=0>
&nbsp;&nbsp;
View Systems with this vulnerability</A>
</b>
<BR><BR>
EOT;
   if($enableNotes) {
      echo '<font color="red"><B>Notes:</B></font><BR>';

      $query = "select id, note 
             from nessus_notes 
             where username='$username' and pid=$id";
      $result=$dbconn->execute($query);
      while (!$result->EOF) {
         list($nid, $note)=$result->fields;
         echo <<<EOT
<hr><a href="lookup.php?op=delnote&amp;nid=$nid&amp;id=$id">
<img alt="Delete Note" src="images/false.png" border=0></a>&nbsp;&nbsp;$note<BR>
EOT;
          $result->MoveNext();
      }

      echo <<<EOT
<BR>
<a href="notes.php?op=add&amp;pid=$id&httpfrom=lookup">
<img alt="Add a Custom Note" src="images/note.png" border=0>
&nbsp;&nbsp;Add a Custom Note</a></font>
EOT;
   }
}

function script_id( $id, $lookup, $details ) {
	global $uroles, $site_code, $user_sites, $sitename, $dbconn;

	$query_filter = "";
	if ( ! $uroles['reports'] || $site_code ) {
		if ( count( $user_sites ) == 1 ) {
			$keys_sites = array_keys($user_sites);
    	
			foreach($keys_sites as $value) {
				$site_code = $value;
			}
		}
		if ( $site_code ) { $query_filter = "t1.ORG = '$site_code' AND "; }
	}
	
	if ( $lookup == "byincident" ) {
		$query = "SELECT t1.site_code, t1.ORG, t1.hostip, t1.hostname, t1.lastscandate, t2.service, t2.risk, t2.msg
			FROM hosts t1
			LEFT JOIN I3_Incidents t2 ON t1.id = t2.host_id
			WHERE $query_filter  t2.status != 'resolved' AND t2.scriptid='$id' 
			GROUP BY t2.host_id ORDER BY t1.site_code";	
	}elseif ( $lookup == "byage" ) {
		subtractTime($hours=0, $minutes=0, $seconds=0, $months=0, $days=0, $years=0);
		$query = "SELECT t1.site_code, t1.ORG, t1.hostip, t1.hostname, t1.lastscandate, t2.service, t2.risk, t2.msg
			FROM hosts t1
			LEFT JOIN I3_Incidents t2 ON t1.id = t2.host_id
			WHERE $query_filter  t2.status != 'resolved' AND t2.scriptid='$id' 
			GROUP BY t2.host_id ORDER BY t1.site_code";	
			
	} else {
		$query = "SELECT t1.site_code, t1.ORG, t3.hostip, t3.hostname, t1.dtLastScanned, t3.service, t3.risk, t3.msg
			FROM I3_subnets t1
			LEFT JOIN I3_jobs t2 ON t1.CIDR = t2.fk_name
				AND ( t2.scan_SUBMIT >= t1.dtLastScanned OR t1.report_id = t2.report_id )
			LEFT JOIN nessus_results t3 ON t2.report_id = t3.report_id
			WHERE $query_filter  t1.status != 'available' and t1.serial_flag='N' AND
			t3.scriptid='$id' GROUP BY t3.hostip ORDER BY t1.site_code";
	}
	#echo "query=$query<br>";
	$result = $dbconn->execute($query);

	
	#ECHO "sql=$query<br>";
	
	
	echo "<table summary=\"Plugin Matches [ <font color=red>$pid</a> ]\" border=\"1\" width=\"100%\">";
	
	
	if ( $details == "1" ) {
		echo "<tr><td colspan=4><h4>Vulnerabilities found:</h4></tr>
		<tr>
			<td><font face=\"Verdana\" color=\"#666666\" size=\"4\"><b>Host&nbsp;&nbsp;</b></font></td>
      		<td><font face=\"Verdana\" color=\"#666666\" size=\"4\"><b>Severity&nbsp;&nbsp;</b></font></td>
      		<td><font face=\"Verdana\" color=\"#666666\" size=\"4\"><b>Description&nbsp;&nbsp;</b></font></td>
      	</tr>";
		
	} else {
		echo "<tr><td colspan=4><h4>Vulnerabilities found:</h4></tr>";
		
		
	}
	
	$htmldetails = "";
	$i = 0;
   while (!$result->EOF) {
       list( $sCODE, $sORG, $hostIP, $hostname, $lastscanned, $service, $risk, $msg)=$result->fields;		
		$i = $i += 1;
		$msg=preg_replace("/^[ \t]*/","",$msg);
        $msg=wordwrap(preg_replace("/\n/","<br>",$msg),100,"<br>",1);
        
        if ( $details == "1" ) {
        	$htmldetails .= "<tr>
			<td>$hostIP<br>$hostname</td>
      		<td>$service<br>".getrisk($risk)."</td>
      		<td>$msg</td>
      	</tr>";
        	
        } else {
        	if ( $htmldetails == "" ) {
        		$htmldetails .= "<tr><td>RISK</td><td colspan=4>".getrisk($risk)."</td></tr>
        		<tr><td>SERVICE</td><td colspan=4>$service</td></tr>
        		<tr><td>MSG</td><td colspan=4>$msg</td></tr>
				<tr><td colspan=4>&nbsp;</td></tr>
				<tr><td colspan=4><h4>VULNERABLE HOSTS</h4></td></tr>
				<tr><td colspan=4>&nbsp;</td></tr>
				<tr><td>HOSTIP</td><td>HOSTNAME</td><td>SITE</td><td>Location</td><td>LastScanned</td></tr>";
        	}
        	if ( $sCODE == $sORG ) { $sORG = ""; }; # no reason to show it twice
        	$htmldetails .= "<tr><td>[$i]&nbsp;&nbsp;$hostIP</td><td>$hostname</td>
        		<td> $sCODE</td><td>$sORG</td><td>$lastscanned</td></tr>";
        }
        $result->MoveNext();     	
	}
	
	echo $htmldetails;
	
	echo "</table>";
		
}

function result_id( $eventid ) {
     global $sitename,  $userinfo, $user_sites, $dbconn;

     $query = "SELECT hostip, hostname, service, risk, msg 
          FROM nessus_results
          WHERE result_id='$eventid' LIMIT 1";

     $result = $dbconn->execute($query);
     $numrows = $result->NumRows();

     ECHO "sql=$query<br>";

     if ($numrows < 1) {
          die ("<h3><font color=red>No Results</font></h3>");
     }

     echo "<table summary=\"Plugin Matches [ <font color=red>$pid</a> ]\" border=\"1\" width=\"100%\">";

     if ( $details == "1" ) {
          echo <<<EOT
<tr><td colspan=4><h4>Vulnerabilities found:</h4></tr>
<tr>
   <td><font face="Verdana" color="#666666" size="4"><b>Host&nbsp;&nbsp;</b></font></td>
   <td><font face="Verdana" color="#666666" size="4"><b>Severity&nbsp;&nbsp;</b></font></td>
   <td><font face="Verdana" color="#666666" size="4"><b>Description&nbsp;&nbsp;</b></font></td>
</tr>
EOT;
     } else {
          echo "<tr><td colspan=4><h4>Vulnerabilities found:</h4></tr>";
     }
     $htmldetails = "";
     $i = 0;
     while (!$result->EOF) {
          list( $hostIP, $hostname, $service, $risk, $msg)=$result->fields;	
          $i = $i += 1;
          $msg=preg_replace("/^[ \t]*/","",$msg);
          $msg=wordwrap(preg_replace("/\n/","<br>",$msg),100,"<br>",1);
          $msg=hyperlink($msg);

          if ( $details == "1" ) {
               $htmldetails .= "<tr>
   <td>$hostIP<br>$hostname</td>
   <td>$service<br>".getrisk($risk)."</td>
   <td>$msg</td>
</tr>";
          } else {
               $htmldetails .= "<tr><td>RISK</td><td colspan=4>".getrisk($risk)."</td></tr>
<tr><td>SERVICE</td><td colspan=4>$service</td></tr>
<tr><td>MSG</td><td colspan=4>$msg</td></tr>
<tr><td colspan=4>&nbsp;</td></tr>
<tr><td colspan=4><h4>VULNERABLE HOSTS</h4></td></tr>
<tr><td colspan=4>&nbsp;</td></tr>
<tr><td>HOSTIP</td><td>HOSTNAME</td><td>SITE</td><td>Location</td></tr>
<tr><td>[$i]&nbsp;&nbsp;$hostIP</td><td>$hostname</td>
   <td> $sCODE</td><td>$sORG</td></tr>";
          }
     }

     echo $htmldetails;
     echo "</table>";
}

switch($disp) {

	case "details":
	   script_details($id, $op, $nid);
	   break;
	   	
	case "result":
		result_id( $eventid );
		break;
	
	case "scriptid":
		script_id($id, $lookup, $details, $site_code );
		break;	
	
    default:
	   script_details($id, $op, $nid);
	   break;
}



include("footer.php");
?>
