<?php
//
// $Id: GetSysHealth.php,v 1.0 2007/06/15 20:14:23 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */

$pageTitle = "Dashboard";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

logAccess( "$username : " . $_SERVER['PHP_SELF']  . " : Accessed Monitor page" );

$getParams = array( "disp");

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
	   if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else {
         $$gp = "";
      }
   }
	break;
}


function monitor ( ) {
	global $disp, $dbconn;

	$url_args = "";
	if ( $disp ) {
		$url_args = "&disp=$disp";
	}
	
	echo "<script type=\"text/javascript\">

	var url = \"GetSysHealth.php\"; // The server-side script
	
	function handleHttpResponse() {	
		if (http.readyState == 4) {
			if(http.status==200) {
				var results=http.responseText;
				document.getElementById('divStatusData').innerHTML = results;
			}
  		}
	}
		
    function StatusUpdate() {      
		http.open(\"GET\", url + \"?r=\" + new Date().getTime() + \"$url_args\", true);
		http.onreadystatechange = handleHttpResponse;
		http.send(null);
		setTimeout(StatusUpdate, 5000);
    }

	function getHTTPObject() {
		var xmlhttp;
 
		if(window.XMLHttpRequest){
			xmlhttp = new XMLHttpRequest();
		} else if (window.ActiveXObject){
			xmlhttp=new ActiveXObject(\"Microsoft.XMLHTTP\");
			if (!xmlhttp){
				xmlhttp=new ActiveXObject(\"Msxml2.XMLHTTP\");
			}
		}
  
		return xmlhttp;
	}
	var http = getHTTPObject(); // We create the HTTP Object
	StatusUpdate();
	</script>";

	#header("Cache-Control: no-cache");

	echo "<h4>System Health</h4>";

	echo"
	<div id=\"divStatusData\"></div>";
	
}


switch($disp) {

	default:
	   monitor( );
	   break;
}


include ('footer.php');

?>
