<?php
//
// $Id: control.php,v 1.4 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "Dashboard";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$getParams = array( "disp", "increment", "likefilter", "page", "nid", "sortby", "site_code" );
$postParams = array( "disp", "increment", "likefilter", "page", "nid", "sortby", "site_code" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
      } else { 
         $$gp="";
      }
   }
   $range_start="";
   $range_end="";
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else { 
         $$pp="";
      }
   }
   break;
}



if ($increment == 'Previous') {
     $page = $page -1;
} elseif ($increment == 'Next') {
     $page = $page + 1;
}

if (!$page) { $page=1; }

global $uroles, $user_sites, $site_code, $likefilterm, $sortby;

$user_sites = getSiteCodes ($username);

function navbar ( ) {
     global $uroles, $user_sites, $likefilter, $site_code, $sortby, $dbconn;
     $txtselected = "";
     echo "<center><h3>SYSTEMS HEALTH</h3></center>";

     if ( $uroles['reports'] ||  $uroles['admin'] ) {
          echo <<<EOT
<table class="forumline" cellSpacing="1" cellPadding="3" border="0" width='100%'>
<form method="post" action="nessus_systems.php">
<tr><td align="Right" width="25%">Filter by System Abbrev:  </td>
<TD align=LEFT><SELECT NAME="likefilter">
<OPTION VALUE="" $txtselected ></OPTION>
EOT;
               $query = "SELECT name, acronym from I3_systems order by name";
               $result=$dbconn->Execute($query);

               while ( !$result->EOF ) {
                    list($nname, $nsystem )  = $result->fields;
                    if ( $likefilter == $nsystem ) {
                         $txtselected = "SELECTED";
                    } else {
                         $txtselected ="";
                    }
                    echo "<OPTION VALUE=\"$nsystem\" $txtselected >$nname</OPTION>\n";
                    $result->MoveNext();
               }
               echo <<<EOT
</SELECT></td></tr>
<tr><td></td><td>
<input type="submit" name="submit" value="Filter" class="mainoption"></TD>
</form></tr>
</table><br>
EOT;

     }

     echo "</center>";
}

function submit_scan ( $likefilter, $page, $nid, $sortby ) {
     global $credAudit, $username, $uroles, $dbconn;

     if( $credAudit >= "1" ) {
     	$sql_cred = "'$credAudit'";
     } else {
     	$sql_cred = "Null";
     }

     if (  $uroles['nessus'] || $uroles['selfservice'] ) {

          $query = "SELECT name, acronym, tiScanApproval, isso_email, admin_sys, admin_network from I3_systems WHERE id='$nid'";
          $result = $dbconn->Execute($query);
          list( $sysname, $acronym, $approval, $isso_poc, $poc_sa, $poc_network ) = $result->fields;

          if ( $approval ) {
               $query_time = gen_timeasstr();
               $all_pocs = $isso_poc;
               if ( $all_pocs != "" && $poc_sa != "" ) { $all_pocs .= ", $poc_sa"; }
               if ( $all_pocs != "" && $poc_network != "" ) { $all_pocs .= ", $poc_network"; }


               $query = "SELECT id from I3_jobs WHERE job_TYPE='S' and fk_name='$sysname' and status='S'";
               $result = $dbconn->execute( $query );
               list( $cronid ) = $result->fields;

               $query_time = gen_timeasstr();

               if ( $cronid ) {
                    echo "Error system already in queue - $sysname<br>";
                    logAccess( "SYSTEM ALREADY IN QUEUE: [ $sysname ]" );
               } else {

                    $query = "SELECT hostip FROM I3_system_hosts WHERE sysID='$nid'";
                    $result = $dbconn->Execute($query);

                    while ( !$result->EOF ) {
                       list($hostip, $hname) = $result->fields;
                       $ip = gethostbyname($hname);
                       if ( strlen($ip)>0) {
                          #if ( $hostip != $ip ) { $hostip=$ip; }
                       }
                       if ( strlen($hostip)>0) {
                          $host_list .= "$hostip\n";
                       }
                       $result->MoveNext();
                    }

                    $query = "INSERT INTO I3_jobs ( name, username, fk_name, job_TYPE, status, scan_SERVER, 
                  meth_SCHED, meth_TARGET, meth_CRED, meth_VSET,
                  scan_SUBMIT, scan_PRIORITY, notify, authorized, author_uname ) VALUES 
                  ( 'C&A - $sysname', '$username', '$acronym', 'S', 'S', 0,
                  'O', '$host_list', $sql_cred, '1', '$query_time', 3, '$all_pocs', '1', 'ACL'  );";
                    
                    
                    $result = $dbconn->Execute($query);
                    echo "Submitted Scan - $sysname<br>";
                    logAccess( "SYSTEM SCAN SUBMITTED: [ $sysname ]" );
               }
          } else {
               echo "System $sysname - Not approved for Scan<br>";
               logAccess( "SYSTEM SCAN: [ $sysname ] NOT APPROVED FOR SCAN" );
          }
     } else {
          echo "You are not authorized to start a scan<br>";
          logAccess( "CRON SCAN: YOU ARE NOT AUTHORIZED TO START A SCAN" );
     }

     network_status( $likefilter, $page, $sortby);

}

function network_status( $likefilter, $page, $sortby) {
     global $sitename, $adminmail, $uroles, $user_sites, $site_code, $dbconn;

     navbar ();

     $Limit=20;
     $query_order="";
     
     $master_query = "SELECT t1.id, t1.name as CIDR, t1.site_code, t1.cntHosts, t1.location, t1.tiScanApproval, 
        t3.scan_START, t3.scan_END, t3.scan_SUBMIT, t3.status, 
        t5.iHostCnt, t5.iScantime, t5.vSerious, t5.vHigh, t5.vMed, t5.vMedLow, t5.vLowMed, t5.vLow, t5.vInfo, 
        t4.results_sent, t4.report_key, t4.scantype, t1.acronym
         FROM I3_systems t1
            LEFT JOIN ( Select MAX(scan_SUBMIT) as scan_SUBMIT, fk_name
               FROM I3_jobs GROUP BY fk_name ) t2 on t1.acronym = t2.fk_name
            LEFT JOIN I3_jobs t3 on t2.fk_name = t3.fk_name AND t2.scan_SUBMIT=t3.scan_SUBMIT
            LEFT JOIN nessus_reports t4 on t3.report_id=t4.report_id 
            LEFT JOIN nessus_report_stats t5 on t3.report_id = t5.report_id 
         WHERE";


     if ( $likefilter ) { $query_like = " AND t1.acronym LIKE '%$likefilter%'"; }

     if ( $uroles['reports'] || $uroles['admin'] ) {
          if ( $site_code != "" ) {
               $query_like .= "AND t1.site_code = '$site_code'";
          } 
          $query = "SELECT count(t1.id)
               FROM I3_systems t1
               WHERE t1.status != 'available'".$query_like;
     } elseif ( $site_code == "" ) {
          #CONTACT SITE ADMIN FOR ACCOUNT SETUP
          die ( "<h3>$sitename: </h3>Please contact: &nbsp;&nbsp;<font color=red>$adminmail</font><br><br>"
               ."<b>ERROR:</b>&nbsp;<i>\"Your user account has not been associated to a Site/Region.\"</i>" );
     } else {
          $query = "SELECT count(id)
              FROM I3_systems
              WHERE site_code = '$site_code' and active = '1'";
     }

     $result = $dbconn->Execute($query);

    list( $numrec ) = $result->fields;

     if ($numrec > 0) {
          $numpages=intval($numrec/$Limit);
     } else {
          $numpages = 1;
          echo "NO Matches Search Criteriae<br><br>";
          include('footer.php');
          exit;
     }

     if ($numrec%$Limit) {
         $numpages++; // add one page if remainder
     }

     if ($page > 0) {
          $previous = $page -1;
     } else {
          $previous = -1;
     }

     if ($numpages > $page) {
          $next = $page +1;
     } else {
          $next = -1;
     }

     $offset = (($page-1) * $Limit);

     echo "<table width=\"100%\" summary=\"Search results\" 
        border=1 cellspacing=\"0\" cellpadding=\"0\" 
        style=\"border-collapse: collapse\" >";

          echo <<<EOT
<table width="100%" summary="Search results" border="1" cellspacing="0" cellpadding="0" style="border-collapse: collapse" >
<tr><td colspan="11"><h4>SYSTEM OVERVIEW</h4></td>
<form action="nessus_systems.php" method="post"> 
<INPUT TYPE=HIDDEN NAME="likefilter" VALUE="$likefilter">
<INPUT TYPE=HIDDEN NAME="sortby" VALUE="$sortby">
<INPUT TYPE=HIDDEN NAME="site_code" VALUE="$site_code">
<TD align=LEFT><SELECT NAME="page">

EOT;

         for ( $i = 1; $i <= $numpages; $i += 1) {
               if ( $i == $page ) {
                    echo "<OPTION VALUE=\"$i\" SELECTED>Page $i</OPTION>\n"; 
               } else {
                    echo "<OPTION VALUE=\"$i\">Page $i</OPTION>\n"; 
               }
          }

          echo <<<EOT
</SELECT><input type="submit" name="submit" value="Goto" class="mainoption">
</TD></form></tr>
EOT;

          if (!isset($sortby) || !is_numeric($sortby)) { $sortby=0; }
          if ($sortby==0) { $query_order.="t1.acronym, t1.parent"; }
          elseif ($sortby==1) { $query_order.="t3.scan_END DESC"; }
          elseif ($sortby==2) { $query_order.="t1.CIDR DESC"; }
          elseif ($sortby==3) { $query_order.="t1.CIDR"; }
          elseif ($sortby==4) { $query_order.="t5.iHostCnt DESC"; }
          elseif ($sortby==5) { $query_order.="t5.iHostCnt"; }
          elseif ($sortby==6) { $query_order.="date_format(t3.scan_END, \"%Y%m%d%W%T\") DESC"; }
          elseif ($sortby==7) { $query_order.="date_format(t3.scan_END, \"%Y%m%d%W%T\")"; }     
          elseif ($sortby==8) { $query_order.="round((t3.scan_END-t3.scan_START)/60)  DESC"; }
          elseif ($sortby==9) { $query_order.="round((t3.scan_END-t3.scan_START)/60) "; }
          elseif ($sortby==10) { $query_order.="t5.vSerious DESC"; }
          elseif ($sortby==11) { $query_order.="t5.vSerious"; }
          elseif ($sortby==12) { $query_order.="t5.vHigh DESC"; }
          elseif ($sortby==13) { $query_order.="t5.vHigh"; }
          elseif ($sortby==14) { $query_order.="t1.site_code DESC"; }
          elseif ($sortby==15) { $query_order.="t1.site_code"; }

          $url_sortby="<a href=\"nessus_systems.php?site_code=$site_code&sortby=";

          echo "<tr>
               <td><b>$url_sortby";

          if ($sortby==0) { echo "1"; } else { echo "0"; }
          echo "\">DEF</a></b></td><td><b>$url_sortby";
          if ($sortby==2) { echo "3"; } else { echo "2"; }
          echo "\">System Name</a></b></td><td><b>$url_sortby";
          if ($sortby==4) { echo "5"; } else { echo "4"; }
          echo "\">Hosts</b></a></td><td><b>$url_sortby";
          if ($sortby==6) { echo "7"; } else { echo "6"; }
          echo "\">Last Scanned</b></a></td><td><b>$url_sortby";
          if ($sortby==8) { echo "9"; } else { echo "8"; }

          echo "\">Scan Time</b></a></td>";
          echo "<td><b>$url_sortby";
          if ($sortby==10) { echo "11"; } else { echo "10"; }
          echo "\">Ser</b></a></td>";
          echo "<td><b>$url_sortby";
          if ($sortby==12) { echo "13"; } else { echo "12"; }
          echo "\">High</b></td>
               <td><b>Med&nbsp;</b></td>
               <td><b>Low&nbsp;</b></td>
               <td><b>Info&nbsp;</b></td>";
          echo "<td><b>$url_sortby";
               if ($sortby==14) { echo "15"; } else { echo "14"; }
          echo "\">Site</b></a></td>";
          echo "<td><b>Location&nbsp;</b></td>
               </tr>";

          if ( $uroles['reports'] ) {
               $where = "t1.status != 'available'".$query_like;
          } else {
               $where = "t1.ORG = '$site_code' AND t1.status != 'available'";
          }
          $query = "$master_query $where ORDER BY $query_order LIMIT $offset,$Limit";

  
        echo "query=$query<br>";	

          echo <<<EOT
<form action="nessus_systems.php" method="post">
<INPUT TYPE=HIDDEN NAME="page" VALUE="$page">
<INPUT TYPE=HIDDEN NAME="sortby" VALUE="$sortby">
<INPUT TYPE=HIDDEN NAME="site_code" VALUE="$site_code">
EOT;
          
     $result = $dbconn->Execute($query);

     while ( !$result->EOF ) {
         list($nid, $nname, $nsite, $nhosts, $nlocation, $approval, $start_date, $end_date, $submit_date, $nstatus, 
          $scntHosts, $siScantime, $svSerious, $svHigh, $svMed, $svMedLow, $svLowMed, $svLow, $svInfo, $emailed_results,
          $report_key, $scantype, $sysacro )  = $result->fields;
          $htmldetails = "";

          $query2 = "SELECT count( hostip ) FROM I3_system_hosts WHERE sysID='$nid'";
          $result2 = $dbconn->execute($query2);
          list( $hostcount ) =  $result2->fields;

          if ( $approval ) {
               $allow_scan = "go.png";
          } else {
               $allow_scan = "lock.png";
          }

               if ( $start_date && $end_date ) {
                    if ( $scntHosts ) {
                         $nhosts = $scntHosts;
                    }
                    $scantime = $end_date;
                    $scantime = str_replace("-", "", $scantime);
                    $scantime = str_replace(" ", "", $scantime);
                    $scantime = str_replace("/", "", $scantime);
                    $scantime = str_replace(":", "", $scantime);

                    $buttons ="";
                    if (  $uroles['nessus'] || $uroles['selfservice'] ) {
                         $buttons .= "&nbsp;<a href=\"nessus_systems.php?disp=scan&likefilter=$likefilter"
                              ."&page=$page&sortby=$sortby&nid=$nid\">"
                              ."<img src=\"images/$allow_scan\" border=0 ></a>&nbsp;&nbsp;";
                    }

                    if ( $svSerious > 1 || $svHigh > 1 || $svMed > 1 || $svLow > 1 || $svInfo > 1 ) {
                         $no_results = 0;

                         $buttons .= "<a href=\"reshtml.php?disp=html&amp;output=full"
                         ."&scantime=$scantime&scantype=$scantype\" target=\"_blank\">"
                         ."<img alt=\"HTML\" src=\"images/html.png\" border=0 "
                         ." title=\"Report in HTML format\"></A>&nbsp;"
                         ."<a href=\"respdf.php?scantime=$scantime&scantype=$scantype&key="
                              .$report_key."\" target=\"_blank\">"
                         ."<img alt=\"PDF\" src=\"images/pdf.png\" border=0 "
                         ."title=\"Report in PDF format\"></A>&nbsp;";

                         if ( $uroles['nessus'] ) {
                              if ( !  $emailed_results ) {
                                   $buttons .= "&nbsp;<a href=\"nessus_systems.php?disp=email"
                                        ."&page=$page&sortby=$sortby&nid=$nid\">"
                                        ."<img src=\"images/email.png\" border=0 ></a>&nbsp;";
                              }
                         }

                    } else {
                         $buttons .= "&nbsp;<img alt=\"HTML\" src=\"images/noreport.png\" border=0 "
                         ." title=\"NO RESULTS\">&nbsp;";
                    }

                    $buttons .= "<a href=\"trend_subnets.php"
                         ."?subnet=$nname\" target=\"_blank\">"
                         ."<img alt=\"HTML\" src=\"images/trend.png\" border=0 "
                         ." title=\"Trend\"></A>&nbsp;";

                    $htmldetails .= "<td>$svSerious</td><td>$svHigh</td><td>$svMed</td><td>$svLow</td><td>$svInfo</td>";

                    if ( $siScantime ) {
                         $nmins = "$siScantime mins";
                    } else { 
                         $nmins = datediff($end_date,$start_date,$unit="N") . " mins";
                    }
               } elseif ( $nstatus =="H" ) {
                    $buttons = "&nbsp;<img src=\"images/hold.png\" border=0>";
                    $nmins = "&nbsp";

               } elseif ( $start_date ) {
                    $buttons = "<img src=\"images/running.png\" border=0>";
                    $curtime = gen_timeasstr();
                    $nmins = "RUN..>" . datediff($curtime,$start_date,$unit="N");
                    $nmins .= " mins";
               } elseif ( $submit_date ) {
                    $buttons = "<img src=\"images/sched.png\" border=0>";
                    $nmins = "&nbsp";
               } else { 
                    if ( $uroles['nessus'] || $uroles['selfservice'] ) {
                         $buttons = "<a href=\"nessus_systems.php?disp=scan"
                              ."&page=$page&sortby=$sortby&nid=$nid\">
                              <img src=\"images/$allow_scan\" border=0></a>";
                    }
                    $nmins = "&nbsp";
                    $start_date = "";
                    $end_date = "<i>Never</i>";
               }

               if ($htmldetails == "" ) {
                    $htmldetails .= "<td>&nbsp;</td>
                         <td>&nbsp;</td>
                         <td>&nbsp;</td>
                         <td>&nbsp;</td>
                         <td>&nbsp;</td>";

               }
              
               echo "
                    <tr>
                    <td>$buttons</td><td>";

               if ( $uroles['admin'] ) {
                    echo "<a href=\"systems.php?disp=systems&nid=$nid\" target=\"_blank\">$nname</a>";
               } else {
                    echo "$nname";
               }

               if ( $hostcount == $nhosts ) {
                   $iHosts = $hostcount;	
               } else {
                   $iHosts = "$nhosts of $hostcount";
               }

               echo "</td>
                    <td><a href=\"systems.php?disp=hosts&nid=$nid\" target=\"_blank\">$iHosts</a></td>
                    <td>$end_date</td>
                    <td>$nmins</td>
                    $htmldetails
                    <td>$nsite</td>
                    <td>$nlocation</td>
                    </tr>";
          $result->MoveNext();
     }


     echo "<tr><td class=\"catBottom\" align=\"center\" colSpan=\"12\" height=\"28\">";    
     if ($previous > 0) {
          echo "<input type=\"submit\" name=\"increment\" value=\"Previous\" class=\"liteoption\">\n";
     }
     if ($next > 0) { 
          echo "<input type=\"submit\" name=\"increment\" value=\"Next\" class=\"mainoption\">\n";
     }
     echo <<<EOT
</td></tr></table></form>
EOT;

}


switch($disp) {

     case "email":
        sent_results( $likefilter, $page, $nid, $sortby);
        break;

     case "scan":
        submit_scan( $likefilter, $page, $nid, $sortby);
        break;

     default:
        network_status( $likefilter, $page, $sortby);
        break;
}

     include ('footer.php');

?>
