<?php
//
// $Id: sched.php,v 1.14 2006/09/21 12:34:35 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Nessus Scan Schedule";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('Crypt/CBC.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$myhostname="";

$getParams = array( 'disp', 'op', 'rid', 'sname', 'notify_email', 'tarSel', 'ip_list', 'ip_start', 
                     'ip_end', 'named_list', 'subnets',  'schedule_type', 'cred_type', 'job_id', 'sched_id'
                   );


$postParams = array( 'disp','op', 'rid', 'sname', 'notify_email', 'schedule_type', 'ROYEAR', 'ROMONTH', 'ROday',
                     'time_hour', 'time_min', 'week_days', 'dayofmonth', 'timeout', 'SVRid', 'sid', 'tarSel',
                     'ip_list', 'ip_start', 'ip_end', 'named_list', 'subnet', 'cred_type', 'credid', 'smbacc',
                     'smbdomain', 'smbpass', 'passtype', 'passstore', 'job_id', 'wpolicies', 'wfpolicies', 
                     'upolicies', 'cidr', 'custadd_type', 'cust_plugins', 'sched_id', 'is_enabled'
                   );

 $daysMap = array ( 
     "0" => "NONE", 
    "Su" => "Sunday",
    "Mo" => "Monday",
    "Tu" => "Tuesday",
    "We" => "Wednesday",
    "Th" => "Thursday",
    "Fr" => "Friday", 
    "Sa" => "Saturday"
          );
$schedOptions = array( "N" => "Immediately",
                     "O" => "Run Once", 
                     "D" => "Daily", 
                     "W" => "Weekly", 
                     "M" => "Monthly" );

$pluginOptions = array( "N" => "No Additional Plugins",
                     "A" => "In Addition to ( selected Profile Plugins)", 
                     "R" => "In Replace of ( selected Profile Plugins)" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach ($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         if(is_array($_GET[$gp])) {
            foreach ($_GET[$gp] as $i=>$tmp) {
               ${$gp}[$i] = sanitize($tmp);
            }
         } else {
            $$gp = sanitize($_GET[$gp]);
         }
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach ($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         if(is_array($_POST[$pp])) {
            foreach($_POST[$pp] as $i=>$tmp) {
               ${$pp}[$i] = sanitize($tmp);
//echo $pp . "[" . $i . "] = " . $$pp[$i] . "<br>";
            }
         } else {
            $$pp = sanitize($_POST[$pp]);
//echo $pp . " = " . $$pp . "<br>";
         }
      } else { 
         $$pp=""; 
      }
//echo $pp . " = " . $$pp . "<Br>";
   }
   break;
}

//echo "<pre>";
//print_r($hosts);
//echo $hosts;
//print_r($postParams);
//echo "</pre>";

global $dbconn;

$query = "select count(*) from nessus_plugins";
$result=$dbconn->execute($query);
list($pluginscount)=$result->fields;

if ($pluginscount==0) {
   logAccess( "NO PLUGINS IN THE DB - USER NEED LAUNCH UPDATEPLUGINS" );
   $logh->log("$username : " . $_SERVER['PHP_SELF'] . " : You need to run updateplugins.pl", PEAR_LOG_CRIT);
   die ("<h2>Please run updateplugins.pl script first before using web interface.</h2>");
}

function java_validation ( ) {
   global $emailDomains;
     echo <<< EOT

<script language="JavaScript">
function checkForm()
{
   var sname, notify_email, tarSel, ip_list, ip_start, ip_end, named_list, subnets,  schedule_type;
   with(window.document.msgform)
   {
      cname    = sname;
      cemail   = notify_email;
      csubject = schedule_type;
      ctSel    = tarSel;
      iplist   = ip_list;
      rstart   = ip_start;
      rend     = ip_end;
      named    = named_list;
      csubnets = subnets;
   }

   if (trim(cname.value) == '') {
      alert('Please enter job name');
      cname.focus();
      return false;
   } else if (trim(cemail.value) == '') {
      alert('Please enter your email');
      cemail.focus();
      return false;
   } else if ( ! checkEmails( trim(cemail.value) ) === true ) {
      cemail.focus();
      return false;
   } else if (trim(csubject.value) == '') {
      alert('Please setup schedule / scan frequency');
      csubject.focus();
      return false;
   } else if ( ctSel.value == '1' &&  trim(iplist.value) == '') {
      alert('Please setup Target Selection ( Host List)');
      ip_list.focus();
      return false;
   } else if ( ctSel.value == '2' && ( trim(rstart.value) == '' || trim(rend.value) == '' ) ) {
      alert('Please setup Target Selection ( Host Range)');
      rstart.focus();
      return false;
   } else if ( ctSel.value == '2' &&  trim(named.value) == '') {
      alert('Please setup Target Selection ( Host List)');
      named.focus();
      return false;
   } else if  (ctSel.value == '3' &&  trim(csubnets.value) == '') {
      alert('Please setup Target Selection (Subnet Block)');
      csubnets.focus();
      return false;
   } else {
      cname.value    = trim(cname.value);
      cemail.value   = trim(cemail.value);
      csubject.value = trim(csubject.value);
      return true;
   }
}

function checkEmails( emails ){
   //WATCH FOR OUTLOOK SEMI-COLON DELIMTERS AND FIX FOR PROPER PARSING
   emails = emails.replace(/;+/g, ',');
   var emailArray = emails.split(",");
   var invEmails = "";
   for(i = 0; i <= (emailArray.length - 1); i++){
      if( isEmail(trim( emailArray[i])) ){
         //Do what ever with the email.
      }else{
         alert('Email address: ' + emailArray[i] + ' is not valid');
	 invEmails += emailArray[i] + ",";
      }
   }
   if ( invEmails == '' ) {
      return true;
   }
}

function trim(str)
{
   return str.replace(/^\s+|\s+$/g,'');
}

function isEmail(str)
{
   var regex = /^[-_.a-z0-9]+@(([-_a-z0-9]+\.)+($emailDomains)|(([0-9][0-9]?|[0-1][0-9][0-9]|[2][0-4][0-9]|[2][5][0-5])\.){3}([0-9][0-9]?|[0-1][0-9][0-9]|[2][0-4][0-9]|[2][5][0-5]))$/i;

return regex.test(str);
}
</script>


EOT;

}

function main_page( $job_id, $op ){
   global  $editdata, $scheduler, $enComplianceChecks, $profileid, $timeout, $uroles, $username, $useremail, $dbconn;

     $query = "SELECT pn_email FROM users WHERE pn_uname='$username' LIMIT 1";
     $result=$dbconn->execute($query);
     list($useremail)=$result->fields;

     $request = "";

     if ( $op == "recurring" ) {
        $scheduler = "1";
        $title = "Create Recurring Job";
        $txt_submit = "Submit";
     } elseif ( $op == "editrecurring" ) {
        $scheduler = "1";
        $title = "Edit Recurring Job";
        $txt_submit = "Save Changes";
     } else {
        if ( !($uroles['nessus']) ) {
           $request = " Request"; #Users without nessus role can only submit scan request
        }
        $title = "Create Scan Job$request";
        $txt_submit = "Submit";
     }

     java_validation ();

     $profileid = 1;          #DEFAULT PROFILE


     #include ('navbar.php');

     $timeout = "172800";


     echo <<<EOT

     <B>$title:</B><BR>

     <div>
     <form method="post" action="sched.php" name="msgform">
     <input type="hidden" name="disp" value="create">
EOT;
     if ( $op == "editrecurring" ) {
        $sched_id = $editdata['id'];
        echo <<<EOT
     <input type="hidden" name="op" value="editrecurring">
     <input type="hidden" name="sched_id" value="$sched_id">
EOT;
     }
 
     $tabs = array( "discovery" => "Target",
                    "settings" => "Scan",
                    "credentials" => "Credentials");
     if ( $enComplianceChecks ) {
        $tabs['compliance'] = "Compliance";
     }
     $tabs['reporting'] = "Reporting";

     $i = 0;
     $numTabs = count($tabs) - 1;
     foreach($tabs as $tkey=>$tname) {
        $func = "tab_" . $tkey;
        if($schedTabs != "") { $schedTabs .= " | "; }
        $schedTabs .= "<a href=\"javascript:\" onClick=\"showDiv($i, 'section', $numTabs);return false;\">" . $tname . "</a>";
        $schedContent .= createHiddenDiv($tkey,$i,$func());
        $i++;
     }

      echo <<<EOT
<p>$schedTabs</p>
$schedContent
<input type="submit" name="submit" value="$txt_submit" onClick="return checkForm();" >
</form>
</div>
EOT;

   require_once("footer.php");

}

function tab_reporting () {
   $reporting = <<<EOT
<table><tr valign="top"><td>
<table class="noborder" >
        <tr><td>No Advanced / Customized Reporting exists (At this Time).</td>
        </tr>
     </table></td></tr></table>
EOT;
   return $reporting;
}

function tab_compliance () {
   global $editdata, $scheduler, $unixAuditDir, $winAuditDir, $winFileAudits, $enComplianceChecks, $profileid, $timeout, $username, $useremail, $dbconn;

$compliance = <<<EOT
<table>
  <tr valign="top">
    <td ><b>Compliance Checks</b>:<br><br>
   <input type="radio" name="comp_type" value="" onClick="showLayer('idComp', 1)" CHECKED>No Compliance Audit</input><br>
   <input type="radio" name="comp_type" value="N" onClick="showLayer('idComp', 2)" >Windows Checks</input><br>
   <input type="radio" name="comp_type" value="S" onClick="showLayer('idComp', 3)" >Win File Check</input><br>
   <input type="radio" name="comp_type" value="E" onClick="showLayer('idComp', 4)">Unix Checks</input>
    </td>
    <td>
      <div>
        <div id="idComp1" class="forminput">
        </div>
        <div id="idComp2" class="forminput">
        <SELECT MULTIPLE  name="wpolicies[]">
EOT;
   $directory = "$winAuditDir";

   $query = "SELECT name 
      FROM nessus_audits t1
      LEFT JOIN nessus_audit_users t2 ON t1.id = t2.cid
      WHERE t1.deleted='0' AND check_type = 'winAuditDir' AND
      ( t1.TYPE='G' 
         OR ( t1.TYPE='P' AND t1.owner = '$username' ) 
         OR ( t1.TYPE='P' AND t2.username = '$username' ) )";

   $result=$dbconn->execute($query);
   while (!$result->EOF) {
      list( $file)=$result->fields;
      if ( isset($editdata['meth_Wcheck']) && preg_match("/$file/i", $editdata['meth_Wcheck'] ) ) { $selected = "SELECTED"; }
      $fname = str_replace(".audit", "", $file );
      $compliance .= "<OPTION VALUE=\"$winAuditDir/$file\" $selected>$fname</option>";
      $result->MoveNext();
   }

    $compliance .= "
        </select><br><font color='red'> Credential is required</font>
    </div>
    <div id='idComp3' class='forminput'>
        <SELECT MULTIPLE  name='wfpolicies[]'>
";
   $directory = "$winFileAudits";
   $query = "SELECT name 
      FROM nessus_audits t1
      LEFT JOIN nessus_audit_users t2 ON t1.id = t2.cid
      WHERE t1.deleted='0' AND check_type = 'winFileAudits' AND
      ( t1.TYPE='G' 
         OR ( t1.TYPE='P' AND t1.owner = '$username' ) 
         OR ( t1.TYPE='P' AND t2.username = '$username' ) )";

   $result=$dbconn->execute($query);
   while (!$result->EOF) {
      list( $file)=$result->fields;
      if ( isset($editdata['meth_Wfile']) && preg_match("/$file/i", $editdata['meth_Wfile'] ) ) { $selected = "SELECTED"; }
      $fname = str_replace(".audit", "", $file );
      $compliance .= "<OPTION VALUE=\"$winFileAudits/$file\" $selected>$fname</option>";
      $result->MoveNext();
   }

    $compliance .= <<<EOT
        </select><br><font color="red">Credential is required</font>
    </div>
    <div id='idComp4' class="forminput"> 
        <SELECT MULTIPLE name='upolicies[]'>
EOT;
   $directory = "$unixAuditDir";

   $query = "SELECT name 
      FROM nessus_audits t1
      LEFT JOIN nessus_audit_users t2 ON t1.id = t2.cid
      WHERE t1.deleted='0' AND check_type = 'unixAuditDir' AND
      ( t1.TYPE='G' 
         OR ( t1.TYPE='P' AND t1.owner = '$username' ) 
         OR ( t1.TYPE='P' AND t2.username = '$username' ) )";

   $result=$dbconn->execute($query);
   while (!$result->EOF) {
      list( $file)=$result->fields;
      if ( isset($editdata['meth_Ucheck']) && preg_match("/$file/i", $editdata['meth_Ucheck'] ) ) { $selected = "SELECTED"; }
      $fname = str_replace(".audit", "", $file );
      $compliance .= "<OPTION VALUE=\"$unixAuditDir/$file\" $selected>$fname</option>";
      $result->MoveNext();
   }   

    $compliance .= <<<EOT
        </select><br><font color='red'>Credential is required</font>
        </div>
        <div id='idComp4' class="forminput">
        </div>
        <div id='idComp5' class="forminput">
        </div>
    </div>
      </td>
    </tr>
  </table>
EOT;
   return $compliance;
}

function tab_credentials () {
   global $editdata, $scheduler, $username, $dbconn;

   $sTYPE['N'] = "";
   $sTYPE['S'] = "";
   
   if ( isset($editdata['meth_CRED'] )) { $usedCred = $editdata['meth_CRED']; } else { $usedCred = ""; }
   if ( isset($editdata['meth_CRED'] )) {  $sTYPE['S'] = "CHECKED"; } ELSE { $sTYPE['N']  = "CHECKED"; }


   $credentials = <<<EOT
<table ><tr valign="top"><td>
<table class="noborder" >
  <tr>
    <td align="right" width="30%"  >Credentials:
    <table cellspacing="0" cellpadding="0" border="0">
      <tr>
        <td><input type="radio" name="cred_type" value="N" onClick="showLayer('idCred', 1)" $sTYPE[N]>Null Credentials</input></td>
      </tr> 
      <tr>
        <td><input type="radio" name="cred_type" value="S" onClick="showLayer('idCred', 2)" $sTYPE[S]>Stored Credentials</input></td>
      </tr>
      <tr>
        <td><input type="radio" name="cred_type" value="E" onClick="showLayer('idCred', 3)">Enter a Credential</input>
        <br><br><br><br><br><br><br><br><br></td>
      </tr>
    </table>
    </td>
    <td>
      <div>
        <div id="idCred1" class="forminput">
          <table >
            <tr><td>&nbsp;</td></tr>
          </table>
        </div>
        <div id="idCred2" class="forminput">
          <table >
            <tr>
              <td><select name="credid">
                <option value="" >Select a credential to Use</option>
EOT;

   $query = "SELECT t1.id, t1.smbaccount, t1.TYPE
      FROM I3_credentials t1
      LEFT JOIN I3_orgs t2 ON t1.ORG = t2.org_code
      LEFT JOIN I3_org_users t3 ON t2.id = t3.orgID
      WHERE expired='0' AND 
         ( t1.TYPE='G' 
         OR ( t1.TYPE='P' AND t1.pn_uname = '$username' ) 
         OR ( t1.TYPE='O' AND t3.pn_uname = '$username' ) )";

   $result=$dbconn->execute($query);

   while (!$result->EOF) {
      list($credid, $cname, $ctype )=$result->fields;
      $credentials .= "<option value=\"$credid\"";
      if ($usedCred==$credid) $credentials .= "selected";
      $credentials .= ">$cname</option>";
      $result->MoveNext();
   }

   $credentials .=  <<<EOT
                </select>
              </td>
            </tr>
          </table>
        </div>
        <div id='idCred3'  class='forminput'> 
          <table >
            <tr>
              <td align='right'>SMB Account</td><td><INPUT type='text' name='smbacc' value=''></td>
            </tr>
            <tr>
              <td align='right'>SMB Domain</td><td><INPUT type='text' name='smbdomain' value=''></td>
            </tr>
            <tr>
              <td align='right'>SMB Password</td><td><INPUT type='password' name='smbpass' value=''></td>
            </tr>
            <tr>
              <td align='right'>Blowfish Encrypted Store</td>
                <td>
                  <INPUT type='radio' name='passstore' value='C' checked>Until Job Start<BR>
                  <INPUT type='radio' name='passstore' value='P' >My Use Only<BR>
                  <INPUT type='radio' name='passstore' value='O' >ORG LEVEL SHARE<BR>
                  <INPUT type='radio' name='passstore' value='G' >Global Shared Password<BR>
                </td>
            </tr>
          </table>
        </div>
        <div id='idCred4' class='forminput'>
        </div>
        <div id='idCred5' class='forminput'>
        </div>
      </div>
      </td>
    </tr>
  </table>
</td></tr></table>
EOT;
   return $credentials;
}

function tab_settings () {
   global $editdata, $pluginOptions, $scheduler, $enComplianceChecks, $profileid, $timeout, 
      $uroles, $username, $useremail, $dbconn;

   if ( isset($editdata['meth_VSET']) ) { $profileid = $editdata['meth_VSET']; }
   if ( isset($editdata['meth_TIMEOUT']) ) { $timeout = $editdata['meth_TIMEOUT']; }

   $query = "SELECT id, name, hostname
     FROM nessus_servers
     WHERE enabled='1' AND status='A' and max_scans > 0
     ORDER BY max_scans desc";
   $result=$dbconn->execute($query);

   $settings = <<<EOT
<table ><tr valign="top"><td>
<table >
  <tr>
    <td align="right" >Select Server:</td>
    <td><select name="SVRid">
      <option value="Null" SELECTED>First Available Server</option>
EOT;

   while (!$result->EOF) {
      list($SVRid, $sname, $shostIP)=$result->fields;
      $settings .= "<option value=\"$SVRid\" ";
      if ( isset($editdata['scan_ASSIGNED']) && ($editdata['scan_ASSIGNED'] == $SVRid )) { $settings .= " SELECTED"; } 
      $settings .= ">" . strtoupper($sname) . " [$shostIP] </option>";
      $result->MoveNext();
   }

   $settings .= <<<EOT
      </select>
    </td>
  </tr>
  <tr>
    <td align='right' width='25%'>Profile:</td>
    <td><select name='sid'>
EOT;

   $query = "SELECT distinct(t1.id), t1.name, t1.description 
      FROM nessus_settings t1
      LEFT JOIN nessus_settings_users t2 ON t1.id = t2.sid 
      WHERE t1.type = 'G' OR t2.username='$username' 
      ORDER BY t1.name";
   $result=$dbconn->execute($query);

   while (!$result->EOF) {
      list($sid, $sname, $sdescription)=$result->fields;
      $settings .= "<option value=\"$sid\" ";
      if ($profileid==$sid) {$settings .= "selected";}
      $settings .= ">$sname-$sdescription</option>";
      $result->MoveNext();
    }

    $settings .= <<<EOT
    </select></td>
  <tr>
    <td align='right'>Timeout</td>
    <td><input type='text' name='timeout' value='$timeout'>
    <font color='red'>Max scan run time in seconds</font></td>
  </tr>
EOT;

  if ( $uroles['plugoverride'] ) {
    $settings .= <<<EOT
  <tr>
    <td >Override Plugin Lists:</td>
    <td><select name='custadd_type'>
EOT;
   foreach( $pluginOptions as $custN => $custV ) {
      $settings .= "<option value=\"$custN\" ";
      if ( isset($editdata['meth_CUSTOM']) && ($editdata['meth_CUSTOM'] == $custN )) { $settings .= " SELECTED"; } 
      $settings .= ">$custV</option>";
   }

   $settings .= <<<EOT
      </select><br>
      <textarea name='cust_plugins' cols='48' rows='12'>$editdata[meth_CPLUGINS]</textarea><font color='red'>Enter Plugin ID's</font>
    </td>
  </tr>
EOT;
   } else {
   $settings .= <<<EOT
<tr>
    <td></td><td></td>
  </tr>
EOT;

   }
   $settings .= "</table></td></tr></table>";
   return $settings;
}

function tab_discovery () {
   global $uroles, $editdata, $scheduler, $username, $useremail, $dbconn;

     $today=date("Ymd");
     $tyear=substr($today,0,4);
     $nyear=$tyear+1;
     $tmonth = substr($today,4,2);
     $tday = substr($today,6,2);

     #SET VALUES UP IF EDIT SCHEDULER
     if ( isset($editdata['notify'] )) { $enotify = $editdata['notify']; } else { $enotify = "$useremail"; }
     if ( isset($editdata['time'] )) { list( $time_hour, $time_min, $time_sec) = split(':', $editdata['time'] ); }

     $arrTypes = array( "N", "O", "D", "W", "M" );
     foreach ( $arrTypes as $type ) {
         $sTYPE[$type] = "";
     }
     if ( isset($editdata['schedule_type'] )) {  $sTYPE[$editdata['schedule_type']] = "CHECKED"; } ELSE { $sTYPE['N']  = "CHECKED"; }

     if ( isset($editdata['day_of_month'] )) { $dayofmonth = $editdata['day_of_month']; }
     if ( isset($editdata['day_of_week'])) { $day[$editdata['day_of_week']] = "SELECTED"; }

     $discovery = <<<EOT
<table id="content" ><tr valign="top"><td>
<table class="noborder" width="100%">
  <tr>
    <td align="Right" width="30%" >Name your Job</td>
    <td><input type="text" name="sname" value="$editdata[name]"></td>
  </tr>
  <tr>
    <td align="Right" >Notification:</td>
    <td><input type="text" name="notify_email" size="40" value="$enotify"><i>(Supports Comma Delimiter)</i></td>
  </tr>
  <tr>
    <td align="right" >Schedule Method:
    <table cellspacing="0" cellpadding="0" border="0">
EOT;

if ( ! $scheduler ) {
     $discovery .= <<<EOT
      <tr>
        <td><input type="radio" name="schedule_type" value="N" onClick="showLayer('idSched', 1)" $sTYPE[N]>Immediately</input></td>
      </tr>
      <tr>
        <td><input type="radio" name="schedule_type" value="O" onClick="showLayer('idSched', 3)"  $sTYPE[O]>Run Once</input></td>
      </tr>
EOT;

}
     $discovery .= <<<EOT
      <tr>
        <td><input type="radio" name="schedule_type" value="D" onClick="showLayer('idSched', 2)" $sTYPE[D]>Daily</input></td>
      </tr> 
      <tr>
        <td><input type="radio" name="schedule_type" value="W" onClick="showLayer('idSched', 4)" $sTYPE[W]>Day of the Week</input></td>
      </tr>
      <tr>
        <td><input type="radio" name="schedule_type" value="M" onClick="showLayer('idSched', 5)"  $sTYPE[M]>Day of the Month</input></td>
      </tr>
    </table>
    </td>
    <td><div>
      <div id="idSched1" class="forminput">
        <table >
          <tr><td>&nbsp;</td></tr>
        </table>
      </div>
      <div id="idSched3" class="forminput">
        <table border="0" cellspacing="0" cellpadding="0">
          <tr><td colspan="7">Year<select name="ROYEAR">
            <option value="$tyear" selected>$tyear</option>
            <option value="$nyear">$nyear</option>
            </select> Month <select name="ROMONTH">";
EOT;
   for ($i=1;$i<=12;$i++) {
      $discovery .= "<option value=\"$i\" ";
      if ($i==$tmonth) $discovery .= "selected";
      $discovery .= ">$i</option>";
   }
   $discovery .= "</select> Day <select name=\"ROday\">";
   for ($i=1;$i<=31;$i++) {
      $discovery .= "<option value=\"$i\" ";
      if ($i==$tday) $discovery .= "selected";
         $discovery .= ">$i</option>";
   }
            $discovery .= <<<EOT
            </select></td>
          </tr>
        </table>
      </div>
      <div id="idSched4" class="forminput" > 
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td align="right">Weekly</td><td colspan="2">
              <select name="week_days">
                <option value="0" SELECTED >Select week day to run</option>
                <option value="Su" $day[Su] >Sunday</option>
                <option value="Mo" $day[Mo] >Monday</option>
                <option value="Tu" $day[Tu] >Tuesday</option>
                <option value="We" $day[We] >Wednesday</option>
                <option value="Th" $day[Th] >Thursday</option>
                <option value="Fr" $day[Fr] >Friday</option>
                <option value="Sa" $day[Sa] >Saturaday</option>
              </select>
            </td>
          </tr>
        </table>
      </div>
      <div id="idSched5" class="forminput">
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td align="right">Select Day</td>
            <td colspan="2"><select name="dayofmonth">"
EOT;
   for ($i=1;$i<=31;$i++) {
      $discovery .= "<option value=\"$i\"";
      if ($dayofmonth==$i) $discovery .= " selected";
      $discovery .= ">$i</option>";
   }

            $discovery .= <<<EOT
            </select></td>
          </tr>
        </table>
      </div>
      <div id="idSched2"  class="forminput">
        <table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr>
            <td rowspan="2" align="right" width="30%">Time</td>
            <td align="right">Hour</td><td>Minutes</td>
          </tr>
          <tr>
            <td align="right"><select name="time_hour">
EOT;
   for ($i=0;$i<=23;$i++){
      $discovery .=  "<option align=\"right\" value=\"$i\"";
      if ($time_hour==$i) $discovery .= " selected";
      $discovery .= ">$i</option>";
   };
            $discovery .= <<<EOT
            </select></td>
            <td><select name="time_min">
EOT;
               for ($i=0;$i<60;$i=$i+15){
                    $discovery .= "<option value=\"$i\"";
                    if ($time_min == $i) $discovery .= " selected";
                    $discovery .= ">$i</option>";
               };
            $discovery .= <<<EOT
            </select></td>
          </tr>
        </table>
      </div>
    </tr>
    <tr>
      <td valign="top" align="Right" width="30%" >Target Hosts
        <select name="tarSel" onClick="if (this.options[this.selectedIndex].value != 'null') {
          showLayer('idTarget', this.options[this.selectedIndex].value ) }">
          <option name="schedule" value="1" >IP List</option>
          <option name="schedule" value="2" >IP Range</option>
          <option name="schedule" value="3" >Named Target List</option>
          <option name="schedule" value="4" >CIDR</option>
          <option name="schedule" value="5" >Subnet</option>
        </select><br><br><br><br><br><br><br><br><br></td>
        <td>
        <div align="left">
          <div id="idTarget1" class="selected" >
            <textarea name="ip_list" cols="32" rows="8">$editdata[meth_TARGET]</textarea>
          </div>
          <div id="idTarget2" class="forminput">
            <table width="100%">
              <tr>
                <td align="Right" width="30%"  >Range Start</td>
                <td><input type="text" name="ip_start" value=""></td>
              </tr>
              <tr>
                <td align="Right" width="30%" >Range End</td>
                <td><input type="text" name="ip_end" value=""></td>
              </tr>
            </table>
          </div>
          <div id="idTarget3" class="forminput">
            <textarea name="named_list" cols="32" rows="8"></textarea>
          </div>
          <div id="idTarget4" class="forminput">
            <input type="text" name="cidr" value="">
          </div>
          <div id="idTarget5" class="forminput">
            <table width="100%">
              <tr>
                <td align="Right" width="30%" ></td>
                <td><select name="subnet">
                  <option value="" >Select A Subnet to Scan</option>
EOT;

if ( $uroles['admin'] || $uroles['auditAll'] ) {
	 $discovery .= "<option value='ALL' >Audit All Subnets - (SINGLE JOB)!!!</option>";
     $query_filter = "AND t1.tiScanApproval='1'";
} else {
     $query_filter = "AND t4.pn_uname = '$username'";
}
     $query = "SELECT distinct t1.id, t1.site_code, t1.CIDR
FROM I3_subnets t1
LEFT JOIN I3_sites t2 ON t1.site_code = t2.site_code
LEFT JOIN I3_org_sites t3 ON t2.id = t3.siteID
LEFT JOIN I3_org_users t4 ON t3.orgID = t4.orgID
WHERE t1.status != 'available' $query_filter
ORDER BY t1.site_code, CIDR";

     $result=$dbconn->execute($query);
     while (!$result->EOF) {
          list($subid, $scode, $sname)=$result->fields;
          $discovery .= "<option value=\"$sname\">[$scode] $sname</option>";
          $result->MoveNext();
     }

                $discovery .= <<<EOT
                </select></td>
              </tr>
            </table>
          </div>
          <div id="idTarget5" class="forminput">
          </div>
        </div>
      </div>
    </td>
  </tr>
</table>
</tr></td></table>
EOT;
   return $discovery;
}

function edit_schedule ( $sched_id ) {
    global $uroles, $editdata, $scheduler, $username, $useremail, $dbconn;

    logAccess( "USER $username CHOSE EDIT SCHEDULE $sched_id" );

    $sql_access = "";
    if ( ! $uroles['admin'] ) { $sql_access = "AND username='$username'"; }

    $query = "SELECT id, name, username, schedule_type, day_of_week, day_of_month, time, email, meth_TARGET, meth_CRED, 
       meth_VSET, meth_Wcheck, meth_Wfile, meth_Ucheck, meth_TIMEOUT, scan_ASSIGNED
       FROM I3_job_schedule WHERE id = '$sched_id' $sql_access";
    $result = $dbconn->execute($query);
    $editdata = $result->fields;

    if ( $editdata['id'] == $sched_id ) {
       main_page( $job_id, "editrecurring" );
    } else {
       logAccess( "INVALID SCHEDULE $sched_id" );
    }
}

function rerun ( $job_id ) {
   global $uroles, $editdata, $scheduler, $username, $useremail, $dbconn;
   
    logAccess( "USER $username CHOSE TO RERUN SCAN $job_id" );
       
    $sql_access = "";
    if ( ! $uroles['admin'] ) { $sql_access = "AND username='$username'"; }    
    
    $query = "SELECT id, name, notify, job_TYPE, meth_SCHED, meth_TARGET, meth_CRED, 
       meth_VSET, meth_Wcheck, meth_Wfile, meth_Ucheck, meth_TIMEOUT, scan_ASSIGNED
        FROM I3_jobs WHERE id = '$job_id' $sql_access";
    $result = $dbconn->execute($query);
    #list( $sname, $notify_email, $job_type, $schedule_type, $timeout, $SVRid, $sid, $targetlist ) = $result->fields;
    $editdata = $result->fields;

    if ( $editdata['id'] == $job_id ) {
       main_page( $job_id, "re-run" );
    } else {
       logAccess( "INVALID JOBID $job_id" );
       echo "<p><font color=red>INVALID JOB ID</font></p>";
    }


}

function getCredentialId ( $cred_type, $passstore, $credid, $smbacc, $smbdomain, $smbpass, $passtype ) {
   global $scheduler, $allowscan, $uroles, $username, $schedOptions, $adminmail, $mailfrom, $dbk, $dbconn;

    if ( $cred_type == "E" ) {
      if ( $smbacc != "" && $smbpass != "" && $passstore != "" ) {
         if ( $smbdomain == "" ) { $sdomain = "Null"; } else { $sdomain = "'$smbdomain'"; }
         $insert_time =  date("YmdHis");
         if ($smbpass!="" && !strstr($smbpass,'ENC{')) {  // not encrypted
            $cipher = mcrypt_module_open(MCRYPT_BLOWFISH,'','cbc','');
            mcrypt_generic_init($cipher, $dbk,substr($dbk,12, 8));
            $encrypted_val = mcrypt_generic($cipher,$smbpass);
            $smbpass = "ENC{" . base64_encode($encrypted_val) . "}";
            mcrypt_generic_deinit($cipher);
         }

         if ( $passstore == "O" ) {
            $query = "SELECT t1.org_code FROM I3_orgs t1
               LEFT JOIN I3_org_users t2 ON t1.id = t2.orgID
               WHERE t2.pn_uname = '$username'";
            $result = $dbconn->execute($query);
            list( $org ) = $result->fields;
         }
         $query = "INSERT INTO I3_credentials ( pn_uname, smbaccount, smbpassword, smbdomain, password_type,
            TYPE, ORG, select_key ) VALUES (
               '$username', '$smbacc', '$smbpass', $sdomain, 'Password', '$passstore', '$org', '$insert_time' ) ";

         if ($dbconn->execute($query) === false) {
            echo "Error creating scan job: " .$dbconn->ErrorMsg();
            logAccess( "Error saving credentials $auname:" . $dbconn->ErrorMsg() );
            $error = 1;
            exit;
         } else {
            $query2 = "SELECT id FROM I3_credentials WHERE pn_uname='$username' AND select_key='$insert_time'";
            $result2 = $dbconn->execute($query2);
            list( $tmpID ) = $result2->fields;
            return "'$tmpID'";
         }

      }

   } 

   if ( $cred_type == "S" ) {
      if ( $credid != "" ) {
         return "'$credid'";
      }
   }

   return;

}

function submit_scan( $op, $sched_id, $sname, $notify_email, $schedule_type, $ROYEAR,$ROMONTH, $ROday,
     $time_hour, $time_min, $week_days, $dayofmonth, $timeout, $SVRid, $sid, $tarSel, $ip_list,
     $ip_start, $ip_end,  $named_list, $cidr, $subnet, $cred_type, $credid, $smbacc, $smbdomain,
     $smbpass, $passtype, $passstore, $wpolicies, $wfpolicies, $upolicies, $custadd_type, $cust_plugins,
     $is_enabled ) {

     global $daysMap, $allowscan, $uroles, $username, $schedOptions, $adminmail, $mailfrom, $dbk, $dbconn;

     $notify_email = str_replace( ";", ",", $notify_email );
     $requested_run = "";
     $jobType="M";
     $recurring = False;
     $targets = array();
     $time_value = "";
     $profile_desc =  getProfileName( $sid );
	 $target_list = "";
     $cidr = "";
     $need_authorized = "";
     $request="";
     $plugs_list="NULL";

     $I3crID = getCredentialId ( $cred_type, $passstore, $credid, $smbacc, $smbdomain, $smbpass, $passtype );
     if ( $I3crID == "" ) {
        $I3crID = "Null";
     }

     if ( $custadd_type == "" ) { $custadd_type = "N"; }
     if ( $custadd_type != "N" && $cust_plugins != "" ) {
     	  $plugs_list="";
          $vals=preg_split( "/\s+|\r\n|,|;/", $cust_plugins );
          foreach($vals as $v) {
               $v=trim($v);
               if ( strlen($v)>0 ) {
                    $plugs_list .= $v . "\n";
               }
          }
          $plugs_list = "'".$plugs_list."'";   	
     }
     
     echo <<<EOT
     <h3>Job Details:</h4>
     <center>
     <table width="1000">
     <tr><td align="right">JOB NAME</td><td>$sname</td></tr>
     <tr><td align="right">NOTIFY</td><td>$notify_email</td></tr>
     <tr><td align="right">TIMEOUT</td><td>$timeout</td></tr>
     <tr><td align="right">PROFILE</td><td>$profile_desc</td></tr>
     <tr><td colspan="2">&nbsp;</td></tr>
     <tr><td align="right">SCHEDULE INFO</td><td>&nbsp;</td></tr>
EOT;

   switch($schedule_type) {
   case "N":

          $requested_run = date("YmdHis");
          $sched_message = "No reccurring Jobs Necessary";

      break;
   case "O":
          $time_value = sprintf("%02d%02d%02d",  $time_hour, $time_min, "00" );
          $requested_run = sprintf("%04d%02d%02d%06d", $ROYEAR, $ROMONTH, $ROday,  $time_value );
          echo "requested run=$requested_run<br>";
          $sched_message = "No reccurring Jobs Necessary";   

      break;
   case "D":
          $next_day = date("Ymd", mktime(0, 0, 0, date("m"), date("d")+1, date("y"))); 

          $recurring = True;
          $today=date("Ymd");
          $time_value = sprintf("%02d%02d%02d", $time_hour,  $time_min, "00" );
          $requested_run = sprintf("%08d%06d", $next_day,  $time_value );
          $sched_message = "Schedule Reccurring";
          $reccur_type = "Daily";
      break;
   case "W":
          $dayofweek = $daysMap[$week_days];
          $next_day = date('Ymd', strtotime("next $dayofweek"));

          $recurring = True;
          $time_value = sprintf("%02d%02d%02d", $time_hour,  $time_min, "00" );
          $requested_run = sprintf("%08d%06d", $next_day,  $time_value );
          $sched_message = "Schedule Reccurring";
          $reccur_type = "Weekly";
      break;
   case "M":
          $next_day = date("Ymd", mktime(0, 0, 0, date("m")+1, $dayofmonth, date("y"))); 

          $recurring = True;
          $time_value = sprintf("%02d%02d%02d", $time_hour,  $time_min, "00" );
          $requested_run = sprintf("%08d%06d", $next_day,  $time_value );
          $sched_message = "Schedule Reccurring";
          $reccur_type = "Montly";
      break;
   default:

      break;
   }

     echo <<<EOT

     <tr><td align="right">TYPE</td><td>$schedOptions[$schedule_type]</td></tr>
     <tr><td align="right">FIRST OCCURRENCE</td><td>$requested_run</td></tr>
     <tr><td align="right">REOCCURRINGG</td><td>$sched_message</td></tr>
     <tr><td colspan="2">&nbsp;</td></tr>
     <tr><td align="right">TARGET SELECTION</td><td>&nbsp;</td></tr>
EOT;

   switch($tarSel) {
   case "1":     #SINGLE
          $vals=preg_split( "/\s+|\r\n|,|;/", $ip_list );
          foreach($vals as $v) {
               $v=trim($v);
               if ( strlen($v)>0 ) {
                    array_push($targets, $v );
               }
          }

      break;
   case "2":     #IP RANGE

          if ( $ip_start || $ip_end ) {
               if ( $ip_start && $ip_end ) {
                    $targets = range2List( $ip_start, $ip_end );
               } else {
                    echo "<tr><td align=\"right\">&nbsp;</td><td>incomplete target list</td></tr>";
               }
          }

      break;
   case "3":     #NAMED TARGET
             $vals=preg_split( "/\s+|\n|,|;/", $named_list );
          foreach($vals as $v) {
               $v=trim($v);
               if ( strlen($v)>0 ) {
                    $ip = gethostbyname($v);
                    if ( strlen($ip)>0) {
                         array_push($targets, $ip );
                    } else {
                         echo "<tr><td align=\"right\">&nbsp;</td><td>$v&nbsp;&nbsp;Name could not be resolved</td></tr>";
                    }
               }
          }
      break;
   case "4":     #SUBNET
          array_push($targets, $subnet );
      break;
   case "5":
          if ( $uroles['auditAll'] && $subnet == "ALL" ) {
             array_push($targets, "all_live_subnets" );
          } else {
             array_push($targets, $subnet );
          }
      break;
   default:          #INPUT FILE

      break;
   }
   
   if ( $tarSel < "4" ) {
       foreach ( $targets as $hostip ) {
           if ( !$allowscan && !inrange( $hostip, $dbconn ) ) {
               $need_authorized .= $hostip . "\n";
           }
           $target_list .= $hostip . "\n";
           echo "<tr><td align=\"right\">&nbsp;</td><td>$hostip</td></tr>";
       }
       if ( $need_authorized != "" ) {
           echo "<tr><td align=\"right\"><font color=red>NOT IN APPROVED ZONE</font></td><td>&nbsp;</td></tr>";
           $html_needs_auth = str_replace( "\n", "<br>", $need_authorized );
           echo "<tr><td align=\"right\">&nbsp;</td><td>$html_needs_auth</td></tr>";
       }
   } elseif ( $tarSel == "4") {
       $subnet = $cidr;
       $target_list=$subnet;
       echo "<tr><td align=\"right\">&nbsp;</td><td>$subnet</td></tr>";
   } else {
       $jobType="C";
       $target_list=$subnet;
       echo "<tr><td align=\"right\">&nbsp;</td><td>$subnet</td></tr>";
   }
   
   if ( count( $targets ) == 0 ) {
      echo "<p><center><font color=red>Missing Host Selection or BAD LIST:$targets[0]<br><br></font>"
         ."[ <a href=\"javascript:history.go(-1)\">Go Back</a> ]</center></p>";
      logAccess( "USER $username Fubared: Missing Host Selection or BAD LIST:$targets[0]" );
      require_once("footer.php");
      exit;
   } elseif ( ! $sname ) {
      echo "<p><center><font color=red>Missing or BAD SNAME:[$sname]<br><br></font>"
         ."[ <a href=\"javascript:history.go(-1)\">Go Back</a> ]</center></p>";
      logAccess( "USER $username Fubared something on job name [$sname]" );
      require_once("footer.php");
      exit;
   }

   if ( $subnet == "" or $subnet== "0" ) { $subnet = "Null"; } else { $subnet = "'$subnet'"; }
   if ( $SVRid == "" or $SVRid == "Null" ) { $SVRid = "Null"; } else { $SVRid = "'$SVRid'"; }

   $arrChecks = array( "w" => $wpolicies, "f" => $wfpolicies, "u" => $upolicies );
   $arrAudits = array('w', 'f', 'u' );

   foreach ( $arrChecks as $check => $policydata ) {
   	  $i = 1;
   	  $audit_data = "";
   	  if ( $policydata ) {
   	  	 if ( $i <=5 ) {
         	foreach( $policydata as $policy ) {
               $audit_data .= "$policy\n";
               $i++;
         	}
         }	      
   	  }
   	  if ( $audit_data != "" ) {
   	  	$arrAudits[$check] = "'$audit_data'";
   	  } else {
   	  	$arrAudits[$check] = "NULL";
   	  }
   	
   }
   
   $insert_time =  date("YmdHis");   
   
   if ( $need_authorized != "" || !($uroles['nessus']) ) {
      $jobType="R";  #REQUEST JOB
      #DO not wrap $subnet / $SVRid with ticks '' as 'Null' is not Null
      $query = "INSERT INTO I3_jobs ( name, fk_name, username, job_TYPE, meth_SCHED, meth_TARGET, meth_CRED, meth_VSET,
         meth_CUSTOM, meth_CPLUGINS, meth_Wcheck, meth_Wfile, meth_Ucheck, meth_TIMEOUT, scan_ASSIGNED, scan_SUBMIT, 
         scan_next, scan_PRIORITY, status, notify ) VALUES (
         '$sname', $subnet, '$username', '$jobType', '$schedule_type', '$target_list', $I3crID, '$sid', '$custadd_type',
         $plugs_list, $arrAudits[w], $arrAudits[f], $arrAudits[u], '$timeout', $SVRid, '$insert_time', 
         '$requested_run', '3' , 'H', '$notify_email' ) ";
      $request = "for Approval";

      $subject = "INPROTECT scan request [$sname]";
      $message = "HELLO SOC TEAM, \tThe following User [ $username ] has requested a scan against:\n"
         ." $target_list\n\nPlease Promptly Accept/Reject the request!"
         ."Thank You\n\nThe SOC TEAM!\n";

      mail($adminmail, $subject, $message, "From: $mailfrom\nX-Mailer: PHP/" . phpversion());

      echo "needs authorization<br>";
      logAccess( "USER $username Submitted Scan Request [$sname]" );
   } else {
      if ( $op == "editrecurring" && $sched_id > 0 ) {
         $query = "UPDATE I3_job_schedule SET name='$sname', schedule_type='$schedule_type', day_of_week='$week_days',
             day_of_month='$dayofmonth', time='$time_value', email='$notify_email', meth_TARGET='$target_list',
             meth_CRED=$I3crID, meth_VSET='$sid', meth_CUSTOM='$custadd_type', meth_CPLUGINS=$plugs_list,
             meth_Wcheck=$arrAudits[w], meth_Wfile=$arrAudits[f], meth_Ucheck=$arrAudits[u], 
             meth_TIMEOUT='$timeout', next_CHECK='$requested_run', enabled='$is_enabled'
             WHERE id='$sched_id' LIMIT 1";
         logAccess( "USER $username Submitted $reccur_type JOB Schedule [$sname]" );
      } elseif ( $recurring ) {
         $query = "INSERT INTO I3_job_schedule ( name, username, schedule_type, day_of_week, day_of_month, time, email,
             meth_TARGET, meth_CRED, meth_VSET, meth_CUSTOM, meth_CPLUGINS, meth_Wcheck, meth_Wfile, meth_Ucheck, 
             meth_TIMEOUT, next_CHECK, createdate, enabled  ) VALUES (
          '$sname', '$username', '$schedule_type', '$week_days', '$dayofmonth', '$time_value', '$notify_email', 
          '$target_list', $I3crID, '$sid', '$custadd_type', $plugs_list, $arrAudits[w], $arrAudits[f], $arrAudits[u],
          '$timeout', '$requested_run', '$insert_time', '1' ) ";
         logAccess( "USER $username Submitted $reccur_type JOB Schedule [$sname]" );
      } else {
         $query = "INSERT INTO I3_jobs ( name, fk_name, username, job_TYPE, meth_SCHED, meth_TARGET,  meth_CRED, meth_VSET,
            meth_CUSTOM, meth_CPLUGINS, meth_Wcheck, meth_Wfile, meth_Ucheck, meth_TIMEOUT, scan_ASSIGNED, scan_SUBMIT, 
            scan_next, scan_PRIORITY, status, notify, authorized, author_uname ) VALUES (
         '$sname', $subnet, '$username', '$jobType', '$schedule_type', '$target_list', $I3crID, '$sid',
         '$custadd_type', $plugs_list, $arrAudits[w], $arrAudits[f], $arrAudits[u], '$timeout', $SVRid, '$insert_time', 
         '$requested_run', '3' , 'S', '$notify_email', '1', 'ACL' ) ";
         logAccess( "USER $username Submitted a Run Once JOB Schedule [$sname]" );
      }
   }

   echo "</table><br><br><b>";

   #$result = $dbconn->execute($query);
   $query_insert_time = gen_strtotime( $insert_time, "" );

   if ($dbconn->execute($query) === false) {
      echo "Error creating scan job: " .$dbconn->ErrorMsg();
      logAccess( " Error creating scan job $auname " );
      $error = 1;
   } else {
      if ( $op == "editrecurring" && $sched_id > 0 ) {
        $query2 = "SELECT id FROM I3_job_schedule WHERE id='$sched_id' AND username='$username'";
      } elseif ( $recurring ) {
         $query2 = "SELECT id FROM I3_job_schedule WHERE createdate='$query_insert_time' AND username='$username'";
      } else {
         $query2 = "SELECT id FROM I3_jobs WHERE scan_SUBMIT='$query_insert_time' AND username='$username'";
         $query2 = "SELECT id FROM I3_jobs WHERE scan_SUBMIT='$query_insert_time' AND username='$username'";
      }
      $result2 = $dbconn->execute($query2);
      list( $jid ) = $result2->fields;

      if ( $op == "editrecurring" && $jid > 0 ) {
         echo "Successfully Updated Recurring Job<br>";
         logAccess( "Updated Recurring Job [ $jid ]" );
      } elseif ( $jid ) {
         echo "Successfully Submitted Job $request<br>";
         logAccess( "Submitted Job [ $jid ] $request" );

      } else {
         echo "Failed Job Creation<br><br>";
         logAccess( "Failed Job Creation" );
      }
   }
   echo "</b></center>";
 
}

function auth_request($op, $rid) {
     global $dbconn;

     echo <<<EOT
<font face="Verdana" color="#666666" size="4">
     <center><h2>Current Scan Requests</h2></center></font><br><br>
EOT;

     if ($op != "" and $rid != ""){
          switch($op) {
               case "accept":
                    accept_request($rid);
                    break;
               case "reject":
                    reject_request($rid);
                    break;
                  break;
          }
          echo "<br>";
     }

     $query="SELECT id, username, meth_VSET, meth_TARGET, scan_SUBMIT
          FROM I3_jobs WHERE job_TYPE= 'R' AND authorized='0'
               ORDER BY scan_SUBMIT";

     $result = $dbconn->execute($query);

echo <<<EOT
<form method="post" action="sched.php?disp=auth_request">
     <table summary="Request Details"  width = 100%>
          <tr><td width="3%">&nbsp;</td>
          <td width="5%">&nbsp;</td>
          <td width="15%"><b>Username</b></td>
          <td width="40%"><b>Profile</b></td>
          <td><b>HOSTIP</b></td></tr>
     <tr><td colspan=5><hr></td></tr>
EOT;


     while (!$result->EOF) {
          list ($rid, $rname, $rsid, $rhostname) = $result->fields;

echo <<<EOT
          <tr>
          <td><a href="sched.php?disp=auth_request&op=accept&rid=$rid">Acc</a></td>
          <td><a href="sched.php?disp=auth_request&op=reject&rid=$rid">Rej</a></td>
          <td>$rname</td>
          <td>
EOT;

          echo getProfileName( $rsid );

          echo "</td>
          <td>$rhostname</td>";
          $result->MoveNext();
     }
     echo "</table>";

}

function reject_request($rid) {
     global $sitename, $username, $useremail, $mailfrom, $dbconn;

     $admin_email = $useremail;

     $query = "SELECT username, notify, meth_TARGET FROM I3_jobs
          WHERE id='$rid' LIMIT 1";
     $result = $dbconn->execute($query);

     list($requestee, $req_email, $hostip ) = $result->fields;

     echo "Denied Request to scan $hostip<br>";

     echo "<br>";

     $curtime = date("Y-m-d H:i:s");
     $query = "Update I3_jobs
          SET author_uname='$username', authorized='-1', status='C', scan_NEXT = Null
          WHERE id = '$rid' LIMIT 1";

     $result = $dbconn->execute($query);

     $mailto = "$req_email";

     if ( $mailto != $admin_email ) { $mailto .= ", $admin_email"; }

     $subject = "$sitename scan request declined";
     $message = "HELLO, $requestee\n\n"
          ."Your scan request for $hostip has been declined at this time.  If you feel, we have reached this decision by error; "
          ."Please contact the FEMA-SOC.\n\nThank You\n\nThe SOC TEAM!\n";

     mail($mailto, $subject, $message, "From: $mailfrom\nX-Mailer: PHP/" . phpversion());
     logAccess( "Rejected Scan Request for [ $requestee - $hostip ]" );

}

function accept_request($rid) {
     global $sitename, $username, $useremail, $mailfrom, $dbconn;

     $admin_email = $useremail;

     $query = "SELECT username, notify, meth_TARGET FROM I3_jobs
          WHERE id='$rid' LIMIT 1";
     $result = $dbconn->execute($query);

     list($requestee, $req_email, $hostip ) = $result->fields;

     echo "Accepted Scan Request for $hostip<br>";

     echo "<br>";

      $curtime = date("Y-m-d H:i:s");
     $query = "UPDATE I3_jobs
          SET author_uname='$admin_name', authorized='1', status='S'
          WHERE id='$rid' LIMIT 1";
     $result = $dbconn->execute($query);

     $mailto = "$req_email";

     if ( $mailto != $admin_email ) { $mailto .= ", $admin_email"; }

     $subject = "$sitename scan request declined";
     $message = "HELLO, $requestee\n\nAs per your request; A scan for $hostip will begin shortly once a free scan slot is available.\n\n"
          ."Thank You\n\nThe SOC TEAM!\n";

     mail($mailto, $subject, $message, "From: $mailfrom\nX-Mailer: PHP/" . phpversion());
     logAccess( "Authorized Scan Request for [ $requestee - $hostip ]" );
}

function kill_scan( $job_id ) {
     global $uroles, $sitename, $username, $useremail, $mailfrom, $dbconn;

     if ( $uroles['admin'] ) {
        $term_status = "Allowed";
        echo "Scan Terminated";
        echo "<br>";
        $query = "SELECT id, scan_SERVER FROM I3_jobs WHERE id='$job_id' LIMIT 1";
        $result = $dbconn->execute($query);
        list($kill_id, $nserver_id ) = $result->fields;

        $query = "UPDATE nessus_servers SET current_scans=current_scans-5 WHERE id='$nserver_id' LIMIT 1";
        $result = $dbconn->execute($query);

        $query = "UPDATE I3_jobs SET status='C' WHERE id='$kill_id' LIMIT 1";
        $result = $dbconn->execute($query);
     } else {
        $term_status = "Denied";
     }

     logAccess( "TERMINATE SCAN: [ $term_status by $username ]" );

     include("monitor.php");
}

switch($disp) {

   case "auth_request":
      auth_request ( $op, $rid );
   break;

   case "create":
      submit_scan( $op, $sched_id, $sname, $notify_email, $schedule_type, $ROYEAR,$ROMONTH, $ROday,
     $time_hour, $time_min, $week_days, $dayofmonth, $timeout, $SVRid, $sid, $tarSel, $ip_list,
     $ip_start, $ip_end,  $named_list, $cidr, $subnet, $cred_type, $credid, $smbacc, $smbdomain,
     $smbpass, $passtype, $passstore, $wpolicies, $wfpolicies, $upolicies, $custadd_type, $cust_plugins,
     $is_enabled );
   break;

   case "edit_sched":
      edit_schedule ( $sched_id );
   break;

   case "kill_scan":
      kill_scan ( $job_id );
   break;

   case "rerun":
      rerun ( $job_id );
   break;

   default:
      main_page( $job_id, $op );
      break;
}


function createHiddenDiv($name, $num, $data) {
   $text = "";
   $style = "";
   if($num == 0) {
      $style = "style='{display: block;}'";
   }
   $text = "<div id='section" . $num . "' name='$name' class='settings' $style>\n";
   $text .= $data;
   $text .= "</div>";
   return $text;
}

?>
