<?php
//
// $Id: scheduler.php,v 1.14 2006/09/21 12:34:35 airwofl Exp $
//

/***********************************************************/
/*          Inprotect             */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect             */
/*                           */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                   */
/*                           */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA          */
/*                           */
/* Contact Information:                */
/* inprotect-devel@lists.sourceforge.net         */
/* http://inprotect.sourceforge.net/             */
/***********************************************************/
/* See the README.txt and/or help files for more      */
/* information on how to use & config.           */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.        */
/*                           */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items    */
/* discovered with this program's use.           */
/***********************************************************/

$pageTitle = "Nessus Scan Schedule";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$myhostname="";

$getParams = array( 'disp', 'schedid', 'sortby', 'sortdir', 'viewall'
         );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
       if (isset($_GET[$gp])) { 
           $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
       } else { 
           $$gp="";
       }
    }
    $range_start="";
    $range_end="";
    break;
}

$query = "select count(*) from nessus_plugins";
$result = $dbconn->execute($query);
list($pluginscount) = $result->fields;

if ($pluginscount==0) {
    include_once('header2.php');
    die ("<h2>Please run updateplugins.pl script first before using web interface.</h2>");
}


function delete_sched( $schedid ) {
    global $viewall, $sortby, $sortdir, $uroles, $username, $dbconn;

    $sql_require = "";
    if ( ! $uroles['admin'] ) { $sql_require = "AND username='$username'"; }

    $query = "SELECT id, name FROM I3_job_schedule WHERE id = '$schedid' $sql_require";
    echo "query=$query<br>";
    $result=$dbconn->Execute($query);
    list( $jid, $nname ) = $result->fields;

    if ( $jid > 0 ) {
       $query = "DELETE FROM I3_job_schedule WHERE id = '$schedid' $sql_require";
       $result=$dbconn->Execute($query);

       echo "Deleted Reoccuring Schedule <i>\"$nname\"</i><br><br>";
       logAccess( "DELETED Reoccuring Schedule $nname" );
    } else {
       echo "Not Authorized to Delete Reoccuring Schedule <i>\"$nname\"</i>";
       logAccess( "UNAUTHORIZED ATTEMPT TO DELETED Reoccuring Schedule $nname" );
    }
    main_page ( $viewall, $sortby, $sortdir );
}

function main_page ( $viewall, $sortby, $sortdir ) {
    global $uroles, $username, $dbconn;

    if ($sortby == "" ) { $sortby = "name"; }
    if ($sortdir == "" ) { $sortdir = "ASC"; }

    if ( $uroles['admin'] ) {
        if($viewall == 1) {
            echo "&nbsp;<a href='scheduler.php'>View My Schedules</a>&nbsp;|&nbsp;";
        } else {
            echo "&nbsp;<a href='scheduler.php?viewall=1'>View All Schedules</a>&nbsp;|&nbsp;";
        }
    } else {
        $viewall = "1";
    }
    echo "<a href='sched.php?op=reoccuring'>New Schedule</a>&nbsp;|<br><br>";

    $sql_order="order by $sortby $sortdir";


    if($viewall == 1) {
       $url_sortby="<a href=\"scheduler.php?viewall=1&sortby=";
    } else {
       $url_sortby="<a href=\"scheduler.php?sortby=";
    }

   echo <<<EOT

   <table width="100%" summary="Job Schedules" 
        border=1 cellspacing="0" cellpadding="0" 
        style="border-collapse: collapse" >
   <t>
EOT;

   if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
   $arr = array("name", "schedule_type", "next_CHECK", "username", "Enabled","" );
   foreach ( $arr as $value) {
      echo "<th>".$url_sortby."$value&sortdir=$sortdir\">$value</a></th>";		
   }

echo <<<EOT
   </tr>
EOT;


// modified by hsh to return all scan schedules
    $query = "select id, name, schedule_type, meth_VSET, meth_TIMEOUT, username, enabled, date_format(next_CHECK, \"%W %M %e, %Y - %r\") 
            from I3_job_schedule ";
    if($viewall == 1) { // list all schedules
    } else { // view only logged in users schedules
       $query .= "where username='$username' ";
    }
    $query .= $sql_order;
    $result=$dbconn->execute($query);

    while (!$result->EOF) {
       list ($schedid, $schedname, $schedtype, $sid, $timeout, $username, $schedstatus, $nextscan)=$result->fields;

       switch ($schedtype) {
       case "N":
          $stt="Once (Now)";
          break;
       case "O":
          $stt="Once";
          break;
       case "D":
          $stt="Daily";
          break;
       case "W":
          $stt="Weekly";
          break;
       case "M":
          $stt="Monthly";
          break;
       case "Q":
          $stt="Quarterly";
          break;
       case "H":
          $stt="On Hold";
          break;
       default:
          $stt="&nbsp;";
          break;
       }

       switch ($schedstatus) {
       case "R":
          $itext="Running";
          $isrc="images/running.png";
          break;
       case "S":
          $itext="Scheduled";
          $isrc="images/sched.png";
          break;
       case "P":
          $itext="Pending";
          $isrc="images/hourglass.png";
          break;
       case "H":
          $itext="On Hold";
          $isrc="images/hourglass.png";
          break;
       case "C":
          $itext="Completed";
          $isrc="images/true.png";
          break;
       default:
          $itext="Scheduling";
          $isrc="images/question.png";
          $schedstatus="I";
       }

       if ( $schedstatus ) { 
          $txt_enabled = "<td>ENABLED</td>"; 
       } else { 
          $txt_enabled = "<td style=\"background-color:red;\">DISABLED</td>"; 
       }

       echo <<<EOT
<tr>
    <td>$schedname</td>
    <td>$stt</td>
    <td>$nextscan</td>
    <td>$username</td>
    $txt_enabled
    <td align="center"><img alt=$itext src=$isrc border=0 title=$itext>&nbsp;
    <a href="sched.php?disp=edit_sched&sched_id=$schedid"><img src="images/pencil.png"></a>&nbsp;
    <a href="scheduler.php?disp=delete&amp;schedid=$schedid" onclick="return confirmDelete();"><img src="images/delete.png"></a></td>
</tr>
EOT;

       $result->MoveNext();
    }
    echo <<<EOT
</table>
<br><a href="sched.php?op=reoccuring">New Schedule</a><br><br>
EOT;
}


switch($disp) {

    case "delete":
        delete_sched( $schedid );
        break;

    default:
       main_page( $viewall, $sortby, $sortdir );
       break;
}

require_once("footer.php");

?>
