<?php

//
// $Id: sites.php,v 1.10 2008/03/06 04:57:01 kkline Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Manage Infrastructure";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');


 $daysMap = array ( 
     "0" => "NONE", 
    "Su" => "Sunday",
    "Mo" => "Monday",
    "Tu" => "Tuesday",
    "We" => "Wednesday",
    "Th" => "Thursday",
    "Fr" => "Friday", 
    "Sa" => "Saturday"
          );

$getParams = array( "disp", "nid", "sid", "op", "sname", "site_code", "subname" );
$postParams = array( "disp", "nid", "sid", "op",  "confirm", "sname", "ssite", "sorg", "slocation", 
   "saddress", "sdescription", "spoc", "spoc2", "autoemail", "authscan", "sstatus", "serial", "sres_start", 
   "sres_cutoff", "sres_day", "naddr_line1", "naddr_line2", "ncity", "nstate", "nzipcode",
   "npoc", "nnnoc_poc", "site_code" );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

global $username;

if ( !$uroles['infrastructure'] && !$uroles['selfservice'] )  {
    echo "Insufficient rights to view this page.";
    require_once('footer.php');
    // should do this better, but it'll work for now.
    die();
} elseif ( !$uroles['infrastructure'] ) {

    if ( count( $usites ) > 1 ) {
    	echo <<<EOT
<br><table class="forumline" cellSpacing="1" cellPadding="3" border="0" width='100%'>
    <tr><td align="Right" width="25%">Associated Sites:  </td>
    <form method="post" action="sites.php">
    <TD align=LEFT><SELECT NAME="site_code">
EOT;

       $keys_sites = array_keys($usites);

      foreach($keys_sites as $value) {
         if ( $site_code == "" ) {
            $site_code = $value;
         } 
         if ( $site_code == $value ) {
            $txtselected = "SELECTED";
         } else {
            $txtselected ="";
         }
         echo "<OPTION VALUE=\"$value\" $txtselected >$value</OPTION>\n";

      }

      echo <<<EOT
</SELECT>
<input type="submit" name="submit" value="Filter" class="mainoption"></TD>
</form></tr>
</table><br></center><br>
EOT;

    } elseif ( count( $usites ) == 1 ) {
       $keys_sites = array_keys($usites);
       foreach($keys_sites as $value) {
          $site_code = $value;
       }
   }

   if ( $site_code == "" ) {
      die ( "<h3>$sitename: </h3>Please contact: &nbsp;&nbsp;<font color=red>$adminmail</font><br><br>"
         ."<b>ERROR:</b>&nbsp;<i>\"Your user account has not been associated to a Site/Region.\"</i>" );
   }
}

function navbar ( $nid ) {
   global $uroles, $dbconn;

   echo "<center><h3>Manage Sites</h3>
      [ <a href=\"sites.php\">Main</a> ]";
      if ($nid) {

         $query = "SELECT name FROM I3_sites WHERE id='$nid'";
         $result = $dbconn->execute($query);
         list($sitename) = $result->fields;

         echo " -> Edit Org [ <font color=red>$sitename</font> ] ( ";

         echo "<a href=\"sites.php?disp=info&nid=$nid\">OVERVIEW</a>";
         echo "| <a href=\"sites.php?disp=edit_site&nid=$nid\">NAME</a>";
         if ( $uroles['infrastructure'] || $uroles['selfservice']) {
            echo "| <a href=\"sites.php?disp=listsubnets&nid=$nid\">SUBNETS</a>";
         }
         echo " )";
      }
      echo "</center><br>";
}

function delete_site( $nid ) {
   global $enableADSubs, $uroles, $username, $dbconn;

   $query = "SELECT name, site_code FROM I3_sites WHERE id='$nid'";
   $result = $dbconn->execute($query);
   list( $site_name, $site_code ) = $result->fields;

   $authorized_to_delete = "0";

   if ( $enableADSubs && ( $uroles['infrastructure'] || $uroles['admin'] ) ) {
      $sql_require = "";
      if ( $uroles['admin'] ) {
         $authorized_to_delete = "1";
      } else {
         $user_sites = getSiteCodes ($username);
         $keys_sites = array_keys($user_sites);
         foreach($keys_sites as $value) {
            if ( $site_code == $value ) {
               $authorized_to_delete = "1";
            }
         }
      }
   }

   if ( $authorized_to_delete == "1" ) {
      $query = "DELETE FROM I3_subnets WHERE site_code='$site_code'";
      $result = $dbconn->execute($query);

      $query = "DELETE FROM I3_site_users WHERE siteID='$nid'";
      $result = $dbconn->execute($query);

      $query = "DELETE FROM I3_org_sites WHERE siteID='$nid'";
      $result = $dbconn->execute($query);

      $query = "DELETE FROM I3_sites WHERE id='$nid' LIMIT 1";
      $result = $dbconn->execute($query);

      echo "DELETED SITE \"$site_name\"";
      logAccess( "DELETED SITE [$site_name]" );
   } else {
      echo "ACCESS DENIED";
      logAccess( "UNAUTHORIZED ATTEMPT TO DELETED SITE [$site_name]" );
   }
   echo "<br>";
   show_subnets( );
}



function delete_subnet($nid, $sid ) {
   global $enableADSubs, $uroles, $username, $dbconn;

   $query = "SELECT CIDR, site_code, ORG FROM I3_subnets WHERE id='$sid'";
   $result = $dbconn->execute($query);
   list($subnet_name, $site_code, $org ) = $result->fields;

   if ( $enableADSubs && ( $uroles['infrastructure'] || $uroles['admin'] ) ) {
      $sql_require = "";
      if ( ! $uroles['admin'] ) {
         $user_org = getUserOrg ($username);
         $user_sites = getSiteCodes ($username);
         if ( $user_org == $org ) {
            $sql_requre = "AND ORG='$user_org'";
         } else {
            $keys_sites = array_keys($user_sites);

            foreach($keys_sites as $value) {
               if ( $site_code == $value ) {
                  $sql_requre = "AND site_code='$site_code'";
               }
            }
         }
      }
      if ( $uroles['admin'] || $sql_requre != "" ) {
        $query = "DELETE FROM I3_subnets WHERE id='$sid' $sql_requre LIMIT 1";
        $result = $dbconn->execute($query);
        echo "DELETED subnet \"$subnet_name\"";
        logAccess( "DELETED SUBNET [$subnet_name]" );
      } else {
       echo "ACCESS DENIED";
       logAccess( "UNAUTHORIZED ATTEMPT TO DELETED SUBNET [$subnet_name]" );
      }
   } else {
       echo "ACCESS DENIED";
       logAccess( "UNAUTHORIZED ATTEMPT TO DELETED SUBNET [$subnet_name]" );
   }
   echo "<br>";
   show_subnets( $nid );
}

function edit_site($nid ){
   global $dbconn;

   navbar ( $nid );

   if ( $nid ) {

      $query = "SELECT name, site_code, description, addr_line1, addr_line2, city, state, zipcode, 
      poc, nnoc_poc FROM I3_sites WHERE id='$nid'";

      $result = $dbconn->execute($query);

      list($sname, $site_code, $sdescription, $naddr_line1, $naddr_line2, $ncity, $nstate, $nzipcode,
         $npoc, $nnnoc_poc ) = $result->fields;

      echo "<b>Edit Site - \"$sname\"</b><br>";
   } else {
      echo "<b>Add new Site</b><br>";
   }
   echo <<<EOT
<form method="POST" action="sites.php">
   <input type="hidden" name="disp" value="save_site">
EOT;

   if ( $nid ) {
      echo "<input type=\"hidden\" name=\"nid\" value=\"$nid\">";
   }

   echo <<<EOT
<table width='100%'>
   <tr><td width="35%" align="right">Name:</td>
   <td><input type="text" name="sname" value="$sname" size="30" maxlength="50"></td>
   </tr>
   <tr><td align="right">SITE:</td>
   <td><input type="text" name="site_code" value="$site_code" size="15" maxlength="25"></td>
   </tr>   
   <tr><td align="right">Address Line 1:</td>
   <td><input type="text" name="naddr_line1" value="$naddr_line1" size="50" maxlength="100"></td>
   </tr>
   </tr>
   <tr><td align="right">Address Line 2:</td>
   <td><input type="text" name="naddr_line2" value="$naddr_line2" size="50" maxlength="100"></td>
   </tr>
   <tr><td align="right">City:</td>
   <td><input type="text" name="ncity" value="$ncity" maxlength="50"></td>
   </tr>
   <tr><td align="right">State:</td>
   <td><input type="text" name="nstate" value="$nstate" size="2" maxlength="2"></td>
   </tr>
   <tr><td align="right">Zipcode:</td>
   <td><input type="text" name="nzipcode" value="$nzipcode"  size="12" maxlength="10"></td>
   </tr>   
   <tr><td align="right">POC:</td>
   <td><input type="text" name="npoc" value="$npoc"></td>
   </tr>
   <tr><td align="right">ALT POC:</td>
   <td><textarea wrap="virtual" cols="70" rows="6" name="nnnoc_poc">$nnnoc_poc</textarea></td>
   </tr>
   <tr><td align="right">Description:</td>
   <td>
   <textarea wrap="virtual" cols="70" rows="15" name="sdescription">$sdescription</textarea>
   </td>
   </tr>
   <tr><td align="right">&nbsp;</td>
   <td><input type="submit" name="submit" value="Save"></td>
   </tr>
   </table>
   
   </form>
EOT;


}

function edit_subnet($nid, $sid, $op  ){
   global $confirm, $sname, $ssite, $sorg, $slocation, $saddress, $sdescription, 
   $spoc, $spoc2, $autoemail, $authscan, $sstatus, $serial, $sip_start, $sip_end, $range_size, $sres_start, 
   $sres_cutoff, $sres_day, $status, $auditable,
   $enableADSubs, $uroles, $daysMap, $subnetStateArray, $site_code, $username, $dbconn;

   $now = gen_timeasstr();

   if  ( $op == "savenew" ) {

      $query = "SELECT site_code FROM I3_sites WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list( $site_code ) = $result->fields;
      $sorg = $site_code;

      if ( ! $sres_start ) { $sres_start = "Null"; } else { $sres_start = "'$sres_start'"; }
      if ( ! $sres_cutoff ) { $sres_cutoff = "Null"; } else { $sres_cutoff = "'$sres_cutoff'"; }
      if ( ! $sres_day || $sres_day == "" ) { $sres_day = "Null"; } else { $sres_day= "'$sres_day'"; }
      if ( $serial == "1" ) { $serial_flag = "Y"; } else { $serial_flag = "N"; } 

      $insert = "INSERT INTO I3_subnets ( 
         CIDR, site_code, ORG, start_ip, end_ip, restrict_start, restrict_cutoff, restrict_day, 
         range_size, location, address, poc, poc_alt, description, tiScanApproval, tiAutoEmail, status,
         serial_flag, auditable, updatedBy ) VALUES (
         '$sname', '$site_code', '$sorg', '$sip_start', '$sip_end', $sres_start, $sres_cutoff, $sres_day,
         '$range_size', '$slocation', '$saddress', '$spoc', '$spoc2', '$sdescription', 
         '$authscan', '$autoemail', '$status', '$serial_flag', '$auditable', '$username' );";

      if (! $dbconn->execute($insert) === false ) {
         echo "sub - $sname has been created.</br><br>";
         logAccess( "SUBNET [ $sname ] CREATED");
      } else {
         echo "There was an error creating the new record.<br>";
         echo $dbconn->ErrorMsg();
         logAccess( "FAILED CREATE SUBNET [ $sname ]");
      }
      show_subnets($nid);
      exit;
   } elseif ( $op=="save"  ) {

      if ( $spoc == "" && $spoc2 == "" && $autoemail == "1" ) {
         $autoemail = 0;
         echo "<h4><font color=red>At Least one POC must be defined to utilize Autoemail report!</font></h4>";
      }

      $query_string = "description='$sdescription',
         location='$slocation', address='$saddress', poc='$spoc', poc_alt='$spoc2',  
         tiAutoEmail='$autoemail', updatedBy='$username', status='$status'";

      if ( $sres_start ) {
         $query_string .= ", restrict_start='$sres_start'";
      } else {
         $query_string .= ", restrict_start = Null";
      }

      if ( $sres_cutoff ) {
         $query_string .= ", restrict_cutoff='$sres_cutoff'";
      } else {
         $query_string .= ", restrict_cutoff = Null";
      }

      if ( $sres_day ) {
         $query_string .= ", restrict_day='$sres_day'";
      } else {
         $query_string .= ", restrict_day = Null";
      }
      if ( $serial == "1" ) { $serial_flag = "Y"; } else { $serial_flag = "N"; } 
      $query_string .= ", serial_flag='$serial_flag'";

      $query_restricted = "";
      if ( $uroles['infrastructure'] ) {
         $query_restricted = ", site_code='$ssite', ORG='$sorg', tiScanApproval='$authscan' ";
      }

      $query = "UPDATE I3_subnets
         SET $query_string $query_restricted
         WHERE id='$sid'";
      $result = $dbconn->execute($query);
      echo "sub - $sname has been updated.</br><br>";

      $ip = $_SERVER['REMOTE_ADDR'];

      $dbconn->execute("INSERT INTO log ( ip, username, action)
           VALUES ( '$ip', '$username', 'SUBNET [ $sname ] MODIFIED' )");

      show_subnets($nid);
      exit;
   } elseif ( $op=="edit" ) {
      navbar ( $nid );

      //check input
      if(is_numeric($sid)){

         $query = "SELECT CIDR, site_code, ORG, start_ip, end_ip, restrict_start, restrict_cutoff, restrict_day,
            range_size, location, address, poc, poc_alt, description, cntHosts, tiScanApproval, tiReadReceipt, 
            tiAutoEmail, status, serial_flag, auditable, updatedBy
            FROM I3_subnets
            WHERE id=$sid";
         $result = $dbconn->execute($query);

         list( $CIDR, $site_code, $ORG, $start_ip, $end_ip, $res_start, $res_cutoff, $res_day,
            $range_size, $location, $address, $poc, $poc_alt, $description, $cntHosts, $tiScanApproval, $tiReadReceipt,
            $tiAutoEmail, $status, $serial_flag, $auditable, $updatedBy ) = $result->fields;

         echo "<h5>Edit subnet: $CIDR</h5>";
         $op="save";
      } else{
         echo "It was a problem accessing the data";
      }
   } else {
      navbar ( $nid );

      echo "<h5>Add subnet: </h5><br>";
      $op="savenew";
   }

   if ( $serial_flag ) {
      $serial_checked = "checked ";
   } else {
      $serial_checked = "";
   }

   if ( $tiScanApproval ) { 
      $auth_checked = "checked ";
   } else {
      $auth_checked = "";
   }

   if ( $tiAutoEmail ) { 
      $autoemail_checked = "checked ";
   } else {
      $autoemail_checked = "";
   }

   if ( $status == "" ) { $status = "assigned"; }

   echo <<<EOT
<form method="POST" action="sites.php">
      <input type="hidden" name="disp" value="sub_edit">
      <input type="hidden" name="op" value="$op">
      <input type="hidden" name="nid" value="$nid">

EOT;

if ( $op == "savenew" ) {  
	echo <<<EOT
      <table width="100%">
      <tr><td align="right">SUBNET (CIDR)</td>
      <td><input type="text" name="sname" size='40' value=""> (EX: 192.168.0.0/24)</td>
      </tr>
      <tr><td align="right">Start IP</td>
      <td><input type="text" name="sip_start" size='15' value="">(EX: 192.168.0.0)</td>
      </tr>
      <tr><td align="right">End IP</td>
      <td><input type="text" name="sip_end" size='15' value="">(EX: 192.168.0.255)</td>
      </tr>
      <tr><td align="right">Range Size</td>
      <td><input type="text" name="range_size" size='8' value="">(EX: 256)</td>
      </tr>
      <tr><td align="right">Status</td>
      <td><SELECT NAME="status">
         <OPTION VALUE="Select Subnet Status" ></OPTION>
EOT;

   foreach ( $subnetStateArray as $tmpStatus ) {
      $tmpStatus = strtolower($tmpStatus);
      echo "<OPTION VALUE=\"$tmpStatus\" >$tmpStatus</OPTION>\n";
   }

   echo <<<EOT
   </SELECT>(EX: Assigned (Must be Assigned to be audited via cron))</td>
      </tr>
      <tr><td align="right">Serial</td>
      <td><input type="checkbox" name="serial" value="1" >(EX: Serial Block if checked (will not Audit))</td>
      </tr>
      <tr><td align="right">NNOC Auditable</td>
      <td><input type="checkbox" name="auditable" value="1" $auth_checked >(EX: Flag SNMP)</td>
      </tr>	
EOT;
	
	
} else {
	echo <<<EOT
      <input type="hidden" name="sid" value="$sid">
      <input type="hidden" name="sname" value="$CIDR">
      <table width="100%">
      <tr><td align="right">SUBNET (CIDR)</td>
      <td><b>$CIDR</b></td>
      </tr>
      <tr><td align="right">Start IP</td>
      <td>$start_ip</td>
      </tr>
      <tr><td align="right">End IP</td>
      <td>$end_ip</td>
      </tr>
      <tr><td align="right">Range Size</td>
      <td>$range_size</td>
      </tr>
EOT;

if ( $enableADSubs ) {
   echo <<<EOT
      <tr><td align="right">Status</td>
      <td><SELECT NAME="status">
         <OPTION VALUE="Select Subnet Status" ></OPTION>
EOT;

   foreach ( $subnetStateArray as $tmpStatus ) {
      $tmpStatus = strtolower($tmpStatus);
      if ( $status == $tmpStatus ) { $status_checked = "SELECTED"; } else { $status_checked = ""; }
      echo "<OPTION VALUE=\"$tmpStatus\" $status_checked>$tmpStatus</OPTION>\n";
   }

   echo <<<EOT
   </SELECT>(EX: Assigned (Must be Assigned to be audited via cron))</td>
      </tr>
      <tr><td align="right">Serial</td>
      <td><input type="checkbox" name="serial" value="1" >(EX: Serial Block if checked (will not Audit))</td>
      </tr>
      <tr><td align="right">NNOC Auditable</td>
      <td><input type="checkbox" name="auditable" value="1" $auth_checked >(EX: Flag SNMP)</td>
      </tr>	
EOT;
EOT;

} else {
   echo <<<EOT
      <tr><td align="right">Status</td>
      <td>$status</td>
      </tr>
      <tr><td align="right">Serial</td>
      <td>$serial_flag</td>
      </tr>
      <tr><td align="right">NNOC Auditable</td>
      <td>$auditable</td>
      </tr>	
EOT;
   }
      if ( $uroles['infrastructure'] ) {
   echo <<<EOT
   <tr><td align='right'>Site</td>
      <td><input type="text" name="ssite" size="25" maxlength="25" value="$site_code"></td>   
   </tr>
   <tr><td align='right'>ORG</td>
      <td><input type="text" name="sorg" size="25" maxlength="25" value="$ORG"> 
      &nbsp; (Should be same as Site unless managed by another site)</td>
   </tr>
EOT;
      }
	
	
}

   echo <<<EOT
      <tr><td align="right">Description</td>
         <td><textarea wrap="virtual" cols="70" rows="15" name="sdescription">$description</textarea></td>
      </tr>
      <tr><td align='right'>Restrict Start</td>
         <td><input type="text" name="sres_start" size="25" maxlength="50" value="$res_start">
         (EX: 04:00:00 => Only Start a Job after 4AM)</td>
      </tr>
      <tr><td align='right'>Restrict Cutoff</td>
         <td><input type="text" name="sres_cutoff" size="25" maxlength="50" value="$res_cutoff">
         (EX: 06:00:00 => Only start a Job Before 6AM)</td>
      </tr>
      <tr><td align='right'>Restrict Day</td>
         <td><SELECT name=sres_day>
EOT;

      foreach (  $daysMap as $day=>$dayName ) {
         if ( $day == $res_day ) { $selected = "SELECTED"; } else { $selected = ""; }
            echo "<OPTION value=$day $selected>$dayName</OPTION>";
         }
      echo <<<EOT
         </SELECT> (EX. run job on the follow day only)</td>
      </tr>      
      <tr><td align='right'>Location</td>
         <td><input type="text" name="slocation" size="25" maxlength="50" value="$location"></td>
      </tr>
      <tr><td align='right'>Address</td>
         <td><input type="text" name="saddress" size="50" maxlength="255" value="$address"></td>
      </tr>         
      <tr><td align='right'>POC</td>
         <td><input type="text" name="spoc" size="50" maxlength="255" value="$poc"></td>
      </tr>
      <tr><td align='right'>Alternate POC</td>
         <td><input type="text" name="spoc2" size="50" maxlength="255" value="$poc_alt"></td>
      </tr>
      <tr><td align='right'>Automated Email Results</td>
         <td><input type="checkbox" name="autoemail" value="1" $autoemail_checked ></td>
      </tr>
EOT;
      if ( $uroles['infrastructure'] ) {
         echo <<<EOT
<tr><td align='right'>Allowed to Scan</td>
   <td><input type="checkbox" name="authscan" value="1" $auth_checked ></td>
</tr>
EOT;
      } else {

         echo "<tr><td align='right'>Monthly SOC SCAN</td><td>";
         if ( $tiScanApproval ) { echo "YES"; } else { echo "NO"; }
         echo "</td></tr>";   
      }
      echo <<<EOT
      <tr><td align='right'>&nbsp;</td>
         <td><input type="submit" name="submit" value="Save"></td>
      </tr>
      </table>
      </FORM>
      <FORM><INPUT TYPE=button VALUE='Go Back' onclick=window.history.back()></FORM>
EOT;


}

function manage_site_users($nid) {
   global $dbconn;

   navbar ( $nid );

   $query = "SELECT name FROM I3_sites WHERE id='$nid'";
   $result = $dbconn->execute($query);
   list($sname) = $result->fields;

   echo <<<EOT
<TABLE width=100% border=0>
   <TR>\n<TD colSpan=3>
      <h4>Site "$sname" Access:</h4>\n</TD>
   </TR>
   <TR>
      <TD valign=top align=left width=150>
         <form method="post" onsubmit="placeInHidden('.', 'sel3', 'hide2');">
         <input type="hidden" name="disp" value="setusers">
         <input type="hidden" name="nid" value="$nid">
         <select id="sel3" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;

      $query = "SELECT t1.user_id, t1.username
         FROM TNS_users t1
         LEFT JOIN I3_site_users t2 on t1.user_id = t2.uid
         WHERE t2.siteID = '$nid'";
      $result = $dbconn->execute($query);

      while(list($nuid, $nuname) = $result->fields ) {
         echo "<OPTION value=\"$nuid\">$nuname</OPTION>\n";
         $result->MoveNext();
      }

      echo <<<EOT
   </SELECT>
         <input type="hidden" name="hide2" id="hide2" />
         <input type="submit" value="Save">
         </form>
      </td>
      <td align="center" valign="middle">
         <form>
         <input type="button" value="--&gt;" onclick="moveOptions(document.getElementById('sel3'), document.getElementById('sel4'));" /><br />
         <input type="button" value="&lt;--" onclick="moveOptions(document.getElementById('sel4'), document.getElementById('sel3'));" />
         </form>
      </td>
      <td valign=top align="left">
         <form method="post" onsubmit="placeInHidden('sel4');">
         <select name="selPHP[]" id="sel4" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;

      $query = "SELECT t1.pn_uname
         FROM users t1
         LEFT JOIN I3_site_users t2 ON t1.pn_uname = t2.pn_uname
            AND t2.siteID = '$nid'
         WHERE t2.pn_uname is Null ORDER BY t1.pn_uname";
      $result = $dbconn->execute($query);

      while(list($nuid, $nuname) = $result->fields ) {
         echo "<OPTION value=\"$nuid\" >$nuname</OPTION>\n";
         $result->MoveNext();
      }

      echo <<<EOT
</select>
   </form></TD></TR>
   <TR>\n<TD colSpan=3>\n
   <DIV id=role></DIV></TD></TR>
</TABLE>
EOT;

}

function save_site($nid, $sname, $site_code, $sdescription, $naddr_line1, $naddr_line2, $ncity, $nstate, $nzipcode,
         $npoc, $nnnoc_poc ){
   global $username, $dbconn;

   $dtinsert = gen_timeasstr();

   $flag=1;

   if($sname==""){
      $flag=0;
      $problemtext="Site Name name cannot be blank!";

      echo "<center><b>Error</b></center><br><br>"
         ."There was a problem saving configuration:<br />$problemtext<br><br>";
      exit;
   }

   $query = "SELECT id, site_code FROM I3_sites WHERE id='$nid'";
   $result = $dbconn->execute($query);
   list( $snid, $scode ) = $result->fields;

   if( $nid && $snid ){

      if ( $site_code != $scode ) {
         $query="UPDATE I3_subnets SET site_code='$site_code' WHERE site_code='$scode'";

         $result = $dbconn->execute($query);
         echo "Moving Subnets associated to [$scode] to site_code=[$site_code]<br>";
      }

      $query="UPDATE I3_sites SET name='$sname', site_code='$site_code', description='$sdescription', 
         addr_line1='$naddr_line1', addr_line2='$naddr_line2', city='$ncity', state='$nstate', 
         zipcode='$nzipcode', poc='$npoc', nnoc_poc='$nnnoc_poc' WHERE id='$snid'";
   } else {
      $query="INSERT INTO I3_sites
         ( name, site_code, description, addr_line1, addr_line2, city, state, zipcode, poc, nnoc_poc ) VALUES 
         ( '$sname', '$site_code', '$sdescription', '$naddr_line1', '$naddr_line2', '$ncity', '$nstate', '$nzipcode',
         '$npoc', '$nnnoc_poc')";
   }

   $result = $dbconn->execute($query);

   $dbconn->execute("INSERT INTO log ( ip, username, action)
           VALUES ( '$ip', '$username', 'SITE [ $sname ] MODIFIED' )");

   echo "Sucessfully added/Updated Site<br />";

   navbar ( $nid );


}

function save_subnet($sname, $ssite, $slocation, $saddress, $sdescription, $spoc, $spoc2, 
   $autoemail, $authscan, $serial ) {	
   global $baselineNewSubnet, $username, $useremail, $dbconn;

   if( $sname ){
      $query="INSERT INTO I3_Subnets
         ( CIDR, site_code, ORG, description, addr_line1, addr_line2, city, state, zipcode, 
            poc, nnoc_poc, restrict_day, tiScanApproval, tiAutoEmail, status, serial_flag, auditable  ) VALUES 
         ( '$sname', '$ssite', '$ssite', '$sdescription', '$naddr_line1', '$naddr_line2', '$ncity', '$nstate', '$nzipcode',
         '$spoc', '$spoc2', Null, '$authscan', '$autoemail', 'assigned', '$serial', 'Y' )";

       $result = $dbconn->execute($query);

       $dbconn->execute("INSERT INTO log ( ip, username, action)
           VALUES ( '$ip', '$username', 'SITE [ $sname ] MODIFIED' )");

       echo "Sucessfully added/Updated Site<br />";
       if ( $baselineNewSubnet ) {   
     		$insert_time =  date("Ymdhis");  	
     		$query = "INSERT INTO I3_jobs ( name , fk_name, username , job_TYPE, meth_SCHED , meth_TARGET ,
            	meth_TIMEOUT, scan_ASSIGNED, scan_SUBMIT , scan_next, scan_PRIORITY , status , notify, 
                	authorized, author_uname 
                ) VALUES (
                	'CRON - $sname', $subnet, '$username', 'C', 'N', '$sname', '1', Null,
                    '$insert_time', '$insert_time', '3' , 'S', '$useremail', '1', 'ACL' ) ";
     		$result = $dbconn->execute($query);
     		echo "Sucessfully Queued Subnet for Baseline<br />";       	  	
       }
   }

   add_subnet($nid, $ssite, $slocation, $saddress, $sdescription, $spoc, $spoc2, 
   $autoemail, $authscan, $serial );
   
   
}

function show_subnets($nid) {
   global $enableADSubs, $uroles, $enableADSubs, $username, $dbconn;

   navbar ( $nid );

   if ( $nid == "" OR !is_numeric($nid)) {
      die ("Invalid LanID specificied");
   }

   #Lookup all subnets associated with siteID by matching Site.  Then get subnet_info based on matching CIDR.

   $query = "SELECT t1.id, t1.CIDR, t1.status, t1.site_code, t1.ORG, t1.location, t1.description,
      t1.poc, t1.poc_alt, t1.tiAutoEmail
   FROM I3_subnets t1
      LEFT JOIN I3_sites t2 on t1.site_code = t2.site_code OR t1.ORG = t2.site_code
   WHERE  t2.id = '$nid' ORDER BY CIDR";

   $result = $dbconn->execute($query);

   echo <<<EOT
<B>Network Subnet Managment</B><br><br>
   <table border=1 width=100% border=1 cellspacing="0" cellpadding="0" style="border-collapse: collapse" >
      <tr>
         <td>Au</td>
         <td>Sub Name</td>
         <td>Status</td>
         <td>SITE->ORG</td>
         <td>Location</td>
         <td>Description</td>
         <td>Point of Contact</td>
         <td>Alt Point of Contact</td>
         <td></td>
      </tr>
EOT;

   while ( !$result->EOF ) {
      list( $subid, $subname, $substatus, $subsite, $suborg, $subloc, $subdescription, $spoc, $spoc2, $tiAutoEmail ) = $result->fields;

      if ( $tiAutoEmail ) {
         echo "<tr><td><img src=\"images/checkmark.png\"></td>";
      } else {
         echo "<tr><td></td>";
      }

      echo "<td>$subname</td>";

      if ( $substatus == "available" ) {
         echo "<td style=\"background-color:BurlyWood;\">$substatus </td>";
      } else {
         echo "<td>$substatus </td>";
      }

      if ( $subsite == $suborg ) {
        $org_struct = $subsite;
      } else {
        $org_struct = "$subsite-\>$suborg";
      }

      echo <<<EOT
      <td>$org_struct</td>
      <td>$subloc</td>
      <td>$subdescription</td>
      <td>$spoc</td>
      <td>$spoc2</td>
      <td align="center"><a href="sites.php?disp=sub_edit&nid=$nid&sid=$subid&op=edit"><img src="images/pencil.png"></a>&nbsp;
EOT;
      
   if ( $enableADSubs && $uroles['admin'] ) {
      echo <<<EOT
   <a href="sites.php?disp=sub_delete&nid=$nid&sid=$subid" onclick="return confirmDelete();"><img src="images/delete.png"></a>
EOT;
   }   
echo <<<EOT
      </td>

</tr>
EOT;
      $result->MoveNext();
   }

   echo "</table>";
   if ( $enableADSubs && $uroles['infrastructure'] ) {
   	  echo <<<EOT
   	  <br><A href="sites.php?disp=sub_edit&nid=$nid&op=add">Add New Subnet</A>  
EOT;
   }
}

function update_site_users( $nid, $hide2 ) {
   global $sitename, $username, $dbconn;

   if ( $nid ) {
      $query = "DELETE FROM I3_site_users WHERE siteID='$nid'";
      $result = $dbconn->execute($query);
   }

   if ( $nid && $hide2 ) {

      $query = "SELECT name FROM I3_sites WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list($name) = $result->fields;
      echo _UPDUSERS.": [$name]<br>";

      $selSplit = explode(".", $hide2);
      foreach ($selSplit as $nuser) {

         if ($nuser) {
            $query = "INSERT INTO I3_site_users (uid, siteID) 
               VALUES ('$nuser', $nid );";
            $result = $dbconn->execute($query);
            #echo "sql=$query<br>";
            #echo "inserting username=$nuser   siteID=$siteID<br>";
         }
      }
   }

   $ip = $_SERVER['REMOTE_ADDR'];

   $dbconn->execute("INSERT INTO log ( ip, username, action)
        VALUES ( '$ip', '$username', 'SITE [ $name ] ACCESS MODIFIED' )");

   echo "<br>";

   manage_site_users($nid);
}

function view_subnets($subname) {
   global $username, $dbconn;


   $query = "SELECT t1.id, t2.id, t1.CIDR, t1.ORG, t1.restrict_start, t1.restrict_cutoff, t1.restrict_day, t1.location, t1.address, 
      t1.description, t1.poc, t1.poc_alt, t1.cntHosts, t1.tiScanApproval, t1.tiReadReceipt, t1.tiAutoEmail, t1.updatedBy
   FROM I3_subnets t1
      LEFT JOIN I3_sites t2 on t1.ORG = t2.site_code
   WHERE t1.CIDR = '$subname'";

   $result = $dbconn->execute($query);
   $row = $result->fields;

   if ($row[0] == "" ) {
      echo "<b>NO MATCH FOUND</b>";
      exit;
   }
   $nid = $row[1];

   navbar ( $nid );

   echo <<<EOT
<h4>SUBNET:  $row[2] </h4>
<table width="100%" summary="Search results" border=1 style="border-collapse: collapse" cellspacing="5" cellpadding="2" >
   <tr><td width="35%" align="right"><h4><b>ATTRIBUTES</b></h4></td>
      <td ><h4><b>VALUE</b></h4></td></tr>
EOT;

   foreach ($row as $k => $v) {
      if ( !is_numeric($k) ) {
            echo "<tr><td align=\"right\">$k</td><td>$v</td></tr>";
      }
   }

   echo <<<EOT
</table>
<FORM method=post>
   <input type="hidden" name="disp" value="sub_edit">
   <input type="hidden" name="nid" value="$nid">
   <input type="hidden" name="sid" value="$row[0]">
   <input type="hidden" name="op" value="edit">
   <INPUT TYPE="submit" NAME="go" VALUE="Edit" onClick="sendRequest('sites.php', 'content', this.form )">
   </FORM>
EOT;

}

function show_sites() {
   global $enableADSubs, $uroles, $username, $site_code, $dbconn;

   $sql_filter ="";
   navbar ( "" );

   if ( $site_code != "" ) { $sql_filter= "WHERE site_code='$site_code' "; }
   
   $query = "SELECT id, name, site_code, description, city, state, poc, report_sent
   FROM I3_sites $sql_filter ORDER by name";

   $result = $dbconn->execute($query);

   echo <<<EOT
<B>DEFINED Sites</B><BR>
<table border=1 width="100%">
<tr>
   <td>Auto Notify</td>
   <td width="5">View</td>
   <td width="5">Send</td>
   <td>Name</td>
   <td>site_code</td>
   <td>City</td>
   <td>State</td>
   <td>POC Email</td>
   <td></td>
   </tr>
EOT;

   while (!$result->EOF) {
      list($siteid, $sname, $site_code, $sdescription, $city, $state, $poc, $emailed_results 
         ) = $result->fields;

      $query2 = "SELECT count( t1.tiAutoEmail ) FROM I3_subnets t1
         LEFT JOIN I3_sites t2 ON t1.site_code = t2.site_code OR t1.ORG = t2.site_code
         WHERE t2.id = '$siteid' AND t1.status != 'available' AND t1.tiAutoEmail = '0'";
      $result2 = $dbconn->execute($query2);

      list( $cntManual ) = $result2->fields;

      echo "<tr>
         <td><A href=\"sites.php?disp=listsubnets&nid=$siteid\">";
      if (  $cntManual == "0" ) {
         echo "<img src=\"images/checkmark.png\">";
      } else {
         echo "<font size=\"4\" color=\"red\">$cntManual</font>";
      }
      echo <<<EOT
</a></td>
<td align="center">
<a href="suboverview.php?site_code=$site_code" target="_blank">
   <img src="images/pdf.png" border="0" >
</a>
</td>
EOT;

      if ( $uroles['admin'] && !  $emailed_results ) {
         echo <<<EOT

<td align="center">
<a href="suboverview.php?site_code=$site_code&amp;mail_report=1" target="_blank">
   <img src="images/email.png" border="0" >
</a>
</td>
EOT;
      } else {
         echo "<td>&nbsp;</td>";
      }

      echo <<<EOT
   <td>$sname</td>
   <td>$site_code</td>
   <td>$city</td>
   <td>$state</td>
   <td>$poc</td>
   <td align="center"><a href="sites.php?disp=info&nid=$siteid"><img src="images/zoom.png"></a>&nbsp;
   <a href="sites.php?disp=edit_site&nid=$siteid"><img src="images/pencil.png"></a>&nbsp;
EOT;
   if ( $enableADSubs && $uroles['admin'] ) {
      echo <<<EOT
   <a href="sites.php?disp=site_delete&nid=$siteid" onclick="return confirmDelete();"><img src="images/delete.png"></a>
EOT;
   }   
      echo <<<EOT
   </td>
   </tr>
EOT;
      $result->MoveNext();
   }

   echo <<<EOT
</table><br>
EOT;
   if ( $uroles['infrastructure'] ) {
      echo <<<EOT
<a href="sites.php?disp=add">Add new site</A>
EOT;
   }


}

function site_info ( $nid ) {
   global $dbconn;

   navbar ( $nid );

   $query = "SELECT name, site_code, description, addr_line1, addr_line2, city, state, zipcode, poc, nnoc_poc 
      FROM I3_sites WHERE id='$nid' LIMIT 1";
   $result = $dbconn->execute($query);

   $row = $result->fields;
   $sname = $row[0];

   if (!$row) {
      echo "[ $nid ] - NO MATCH FOUND";
   } else {

      echo <<<EOT
<font color="red">
   <h5>SITE [ $sname ]</h5></font>
   <table width="100%" summary="Search results" border=1 style="border-collapse: collapse" cellspacing="5" cellpadding="2" >
      <tr><td width="%25" align="right"><h5><b>ATTRIBUTES</b></h5></td>
      <td ><h5><b>VALUE</b></h5></td></tr>
EOT;
	  if ( !empty( $row)) {
         foreach ($row as $k => $v) {
            if ( !is_numeric($k) ) {
               if ( $k == "nnoc_poc" ) {
                  $v = str_replace("\n", "<br>", $v);
                  $v = str_replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;", $v);
               }
               echo "<tr><td align=\"right\">$k</td><td>$v</td></tr>";
            }
         }
	  }
      echo "</table><br>";
   }

   $query = "SELECT t1.username
      FROM TNS_users t1
      LEFT JOIN I3_org_users t2 on t1.user_id = t2.uid
      LEFT JOIN I3_org_sites t3 on t2.orgID = t3.orgID
      WHERE t3.siteID = '$nid'";

   $result = $dbconn->execute($query);

      echo <<<EOT
<font color="red">
   <h5>REPORT ACCESS [ $sname ]</h5></font>
   <table width="100%" summary="Search results" border=1 style="border-collapse: collapse" cellspacing="5" cellpadding="2"   >
EOT;
   if ( !empty( $result)){
      while( !$result->EOF ) {
   	     list($suser ) = $result->fields;
         echo "<tr><td>$suser</td></tr>";
         $result->MoveNext();
      }
   }
   echo "</table>";

}

switch($disp) {

   case "add":
      edit_site('');
      break;

   case "edit_site":
      edit_site($nid);
      break;

   case "editusers":
      manage_site_users($nid);
      break;

   case "info":
      site_info($nid);
      break;

   case "listsubnets":
      show_subnets($nid);
      break;

   case "save_site":
      save_site($nid, $sname, $site_code, $sdescription, $naddr_line1, $naddr_line2, $ncity, $nstate, $nzipcode,
         $npoc, $nnnoc_poc );
      break;

   case "setusers":
      update_site_users( $nid, $hide2 );
      break;

   case "site_delete":
      delete_site ( $nid );
      break;

   case "sub_delete":
      delete_subnet( $nid, $sid );
      break;

   case "sub_edit":
      edit_subnet($nid, $sid, $op );
      break;

   case "sub_view":
      view_subnets($subname);
      break;

   default:
      show_sites();
      break;

}


require_once('footer.php');

?>