
DROP TABLE IF EXISTS `I3_system_users`;

CREATE TABLE IF NOT EXISTS `I3_system_users` (
`sysID` int( 11 ) NOT NULL default '0',
`pn_uname` varchar( 255 ) NOT NULL default ''
) ENGINE = MYISAM DEFAULT CHARSET = latin1;

CREATE TABLE `I3_ISVM` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`name` VARCHAR( 255 ) NOT NULL ,
`dt_release` DATE NOT NULL ,
`dt_ackdue` DATE NOT NULL ,
`dt_compliance` DATE NOT NULL ,
`dt_ackon` DATE NOT NULL ,
`dt_complied` DATE NOT NULL ,
`description` TEXT NOT NULL ,
`dtcreated` DATETIME NOT NULL ,
`archived` ENUM( '0', '1' ) NOT NULL DEFAULT '0',
UNIQUE ( `name` )
) ENGINE = MYISAM CHARACTER SET latin1 COLLATE latin1_bin AUTO_INCREMENT=1 ;

UPDATE inprotect_settings SET settingSection='Maintainence' WHERE settingName='maxScanAge';

UPDATE inprotect_settings SET settingValue='1.00.0_alpha_15' WHERE settingName='version';

