-- change the necessary table columns back to case insensitive
ALTER TABLE log CHANGE `username` `username` varchar(255) default NULL;
ALTER TABLE nessus_hosts CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE nessus_live_stats CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE nessus_notes CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE nessus_results CHANGE `username` `username` varchar(255) default NULL;
ALTER TABLE nessus_schedule CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE nessus_servers CHANGE `owner` `owner` varchar(255) NOT NULL default '';
ALTER TABLE nessus_settings CHANGE `owner` `owner` varchar(255) NOT NULL default '';
ALTER TABLE nessus_settings_users CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE nessus_user_zones CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE nessus_zones CHANGE `owner` `owner` varchar(255) NOT NULL default '';
ALTER TABLE portscan CHANGE `username` `username` varchar(255) NOT NULL default '';
ALTER TABLE users CHANGE `pn_uname` `pn_uname` varchar(255) NOT NULL default '';

-- add new setting to inprotect_settings table
INSERT INTO `inprotect_settings` (`settingName`, `settingValue`, `settingDescription`, `settingSection`) VALUES 
('admin_notifications', 'admins@domain.com', 'Admin Notification Email Address', 'Mail');

-- adds new field to nessus_results to store the FQDN for a scan result
alter table nessus_results add column fqdn VARCHAR(255);

-- add new fields to users table for first and last names, default to empty
alter table users add column first_name varchar(55) NOT NULL default "";
alter table users add column last_name varchar(55) NOT NULL default "";
