<?php
//
// $Id: servers.php,v 1.10 2006/09/19 04:57:01 airwofl Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Scanners";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "disp", "op", "hostid", "hostip", "find", "type" );
$postParams = array( "disp", "op", "nid", "hostid", "hostip", "find", "type"
              );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

function view_details ( $hostid, $hostip ) {
	global $hostScanStateArray, $sitename, $pageSize, $dbconn;	
	

	$base_url = "hostsearch.php";	
	
echo <<<EOT

<br><font color="red">
<h4>HOST MATCH [$hostip]</h4></font>
<table width="100%" summary="Search results" border=1 >
<tr valign="top"><td width="600">
<table width="100%" summary="Scan results" 	border=1 >
	<tr><td>&nbsp;</td><td align="left"><h4><b>Scantime(s)</h4></td>
EOT;

    	
    $query = "SELECT distinct(t1.scantime), t1.report_id, t2.scantype, t2.report_key
    	FROM nessus_results t1
    	LEFT JOIN nessus_reports t2 on t2.report_id = t1.report_id
    	WHERE hostIP = '$hostip' ORDER BY scantime DESC";

    #echo "sql=$query<br>";    
    
    $result = $dbconn->execute($query);
    
	while ( !$result->EOF ) {
    	list( $scantime, $report_id, $scantype, $report_key ) = $result->fields;    

		$url_filter = "scantime=$scantime&scantype=$scantype&filterip=$hostip&key=$report_key";
		
		echo <<<EOT
<tr>
	<td align="right">
		<a href="reshtml.php?$url_filter">
			<img alt="HTML" src="images/html.png" border=0 title="Report in HTML format"></A>
			&nbsp;
			<a href="respdf.php?$url_filter" target="_blank">
			<img alt="PDF" src="images/pdf.png" border=0 title="Report in PDF format"></A>			
			</td>
			<td>$scantime</td>
			</tr>
EOT;
		$result->MoveNext();
	}
	
	echo "</table></td><td align=\"left\">";
	
	
	#hostip='hostip'
	
	$query ="SELECT hostip, hostname, os, status, description, contact, id, scanstate
           from hosts WHERE id = '$hostid' Limit 1"; 	

	if ($hostip != "") {	
		$result = $dbconn->execute($query);
		$numrows = $result->NumRows();
	}
		
	if ($numrows == 0) {
		echo "<b>NO HOST OS/CONTACT RECORD FOUND</b>";
		
	} else {
   		$result = $dbconn->execute($query);

   		$row = $result->fields;

		echo "<table width=\"100%\" summary=\"Host Attributes\" 
		border=1 style=\"border-collapse: collapse\"
		cellspacing=\"5\" cellpadding=\"2\"
		>
		<tr><td width=\"%25\" align=\"right\"><h4><b>ATTRIBUTES</b></h4></td>
		<td ><h4><b>VALUE</b></h4></td></tr>";
		
		foreach ($row as $k => $v) {
			if ( !is_numeric($k) ) {
   				echo "<tr><td align=\"right\">$k</td><td>$v</td></tr>";
			}
		}
		echo "</table>";
	}
	
	echo "</td></tr></table>";
	
}


function listall( $find, $type ) {
	global $hostScanStateArray, $sitename, $pageSize, $dbconn;

	$base_url = "hostsearch.php";	
	
	echo "<H3>Hosts</H3>";

	if ( $find == "" ) { $type = ""; }
	
   $viewFORM = FALSE;
   $querys="SELECT hostip, hostname, os, status, description,
              contact, id, scanstate
           from hosts";
   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "ip":
      $q = $find;
      $queryw = " where hostip LIKE '%$q%' order by INET_ATON(hostip) ASC ";
      $stext =  "Search for ip = '*$q*'";
      break;
   case "name":
      $q = strtolower($find);
      $queryw = " where hostname LIKE '%$q%' order by hostname";
      $stext =  "Search for name = '*$q*'";
      break;
   case "contact":
      $q = strtolower($find);
      $queryw = " where contact LIKE '%$q%' order by hostname";
      $stext = "Search for contact = '*$q*'";
      break;
   case "desc":
      $q = strtolower($find);
      $queryw = " where description LIKE '%$q%' order by hostname";
      $stext = "Search for description = '*$q*'";
      break;
   case "status":
      $q = strtolower($find);
      $queryw = " where status LIKE '%$q%' order by hostname";
      $stext = "Search for status = '*$q*'";
      break;
   case "scanstate":
      $queryw = " where scanstate = '$scanstate' order by hostname";
      $stext = "Search for scanstate = '$scanstate'";
      break;
   default:
      $viewFORM = TRUE;
      $stext = "Input Search Criteria";
      break;
   }

   // put link to add new host
   echo "<p>";
   echo $stext;
   echo "";
   echo "</p>";
   // echo the search criteria used
   
   #exit;
   // set up the pager and search fields if viewing all hosts
   $hostCount = 0;
   if($viewFORM) {

      echo <<<EOT
<!--<form name="hostSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="$base_url" method="POST">
<input type="text" length="25" name="find">
<input type="radio" name="type" value="ip">IP
<input type="radio" name="type" value="name" checked>Name
<input type="radio" name="type" value="status">Status
<input type="radio" name="type" value="contact">Contact
<input type="radio" name="type" value="desc">Description
<input type="hidden" name="op" value="search">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;

   } else {
      // get the search result count
      $query = "SELECT count(id)
                 FROM hosts".$queryw;
      $result = $dbconn->execute($query); 
      list($scount) = $result->fields; 

      echo "<p>$scount host";
      if($scount != 1) {
         echo "s";
      } else {
      }
      echo " found matching search criteria | "; 
      echo " <a href='$base_url' alt='View All Hosts'>New Search</a></p>";


   // set up the table and column headers
   echo <<<EOT
<table summary="Hosts" width="100%" border=1 cellspacing="0" cellpadding="2">
<tr>
<th>Hostname</th>
<th>IP</th>
<th>O/S</th>
<th>Status</th>
<th>Description</th>
<th>Contact</th>
<th>Scan State</th>
<th></th>
</tr>
EOT;
   // get the hosts to display
   $result = $dbconn->execute($querys.$queryw);
   while( $data = $result->fields ) {
      #$hlink = hostLink($data[hostname],$data[hostip],'name',true);
      #$ilink = hostLink($data[hostname],$data[hostip],'hostip',true);
      echo <<<EOT
<tr>
<td><a href='$base_url?disp=view&hostid=$data[id]&hostip=$data[hostip]' title='Search for results'>$data[hostname]</a></td>
<td><a href='$base_url?disp=view&hostid=$data[id]&hostip=$data[hostip]' title='Search for results'>$data[hostip]</a></td>
<td>$data[os]</td>
<td>$data[status]</td>
<td>$data[description]</td>
<td>$data[contact]</td>
<td>$data[scanstate]</td>
<td><a href='$base_url?disp=view&hostid=$data[id]&hostip=$data[hostip]' title='Search for results'><img src='images/zoom.png'></a></td>
</tr>
EOT;
		$result->MoveNext();
   }

   echo "</table>";

   }	
	include("footer.php");
}


switch($disp) {

	case "view":
		view_details ( $hostid, $hostip );
		break;
	
    default:
	   listall( $find, $type );
	   break;
}

?>