<?php
//
// $Id: control.php,v 1.4 2006/08/10 17:19:32 airwofl Exp $
//

$pageTitle = "Dashboard";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');

$pageSize = 25;

$getParams = array( "disp", "offset", "sortby", "sortdir" );
$postParams = array( "disp", "importisvm", "type", "value", "importplugins", "isCVE" );

switch ($_SERVER['REQUEST_METHOD']) {
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES);
      } else { 
         $$gp="";
      }
   }
   $range_start="";
   $range_end="";
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES);
      } else { 
         $$pp="";
      }
   }
   break;
}

if(isset($offset)) {
   if(!is_numeric($offset)) {
      $offset=0;
   }
} else {
   $offset=0;
}

if( (!($uroles['isvmView'] || $uroles['isvmAdmin'] ))) {
    echo "Insufficient rights to view this page.";
    require_once('footer.php');
    // should do this better, but it'll work for now.
    die();
}


$query = "select count(*) from nessus_plugins";
$result = $dbconn->execute($query);
list($pluginscount)=$result->fields;

if ($pluginscount==0) {
   die ("<h2>Please run updateplugins.pl script first before using web interface.</h2>");
}



function navbar ( $nid ) {
   global $disp, $uroles, $dbconn;

   echo <<<EOT
<center><h3>Manage ISVM</h3>
      [ <a href="isvm.php">Main</a> ]
EOT;
  
   if ($nid) {

      $query = "SELECT name FROM I3_ISVM WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list( $sysname ) = $result->fields;

      echo <<<EOT
 -> Edit isvm [ <font color=red>$sysname</font> ] ( 
<a href="isvm.php?disp=view&nid=$nid">INFO</a>
| <a href="isvm.php?disp=edit_isvm&nid=$nid">NAME</a>
| <a href="isvm.php?disp=linkplugins&nid=$nid">PLUGINS</a> )
EOT;
   }
   echo "</center><br>";
   if (  $uroles['isvmAdmin'] && $disp =="" ) {
      echo <<<EOT
      	<A HREF="isvm.php?disp=import" >Import ISVM</a><br>
EOT;
   }
   
   
   
}

function add_isvm (  ) {
   global $dbconn;

   echo "<H3>ADD ISVM</H3>";

   $formFields = array ( "Name" => array( "name" => "name",
                                              "type" => "input",
                                              "size" => 20,
                                              "value" => $iname),
                         "ISVM TYPE" => array( "name" => "isvm_TYPE",
                                              "type" => "input",
                                              "size" => 32,
                                              "value" => $isvm_TYPE),
                         "ISVM LINK" => array( "name" => "isvm_LINK",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $isvm_LINK),
                         "Dt Release" => array( "name" => "dt_release",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $os),
                         "Dt Ack Due" => array( "name" => "dt_ackdue",
                                                "type" => "input",
                                                "size" => 32,
                                                "value" => $os),
                         "Dt Compliance Due" => array( "name" => "dt_compliance",
                                                "type" => "input",
                                                "size" => 60,
                                                "maxsize" => 255,
                                                "value" => ""),
                         "Description" => array( "name" => "description",
                                                "type" => "input",
                                                "size" => 50,
                                                "value" => ""));

      $formButtons = array( "Submit" => array( "name" => "submit",
                                               "type" => "submit",
                                               "value" => "Save"));
      $formHidden = array( "disp" => "save_new",
                           "ref" => $ref );
      $formData = array( "summary" => "Create Host Entry",
                         "fields" => $formFields,
                         "hidden" => $formHidden,
                         "buttons" => $formButtons);
      drawForm($formData,$_SERVER['PHP_SELF']);
}

function add_plugins ($nid, $importplugins, $isCVE ) {
   global $username, $dbconn;
 
   if ( $nid && $importplugins ) {

      if ( strlen($importplugins) > 0 ) {	 
        $importplugins  = str_replace("\\r\\n", "<br>", $importplugins  );	
        $importplugins  = str_replace(", ", "<br>", $importplugins  );
        if ( $isCVE == "1" ) {
           $cves = explode( "<br>", $importplugins );
           $importplugins = "";
		   foreach( $cves as $cve ) {
		   	  echo "looking up cve=[$cve]<br>";
              $query = "SELECT id FROM plugins WHERE cve_id LIKE '%$cve%'";
              $result = $dbconn->execute($query);
              while( !$result->EOF ) {
   	             list( $plugid ) = $result->fields;
   	             $importplugins .= "$plugid<br>";
                 $result->MoveNext();
              }
		   }
        }
        $rows = explode( "<br>", $importplugins ); 
        foreach($rows as $row) {
        	$query = "SELECT t1.id FROM nessus_plugins t1
               LEFT JOIN I3_ISVM_plugins t2 ON t1.id = t2.nessus_id AND t2.iid = '$nid'
                  WHERE t1.id = '$row' AND t2.nessus_id IS NULL";
            $result = $dbconn->execute($query);
            list( $plugid  ) = $result->fields;
        	if ( $plugid > 0 ) {
        	   echo "added isvm=[$nid] plugin=[$plugid]<br>";
               $query = "INSERT INTO I3_ISVM_plugins ( iid, nessus_id ) VALUES ( '$nid', '$plugid' );";
               $result = $dbconn->execute($query);               
        	}
         }
      }
   #$dbconn->execute("INSERT INTO log ( ip, username, action)
   #   VALUES ( '$ip', '$username', 'isvm.PHP update associated isvm for isvm $sysname' )");
   
   }
   
   echo "<br>";

}

function edit_isvm($nid ){
   global $username, $dbconn;

   navbar ( $nid );

   if ( $nid ) {

      $query = "SELECT id, name, isvm_TYPE, isvm_LINK, dt_release, dt_ackdue, dt_compliance, dt_ackon, dt_complied, 
         description, archived FROM I3_ISVM WHERE id='$nid'";
      $result = $dbconn->execute($query);
      list( $nid, $nname, $nisvm_TYPE, $nisvm_LINK, $ndt_release, $ndt_ackdue, $ndt_compliance, $ndt_ackon, $ndt_complied, 
         $ndescription, $narchived  ) = $result->fields;

      echo "<b>Edit ISVM - \"$nname\"</b><br>";
   } else {
      echo "<b>Add new ISVM</b><br>";
   }
   
   if ( $narchived ) { 
      $narchived_checked = "checked ";
   } else {
      $narchived_checked = "";
   }   
   
   echo <<<EOT
<form method="POST" action="isvm.php">
<input type="hidden" name="disp" value="save_isvm">
EOT;

   if ( $nid ) {
      echo "<input type=\"hidden\" name=\"nid\" value=\"$nid\">";
   }

   echo <<<EOT
<table width='100%'>
   <tr><td width='35%' align="right">Name:</td><td>$nname</td></tr>
   <tr><td width='35%' align="right">Release Date:</td><td>$ndt_release</td></tr>
   <tr><td width='35%' align="right">Ack Due Date:</td><td>$ndt_ackdue</td></tr>
   <tr><td width='35%' align="right">Compliance Due Date:</td><td>$ndt_compliance</td></tr>
   <tr><td width='35%' align="right">Ack on Date:</td><td>$ndt_ackon</td></tr>
   <tr><td width='35%' align="right">Compliance Date:</td><td>$ndt_complied</td></tr>
   <tr><td align="right">Description:</td>
      <td>
      <textarea wrap="virtual" cols="70" rows="15" name="ndescription">$ndescription</textarea>
      </td>
      </tr>
   <tr><td align='right'>Archived</td>
         <td><input type="checkbox" name="narchived" value="1" $narchived_checked ></td>
   </tr>   
   <tr><td>&nbsp;</td>
      <td>
      <input type="submit" name="submit" value="Save"></form>
      </td>
   </tr>
   </table>
EOT;


}

function import_isvm ( $nid, $importisvm ) {
   global $username, $dbconn;

   navbar( $nid );

   $query = "SELECT id, name FROM I3_ISVM WHERE id='$nid' limit 1"; 
   $result = $dbconn->execute($query);
   list( $sysid, $sysname  )= $result->fields;

   process_import_data ($nid, $importisvm);

   echo <<<EOT
<form method="post" action="isvm.php">
<input type="hidden" name="disp" value="import_isvm">
<table summary="Target isvm">
   <tr><td>Input DATA to Import into ISVM</td></tr>
   <tr><td valign="top">
<textarea name="importisvm" style="WIDTH: 1024px; HEIGHT: 300px">
</textarea></td></tr>
   <tr><td align="right"><input type="submit" value="Import">
   </td></tr>
   </table>
</form>
EOT;

}

function import_plugins ( $nid, $importplugins, $isCVE ) {
   global $username, $dbconn;

   navbar( $nid );

   $query = "SELECT id, name FROM I3_ISVM WHERE id='$nid' limit 1"; 
   $result = $dbconn->execute($query);
   list( $sysid, $sysname )= $result->fields;

   add_plugins ($nid, $importplugins, $isCVE );

   echo <<<EOT
   <form method="post" action="isvm.php">
   <input type="hidden" name="disp" value="linkplugins">
   <input type="hidden" name="nid" value="$nid">
   
   <table summary="Target Hosts">
   <tr><td>Input Plugin/CVE List to Import into ISVM</td></tr>
   <tr><td><input type="checkbox" name="isCVE" value="1" >CVE LIST</option></td></tr>     
   <tr><td valign="top"><textarea name="importplugins" style="WIDTH: 400px; HEIGHT: 300px"></textarea></td></tr>
   <tr><td align="right"><input type="submit" value="Import">
   </td></tr>
   </table>
</form>
EOT;

}

function isvm_info ( $nid ) {
   global $dbconn;

   navbar( $nid );

   $query = "SELECT name, dt_release, dt_ackdue, dt_compliance, dt_ackon, dt_complied, description
      FROM I3_ISVM WHERE id='$nid' LIMIT 1";

   $result = $dbconn->execute($query);
   $row = $result->fields;
   $nname = $row[0];

   if (!$row) {
      echo "[ $nid ] - NO MATCH FOUND";
   } else {

      echo <<<EOT
<font color="red">
   <h4>isvm [ $nname ]</h4></font>
<table width="100%" summary="Search results" border=0 style="border-collapse: collapse" cellspacing="5" cellpadding="2">
   <tr><td width="25%" align="right"><h5><b>ATTRIBUTES</b></h5></td>
   <td ><h5><b>VALUE</b></h5></td></tr>
EOT;

      foreach ($row as $k => $v) {
         if ( !is_numeric($k) ) {
               echo "<tr><td align=\"right\">$k</td><td>$v</td></tr>";
         }
      }
      echo <<<EOT
</table>
EOT;

   $query = "SELECT t1.id, t1.name
      FROM plugins t1
      LEFT JOIN I3_ISVM_plugins t2 on t1.id = t2.nessus_id
      WHERE t2.iid = '$nid'";
   $result = $dbconn->execute($query);

   echo <<<EOT
<font color="red">
   <h5>ISVM [ $nname ] Required Plugins</h5></font>
   <table width="100%" summary="Search results" border=1 style="border-collapse: collapse"
      cellspacing="5" cellpadding="2">
   <tr><td width="50" >PLUGIN</td><td >NAME</td><td width="10">COUNT</td></tr> 
EOT;

      if ( !empty( $result)){
         while( !$result->EOF ) {
   	        list($plugid, $splugins ) = $result->fields;
   	        $vCount = $dbconn->GetOne("SELECT count(id) FROM I3_Incidents WHERE scriptid='$plugid' AND status !='resolved'");
   	        
   	        echo <<<EOT
<tr><td>$plugid</td><td>$splugins</td>
   <td><a href="lookup.php?disp=scriptid&id=$plugid&lookup=byincident">$vCount</a></td>
</tr>
EOT;
            $result->MoveNext();
         }
      }
      echo "</table>";            
   }
}

function list_ISVMS ( $nid, $type, $value, $sortby, $sortdir ) {
   global $offset, $pageSize, $username, $uroles, $dbconn;

   $filteredView = FALSE;
   
   $selRadio = array( "","","","");
   
   
   if ($sortby == "" ) { $sortby = "dt_release"; }
   if ($sortdir == "" ) { $sortdir = "ASC"; }
   
   navbar ( $nid );
  
   $querys="SELECT id, name, iCntPlugs, iVulnHosts, isvm_LINK, dt_release, dt_ackdue, dt_compliance, dt_ackon, dt_complied 
	  FROM I3_ISVM WHERE archived = '0' ";
   
   
   // set up the SQL query based on the search form input (if any)
   switch($type) {
   case "name":
      $selRadio[0] = "CHECKED";
      $q = $value;
      $queryw = " AND name LIKE '%$q%' order by $sortby $sortdir";
      $stext =  "Search for name = '*$q*'";
      $filteredView = True;
      break;
   case "description":
      $selRadio[1] = "CHECKED";
      $q = strtolower($value);
      $queryw = " AND description LIKE '%$q%' order by $sortby $sortdir";
      $stext =  "Search in Description for = '*$q*'";
      $filteredView = True;
      break;
      
   default:
      $selRadio[0] = "CHECKED";
      $viewAll = FALSE;
      $queryw .= " order by $sortby $sortdir";
      $queryw .= " limit $offset,$pageSize"; 
      $stext = "";
      break;
   }
 
   // echo the search criteria used

   // set up the pager and search fields if viewing all hosts
   $reportCount = 0;
   if(!$filteredView) {
      $reportCount = $dbconn->GetOne("SELECT count(id) FROM I3_ISVM WHERE archived='0'");
      $previous = $offset - $pageSize;
      if ($previous < 0) {
         $previous = 0;
      }
      $last = $reportCount - $pageSize;
      if ( $last < 0 ) { $last = 0; }
      $next = $offset + $pageSize;
      if ($next > $last) {
         $next = $last;
      }
      $pageEnd = $offset + $pageSize;
      echo "<p>There are $reportCount ISVM's defined in the system.";
      // output the search form
      echo <<<EOT
<!--<form name="hostSearch" onSubmit="return OnSubmitForm();">-->
<form name="hostSearch" action="isvm.php" method="GET">
<input type="text" length="25" name="value" value="$value">
EOT;
echo "
<input type=\"radio\" name=\"type\" value=\"name\" $selRadio[0]>Name
<input type=\"radio\" name=\"type\" value=\"description\" $selRadio[1]>Description

";
     echo <<<EOT
<input type="hidden" name="sortby" value="$sortby">
<input type="hidden" name="op" value="search">
<input type="submit" name="submit" value="Find">
</form>
</p>
EOT;
      // output the pager
      echo "<p align=center><a href='isvm.php?offset=0".$url_allres."' class='pager'>&lt&lt First</a> | ";
      if($offset != 0) {
         echo "<a href='isvm.php?offset=$previous".$url_allres."' class='pager'>&lt Previous </a> | ";
      }
      if($pageEnd >= $reportCount) { $pageEnd = $reportCount; }
      echo "[ $offset - $pageEnd of $reportCount ] | ";
      if($next < $last) {
         echo "<a href='isvm.php?offset=$next".$url_allres."' class='pager'>| Next &gt;</a> | ";
      }
      echo "<a href='isvm.php?offset=$last".$url_allres."' class='pager'> Last &gt;&gt;</a></p>";
   } else {
      // get the search result count
      $queryc = "SELECT count( id ) FROM I3_ISVM WHERE archived = '0' ";
      $scount=$dbconn->GetOne($queryc.$queryw);
      echo "<p>$scount ISVM";
      if($scount != 1) {
         echo "s";
      } else {
      }
      echo " found matching search criteria | "; 
      echo " <a href='isvm.php' alt='View All Reports'>View All Reports</a></p>";
   }

   echo "<p>";
   echo $stext;
   echo "</p>";
   
   // get the hosts to display
   $result=$dbconn->GetArray($querys.$queryw);
   if($result === false) {
      $errMsg[] = "Error getting hosts: " . $dbconn->ErrorMsg();
      $error++;
      dispSQLError($errMsg,$error);
   } else {
   	  $tdata = array();
      foreach($result as $data) {
      	 $iid = $data['id'];
#moved to backend script
/*   	 $query = "SELECT count(nessus_id) FROM I3_ISVM_plugins WHERE iid='$iid'"; 
         $result = $dbconn->execute($query);
         list( $pcount )= $result->fields;


         
         $query = "SELECT t1.id FROM plugins t1 LEFT JOIN I3_ISVM_plugins t2 on t1.id = t2.nessus_id
            WHERE t2.iid = '$iid'";
         $result = $dbconn->execute($query);

         if ( !empty( $result)){
            $vcount = 0;
            while( !$result->EOF ) {
   	           list( $plugid  ) = $result->fields;
   	           $tmpCount = $dbconn->GetOne("SELECT count(id) FROM I3_Incidents WHERE scriptid='$plugid' AND status !='resolved'");
   	           $vcount += $tmpCount; 

               $result->MoveNext();
            }
         } else {  	 
            $vcount = "0";   	
         }
*/
		 $pcount =$data['iCntPlugs'];
		 $vcount =$data['iVulnHosts'];
		 
         if ( $pcount < 1 ) {
         	$html_pcount = "<font color='red'><b>$pcount</b></font>";
         } else {
         	$html_pcount = "<font color='green'>$pcount</font>";
         }         
         
         if ( $pcount < 1 || $vcount > 0 ) {
         	$html_vcount = "<font color='red'><b>$vcount</b></font>";
         } else {
         	$html_vcount = "<font color='green'>$vcount</font>";
         }
         $data['pc'] = $html_pcount;
         $data['vcount'] = $html_vcount;  	 
      	 $data['plink'] = $data['isvm_LINK'];
         $tdata[] = $data;
         
         
         
      }
   	      
      if($sortdir == "ASC") { $sortdir = "DESC"; } else { $sortdir = "ASC"; }
      $url = $_SERVER['PHP_SELF'] . "?offset=$offset&sortby=%var%&sortdir=$sortdir";
      $fieldMap = array(
      
      "Links" => array( "PDF ISVM" => array(
             'url' => '%param%',
             'param' => 'plink',
             "target" => "_blank",
             'icon' => 'images/pdf.png'),
      "View" => array(
          "url" => "isvm.php?disp=view&nid=%param%",
          "param" => "id",
          "icon" => "images/zoom.png")),
      "Plug Count" => array( 'var' => 'pc' ),
      "VULS" => array( 'var' => 'vcount' ),                                        
                                                  
      "Name" => array( 'var' => 'name',
                                              'link' => $url ),
      "Release Date" => array( 'var' => 'dt_release',
                                        'link' => $url ),
      "Ack Due Date" => array( 'var' => 'dt_ackdue',
                                             'link' => $url ),
      "Complaince<br>Due Date" => array( 'var' => 'dt_compliance',
                                             'link' => $url ));
      drawTable($fieldMap, $tdata, "ISVM");

   }

   // draw the pager again, if viewing all hosts
   if(!$filteredView) {
      echo <<<EOT
<p align=center>
<a href="isvm.php?offset=0" class="pager">&lt&lt First</a>
<a href="isvm.php?offset=$previous" class="pager">&lt Previous </a>
<a href="isvm.php?offset=$next" class="pager">| Next &gt;</a>
<a href="isvm.php?offset=$last" class="pager"> Last &gt;&gt;</a>
</p>
EOT;
   }
}

function process_import_data ( $importisvm ) {
   global $username, $dbconn;

   if ( $importisvm ) {

   	  $now = gen_strtotime("now", "");
      if ( strlen($importisvm) > 0 ) {	 
        $importisvm = str_replace("\\r\\n", "<br>", $importisvm );	
		$rows = explode( "<br>", $importisvm ); 
        $inputisvmcount=1;
        foreach($rows as $row) {
         	if ( $row != "" & $row != "r" ) {
               echo "row=[$row]<br>";
               $fields=split( "[ \]+", $row );
               echo "name=$fields[0]', '$fields[1]', '$fields[2]', '$fields[3]', '$fields[4]', '$fields[5]'<br>";

               $query = "SELECT id FROM I3_ISVM WHERE name='$fields[0]' limit 1"; 
               $result = $dbconn->execute($query);
               list( $iid )= $result->fields;

               if ( !defined ($iid) || $iid == "" ) {
                  $query = "INSERT INTO I3_ISVM ( name, dt_release, dt_ackdue, dt_compliance, dt_ackon, dt_complied,
                     dtcreated ) VALUES (
                     '$fields[0]', str_to_date('".$fields[1]."', '%c-%d-%Y'), str_to_date('".$fields[2]."', '%c-%d-%Y'),
                     str_to_date('".$fields[3]."', '%c-%d-%Y'), str_to_date('".$fields[4]."', '%c-%d-%Y'), 
                     str_to_date('".$fields[5]."', '%c-%d-%Y'), '$now' );";
                  $result = $dbconn->execute($query);               
               } else {
               	  $query = "UPDATE I3_ISVM SET
                     dt_release = str_to_date('".$fields[1]."', '%c-%d-%Y'),
                     dt_ackdue = str_to_date('".$fields[2]."', '%c-%d-%Y'),
                     dt_compliance = str_to_date('".$fields[3]."', '%c-%d-%Y'),
                     dt_ackon = str_to_date('".$fields[4]."', '%c-%d-%Y'), 
                     dt_complied = str_to_date('".$fields[5]."', '%c-%d-%Y')
                     WHERE id='$iid'";
                  $result = $dbconn->execute($query);    
               }
         	}
         }
      }
   #$dbconn->execute("INSERT INTO log ( ip, username, action)
   #   VALUES ( '$ip', '$username', 'isvm.PHP update associated isvm for isvm $sysname' )");
   
   }
   
   echo "<br>";

}

function save_isvm( $nid, $ndescription, $narchived ){
   global $username, $dbconn;

   $dtinsert = gen_timeasstr();

   if( $narchived == "" ) { $narchived = "0"; }
   
   if( $nid ){
      $query="UPDATE I3_ISVM SET description='$ndescription', archived='$narchived' WHERE id='$nid'";
   } else {   

   }

   $result = $dbconn->execute($query);

   logAccess( "ISVM [ $nname ] MODIFIED" );

   echo "Sucessfully added/Updated ISVM<br><br>";

   isvm_info ( $nid );

}


switch($disp) {

   case "add_isvm":
      add_isvm( );
      break;

   case "edit_isvm":
      edit_isvm($nid);
      break;	
	
   case "import":
      import_isvm ( $importisvm );
      break;	

   case "linkplugins":
      import_plugins ( $nid, $importplugins, $isCVE );
      break;	      
      
      
   case "save_isvm":
      save_isvm( $nid, $ndescription, $narchived );
      break;      
      
   case "view":
      isvm_info ( $nid );
      break;	
	      
      
     default:
        list_ISVMs ( $nid, $type, $value, $sortby, $sortdir );
        break;
}

     include ('footer.php');

?>
