<?php
//
// $Id: reshtml.php,v 1.10 2006/09/20 13:03:48 airwofl Exp $
//

/***********************************************************/
/*                 Inprotect                      */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                      */
/*                                          */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                              */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the         */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                 */
/*                                          */
/* You should have received a copy of the GNU General         */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                 */
/*                                          */
/* Contact Information:                              */
/* inprotect-devel@lists.sourceforge.net                */
/* http://inprotect.sourceforge.net/                    */
/***********************************************************/
/* See the README.txt and/or help files for more        */
/* information on how to use & config.                  */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                          */
/* This program is intended for use in an authorized          */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items      */
/* discovered with this program's use.                  */
/***********************************************************/

$pageTitle = "HTML Results";
require_once('config.php');
require_once("functions.inc");
require_once('auth.php');
//require_once('permissions.inc.php');


$getParams = array( "disp", "op", "output", "scantime", "scantype", "reporttype", "key", "sortby", "allres", 
   "fp","nfp", "wh", "bg", "filterip", "critical", "increment" );
$postParams = array( "disp", "op", "output", "scantime", "scantype", "fp","nfp", "filterip", "critical", "increment"
              );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

$isReportAdmin = ($uroles['admin'] || $uroles['reports']) ? TRUE : FALSE;

if ( $output != "printable" ) {
	require_once('header2.php');
}

function navbar ( $output ) {
   global $disp, $sitename, $username, $border, $report_id, $scantime, $scantype, $fp, $nfp, $output, 
   $filterip, $query_risk, $likefilter, $dbconn;
 
      $arr = array("full", "summary", "optimized", "printable", "min");
      if ( $output == "" ) { $output = "summary"; }

      echo <<<EOT
   <table class="forumline" cellSpacing="1" cellPadding="3" width="100%" border="0">
   <form action="reshtml.php" method="post">
   <INPUT TYPE=HIDDEN NAME="disp" VALUE="html">
   <INPUT TYPE=HIDDEN NAME="scantime" VALUE="$scantime">
   <INPUT TYPE=HIDDEN NAME="scantype" VALUE="$scantype">
   <INPUT TYPE=HIDDEN NAME="fp" VALUE="$fp">
   <INPUT TYPE=HIDDEN NAME="nfp" VALUE="$nfp">
EOT;

      if ( $filterip ) {
         echo "<INPUT TYPE=HIDDEN NAME=\"filterip\" VALUE=\"$filterip\">";
      }
      echo <<<EOT
   <tr><td align="Right" width="40%">REPORT FORMAT:  </td>
   <TD align=LEFT><SELECT NAME="output">
EOT;

      foreach ( $arr as $value) {
         if ( $output == $value ) {
            echo "<OPTION VALUE=\"$value\" SELECTED>". strtoupper($value) . "</OPTION>";
         } else {
            echo "<OPTION VALUE=\"$value\">". strtoupper($value) . "</OPTION>";
         }
      }

      echo <<<EOT
   </SELECT><input type="submit" name="submit" value="Reload Report" class="mainoption">
   </TD></tr>
</table>\n</form>
</center>
EOT;

}

function generate_results($output){
   global $sitename, $username, $border, $report_id, $sid, $scantime, $scantype, $fp, $nfp, $output, $filterip, 
   $query_risk, $dbconn;

   $query = "SELECT report_id, sid FROM nessus_reports WHERE scantime='$scantime' 
         AND scantype='$scantype' LIMIT 1";
   $result=$dbconn->execute($query);

   list( $report_id, $sid ) = $result->fields;

   #echo "report_id=$report_id<br>";

   $ip = $_SERVER['REMOTE_ADDR'];

   logAccess( strtoupper($output) . " HTML REPORT [ $report_id ] ACCESSED" );

   switch($output) {

         case "full" :
      navbar ( $output );
      echo "". reportsummary();
      echo "". vulnbreakdown();
      echo "". hostsummary();
      echo "". origdetails();
      require_once('footer.php');
      break;

         case "detailed" :
      echo "". reportsummary();
      #echo "". detailedresults();
      break;

         case "summary" :
      navbar ( $output );
      echo "". reportsummary();
      echo "". vulnbreakdown();
      echo "". hostsummary();
      require_once('footer.php');

      break;


         case "printable" :
      $border=0;
      echo "". reportsummary();
      echo "". vulnbreakdown();
      #echo "". atrisksummary();
      echo "". hostsummary();
      echo "". vulndetails();
      break;

         case "min" :
      navbar ( $output );
      #$border=0;
      $query_risk = "AND risk <= '3' ";
      echo "". reportsummary();
      echo "". vulnbreakdown();
      #echo "". atrisksummary();
      echo "". hostsummary();
      echo "". vulndetails();
      break;

         case "optimized" :
      navbar ( $output );
      echo "". reportsummary();
      echo "". vulnbreakdown();
      echo "". hostsummary();
      echo "". vulndetails();
      require_once('footer.php');
      break;

          default:
      navbar ( $output );
      echo "". reportsummary();
      echo "". vulnbreakdown();
      echo "". hostsummary();
      echo "". origdetails();
      require_once('footer.php');

      break;

    }
}

function reportsummary( ){   //GENERATE REPORT SUMMARY

   global $sitename, $username, $border, $report_id, $scantime, $scantype, $fp, $nfp, $output, $filterip, $query_risk, $dbconn;

   $htmlsummary = "";
   $query = "SELECT t1.username, t1.name, t2.name, t2.description 
         FROM I3_jobs t1
         LEFT JOIN nessus_settings t2 on t1.meth_VSET=t2.id
         WHERE t1.report_id='$report_id'
          order by t1.SCAN_END DESC";
   $result=$dbconn->execute($query);

   list( $query_uid, $job_name, $profile_name, $profile_desc ) = $result->fields;

    $htmlsummary .= "<font face=\"Verdana\" color=\"#666666\" size=\"4\">
         <b><big>Scan results:</big></b></font><br>
         <table border=\"0\"><tr><td valign=\"top\">
         <font face=\"Verdana\" color=\"#666666\" size=\"2\">
         <b>Scan time:</b> ". gen_strtotime($scantime,"")."&nbsp;&nbsp;&nbsp;</font></td>";

    //Generated date
    $gendate = date("Y-m-d H:i:s");

    $htmlsummary .= "<td valign=\"top\"><font face=\"Verdana\" color=\"#666666\" size=\"2\">
         <b>Generated:</b> $gendate</font></td></tr>";

   $htmlsummary .= "<td valign=\"top\"><font face=\"Verdana\" color=\"#666666\" size=\"2\">
         <b>Profile:</b> $profile_name - $profile_desc&nbsp;&nbsp;&nbsp;</font></td>
         <td valign=\"top\"><font face=\"Verdana\" color=\"#666666\" size=\"2\">
         <b>Job Name:</b> $job_name</font></td></tr>
         <tr><td valign=\"top\"><font face=\"Verdana\" color=\"#666666\" size=\"2\">
         <b>Owner:</b> $query_uid</font></td><td><font face=\"Verdana\" color=\"#666666\" size=\"2\">
         <b>Report Format: </b>" . strtoupper($output) . "</font></td></tr></table>";


   return $htmlsummary;
}

function vulnbreakdown(){   //GENERATE CHART
   global $sitename, $username, $border, $report_id, $scantime, $scantype, $fp, $nfp, $output, $filterip, $query_risk, $dbconn;

   $htmlchart = "";
   $query_host = "";
   if ( $filterip ) { $query_host = " AND hostip='$filterip'"; }

   $query = "SELECT count(risk) as count, risk
         FROM `nessus_results`
         WHERE report_id='$report_id' $query_host
      AND falsepositive<>'Y'
      AND scriptid <> 10180
         GROUP BY risk";
   $result=$dbconn->Execute($query);

   //print_r($result);
   $prevrisk=0;
   $chartimg="graph1.php?graph=1";
   while (list($riskcount, $risk)=$result->fields) {
         for ($i=0;$i<$risk-$prevrisk-1;$i++) {
      $missedrisk=$prevrisk+$i+1;
      $chartimg.="&amp;risk$missedrisk=0";
         }
         $prevrisk=$risk;
         $chartimg.="&amp;risk$risk=$riskcount";
         $result->MoveNext();
   }

   // print out the pie chart
   $htmlchart .= "<font size=\"1\"><br></font>
         <img alt=\"Chart\" src=\"$chartimg\"><br>";

   return $htmlchart;
}

function hostsummary( ){
   global $sitename, $username, $border, $report_id, $scantime, $scantype, $fp, $nfp, $output, $filterip, $query_risk, $dbconn;

   $htmldetails = "";
   $query_host = "";
   if ( $filterip ) { $query_host = " AND hostip='$filterip'"; }

   $htmldetails .= "<br><br><font color=\"red\">
         <b>Summary of Scanned Hosts</b></font><br>
         <table summary=\"Summary of scanned hosts\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\" style=\"border-collapse: collapse\">";

   $htmldetails .= "<tr><td><b>Host&nbsp;&nbsp;</b></td>
         <td><b>Serious&nbsp;&nbsp;</b></td>
         <td><b>High&nbsp;&nbsp;</b></td>
         <td><b>Medium&nbsp;&nbsp;</b></td>
         <td><b>Medium/Low&nbsp;&nbsp;</b></td>
         <td><b>Low/Medium&nbsp;&nbsp;</b></td>
         <td><b>Low&nbsp;&nbsp;</b></td>
         <td><b>Info&nbsp;&nbsp;</b></td></tr>";

    $query = "SELECT distinct hostip
          FROM nessus_results
         WHERE report_id = '$report_id' $query_host
         ORDER BY INET_ATON(hostip) ASC";

   $result=$dbconn->execute($query);

   while(list( $hostip ) = $result->fields) {

      if ( $output == "original" ) {
         $tmp_host = "<a href=\"#$hostip\">$hostip</a>";
      } else {
         $tmp_host = $hostip;
      }

      $htmldetails .= "<tr>
         <td>$tmp_host&nbsp;</td>";
      $prevrisk=0;

      $query2 = "SELECT count(risk) as count, risk
         FROM nessus_results
         WHERE report_id='$report_id' AND hostip='$hostip' 
            AND falsepositive<>'Y' AND scriptid <>10180
         GROUP BY risk";

      $drawtable=0;

      $result2=$dbconn->execute($query2);
      while( list( $riskcount, $risk ) = $result2->fields ) {
         $drawtable=1;
         for ($i=1;$i<$risk-$prevrisk;$i++) {
            $htmldetails .= "<td>-</td>";
         }

         $htmldetails .= "<td>$riskcount</td>";
         $prevrisk=$risk;
         $result2->MoveNext();
      }

      if ($drawtable==0) {
         $htmldetails .= "<td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td>";
      }
      #$htmldetails .= "<td>&nbsp;<a href=\"trend.php?submit=Go&amp;type=1&amp;ip=$hostip&amp;days=30";

      #$htmldetails .= "\">"; #<img alt=\"Trend\" border=0 src=\"images/Inprotect/trend.png\"></a>&nbsp;</td>";
      $htmldetails .= "</tr>";
      $result->MoveNext();
   }
   $htmldetails .= "</table><br>";

   return $htmldetails;

}

function vulndetails( ){
   global $sitename, $username, $border, $report_id, $scantime, $scantype, $fp, $nfp, $output, $filterip, $query_risk, $dbconn;

   $host_list = array();

   $htmldetails = "";
   $query_host = "";
   if ( $filterip ) { $query_host = " AND hostip='$filterip'"; }

   if ( $output == "original" ){
         $query_order = "group by hostip order by risk";
   } else {
         $query_order = "order by risk,scriptid,hostip";
   }

   $query = "SELECT risk, scriptid, service, msg, hostip
         FROM nessus_results
         WHERE report_id='$report_id' ".$query_risk.$query_host.$query_order;

   echo "query=$query<br>";

   $result = $dbconn->execute($query);

   if ( $result->RecordCount() != 0 ) {
         $htmldetails .= "
      <br><hr><br><font color=\"red\">
      <b><big>Summary of Vulnerabilities By Risk</big></b></font>
      <br><table width=\"100%\" summary=\"Summary of risks\" border=\"$border\"
      cellspacing=\"0\" cellpadding=\"0\" style=\"border-collapse: collapse\">";
   } else {
         $htmldetails .= "<br><hr><br><font color=\"red\">
      <b><big>Serious Vulnerabilities Risks:</big></b></font><br><br>
      <b>NONE</b>";
         return $htmldetails;
   }

   $lastid=0;
   $scriptid=0;


   while( list( $risk, $scriptid, $service, $msg, $host ) = $result->fields ) {
      if ($scriptid != $lastid ) {

         if ( is_array($host_list)) {
            foreach ($host_list as $key => $value) {
                $htmldetails .= "<tr><td>$key</td></tr>";
            }
            reset($host_list);
         }

         $query2 = "select note from nessus_notes where pid='$scriptid'";
         $result_note = $dbconn->execute($query2);

         if (  $result_note->RecordCount() != 0 ) {
            $msg.="\n\n<FONT COLOR=\"#0044FF\"><B>Custom Notes:</B>";
            $note_num=1;
            while(list( $customnote ) = $result_note->fields) {
               $msg.="\n$note_num. $customnote";
               $note_num++;
               $result_note->MoveNext();
            }
            $msg.="</FONT>";
         }

         $msg=preg_replace("/^[ \t]*/","",$msg);
         $msg=wordwrap(preg_replace("/\n/","<br>",$msg),100,"<br>",1);
         $msg=activateHyperlink($msg);

         if ($lastid != 0) {
            $htmldetails .= "<tr>
               <td>&nbsp;</td></tr>
               <tr><td><hr></td></tr>
               <tr><td>&nbsp;</td></tr>";
         }

         $htmldetails .= "<tr><td><b>RISK</b></td></tr>
            <tr><td>".getrisk($risk)."</td></tr>
            <tr><td>&nbsp;</td></tr>
            <tr><td><b>PLUGIN</b></td></tr>
            <tr><td>$scriptid</td></tr>
            <tr><td>&nbsp;</td></tr>
            <tr><td><b>SERVICE</b></td></tr>
            <tr><td>$service</td></tr>
            <tr><td>&nbsp;</td></tr>
            <tr><td><b>DETAILS</b></td></tr>
            <tr><td>$msg</td></tr>
            <tr><td>&nbsp;</td></tr>
            <tr><td><b>VULNERABLE HOSTS:</b></td></tr>";
         $host_list[$host] = 1;
         $lastid=$scriptid;
      } else {
         if ( $scriptid != " ") {
            $host_list[$host] = 1;
         }
      }
      $result->MoveNext();
   }

   if ( !empty($host_list)) {
      foreach ($host_list as $key => $value) {
       $htmldetails .= "<tr><td>$key</td></tr>";
      }
      reset($host_list);
   }

    $htmldetails .= "</table><br>";
    return $htmldetails;
}

function origdetails( ) {
   global $uroles, $sitename, $username, $sid, $query_risk, $border, $report_id, $scantime, $scantype, $fp, $nfp, $filterip,
   $enableFP, $enableNotes, $enableException, $output, $sortby, $dbconn;

   // print the icon legend
   if ($enableFP) {
         echo "<img alt='True' src='images/true.png' border=0> - True result&nbsp;&nbsp;";
         echo "<img alt='False' src='images/false.png' border=0> - False positive result&nbsp;&nbsp;";
   }
   if ($enableNotes) {
         echo "<img alt='Note' src='images/note.png' border=0> - Add a custom note&nbsp;&nbsp;";
   }
   echo "<img alt='Info' src='images/info.png' border=0> - Additional information is available</p>";

   $query ="select distinct hostip, hostname from nessus_results where report_id='$report_id' order by INET_ATON(hostip) ASC";
   $result = $dbconn->execute( $query );

   while( list($hostip, $hostname) = $result->fields) {

      if($output=="min") { 
         echo "<h3>Details for Serious, High, Medium and Medium/Low severity risks only.</h3>"; 
      }
      echo <<<EOT
<br><font color="red"><b><a name="$hostip">$hostip - $hostname</a></b></font>
<table summary="$hostip - Open Ports">
<tr><th colspan=2>Open Ports</th></tr>
EOT;

   // get the "open ports", defined as a risk=7 with no msg
   $query = "select service, risk,  falsepositive, result_id
      FROM nessus_results 
         WHERE report_id = '$report_id' AND hostip='$hostip' AND msg='' AND risk='7'
         ORDER BY result_id ASC";
   $result1=$dbconn->execute($query); 

   $arrResults="";

      while( list( $service, $risk, $falsepositive, $resid ) = $result1->fields ) {
         $tmpport1=preg_split("/\(|\)/",$service);
         $tmpport2=preg_split("/\//",$tmpport1[1]);
         $service_num=$tmpport2[0];
         $service_proto=$tmpport2[1];

         $arrResults[]=array( 
                           $service_num, 
                           $service_proto, 
                           $service, 
                           $risk, 
                           $falsepositive, 
                           $resid);
         $result1->MoveNext();
      }

      if(!empty($arrResults)) {
         uasort ($arrResults, 'arrPortResultsCompare');
      }

      $k=1;
      $pos = "";
      if(!empty($arrResults)) {
         foreach ($arrResults as $key=>$value) {
            list( 
               $service_num, 
               $service_proto, 
               $service, 
               $risk, 
               $falsepositive, 
               $resid) = $value;

            if($k % 2) {
               echo "<tr><td>$service</td>";
               $pos = "open";
            } else {
               echo "<td>$service</td></tr>";
               $pos = "closed";
            }
            $k++;
            $result1->MoveNext();
         }
      // close up the table
         if($pos!="closed") {
            echo "<td>&nbsp;</td></tr>";
         }
      } else {
         echo "<tr><td>No open ports found</td></tr>";
      }
      echo "</table><p></p>";

   echo <<<EOT
<table summary="$hostip - risks">
<tr>
<th>Service</th>
<th>Severity</th>
<th>PluginID</th>
<th>Description</th>
</tr>
EOT;

      $query = "select service, risk, falsepositive, result_id, msg, scriptid from nessus_results 
        	WHERE report_id='$report_id' and hostip='$hostip' and msg<>''";


      // for minimized output, don't include risk=[5|6|7]
      if($output=="min") {
         $query.=" and risk NOT IN( '7', '6', '5')";
      }
      $query.=" order by risk ASC, result_id ASC";
      $result1=$dbconn->execute($query);

      $arrResults="";

      while(list( $service, 
                  $risk, 
                  $falsepositive, 
                  $resid, 
                  $msg, 
                  $scriptid) = $result1->fields ) {
         $tmpport1=preg_split("/\(|\)/",$service);
         if (sizeof($tmpport1)==1) { $tmpport1[1]=$tmpport1[0]; }
   #echo "$tmpport1[0] $tmpport1[1]<BR>";
         $tmpport2=preg_split("/\//",$tmpport1[1]);
   #echo "$tmpport2[0] $tmpport2[1]<BR>";
         $service_num=$tmpport2[0];
         $service_proto=$tmpport2[1];
   
         $arrResults[]=array( $service_num, 
                              $service_proto, 
                              $service,
                              $risk, 
                              $falsepositive, 
                              $resid, 
                              $msg, 
                              $scriptid );
         $result1->MoveNext();
      }

      if(!empty($arrResults)) {
         uasort ($arrResults, 'arrScanResultsCompare');
      } else { // empty, print out message
         echo "<td colspan=3>No vulnerability results matching this reports 
               filtering criteria were found.</td></tr>";
      }
   
      foreach ($arrResults as $key=>$value) {
         list( $service_num, 
               $service_proto, 
               $service, 
               $risk, 
               $falsepositive, 
               $resid, 
               $msg, 
               $scriptid ) = $value;

// No need to do this anymore as the HTML entities are converted when
// importing the results
//            $msg=htmlspecialchars($msg);

// Do NOT do a check for admin and filter out username var here. 
// Otherwise you will get all user's comments due to the poor way
// the Inprotect DB is structured.

         // Print Notes associated with this result (resid)
         // modified to remove username filter - will tag the note with the
         // username which we now get in the results
         if ($enableNotes) {
         	$query = "select note, username FROM nessus_notes WHERE pid=$scriptid and resid = $resid";
            $result_note=$dbconn->execute($query);
                                                //and username='$username'");
            //The next line breaks for upgrade installs
            //$notes=$result_note->GetArray();
            if ( !empty( $result_note) ) {
               $msg.='<p><FONT COLOR="#0044FF"><B>Custom Notes:</B>';
               foreach ($result_note as $note_num=>$customnote) {
                  //list($customnote)=$result_note->fields;
                  $note_num++; // do this as the index starts at 0
                  $msg.="\n$note_num. [$customnote[username]] - $customnote[note]";
                  //$note_num++;
                  //$result_note->MoveNext();
               }
               $msg.="</FONT></p>";
            }
         } // end Print Notes

         $msg=preg_replace("/^[ \t]*/","",$msg);
         $msg=preg_replace("/\n/","<br>",$msg);
//         $tr = array("\\n" => "<br>");
//         $msg=strtr($msg,$tr);
         //$msg=wordwrap(preg_replace("/\n/","<br>",$msg),100,"<br>",1);
         $msg=wordwrap($msg,100,"<br>",1);

         // Add Exceptions
         //if ($enableException && $risk <= 6) {
         if ($enableException) {
            $msg .= "<p><FONT COLOR='#0044FF'><b>Exceptions:</b><br>";
            if ($uroles['eview'] || $uroles['esubmit'] || $uroles['eapprove']) {
               $msg .= printException($hostip, $scriptid, $dbconn, FALSE,
                                      $hostname, $service_num, $sid );
            }
            //if ($esubmit) {
            //   $msg .= addException($hostip,$resid,$scriptid,$schedid,$hostname);
            //}
         } // end Exceptions

         $tmprisk = getrisk($risk);

         // output the table cells
         echo <<<EOT
<tr>
<td>$service</td>
<td>$tmprisk</td>
<td>$scriptid</td>
<td width="70%">
<A class="msg" NAME="$resid"></a>$msg
<font size="1">
<br><br>
</font>
EOT;

         // Add link to popup with Script Info
         echo <<<EOT
<a href="lookup.php?id=$scriptid" onClick="popup('lookup.php?id=$scriptid','lookup'); return false;">
<img alt="Info" src="images/info.png" title="More info..." border=0></a>
EOT;
         // Add Custom Notes icon
         // don't filter on username - any user can add a note to any result
         //if ($sql_uid==$username) {
         if($enableNotes) {
            if ($output=="min") {
               echo <<<EOT
&nbsp;&nbsp;
<a href="notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&sortby=$sortby&resid=$resid&httpfrom=resmin" 
  onClick="popup('notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&sortby=$sortby&resid=$resid&httpfrom=resmin','Notes'); 
  return false;"><img alt="Note" src="images/note.png" title="Add note" border=0></a>
EOT;
            } else {
               echo <<<EOT
&nbsp;&nbsp;
<a href="notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&sortby=$sortby&resid=$resid&httpfrom=results" 
  onClick="popup('notes.php?op=add&amp;pid=$scriptid&scantime=$scantime&scantype=$scantype&sortby=$sortby&resid=$resid&httpfrom=results','Notes'); 
  return false;"><img alt="Note" src="images/note.png" title="Add note" border=0></a>
EOT;
            }
         }
         //}

         // Add False Positive Indicator/link
         if ($enableFP && ($sql_uid==$username || $uroles['admin'])) {
            if ($falsepositive=="Y") {
               echo <<<EOT
&nbsp;&nbsp;
<a href="reshtml.php?scantime=$scantime&scantype=$scantype&nfp=$resid">
<img alt="Clear false positive" src="images/false.png" title="Clear false positive" border=0></a>
EOT;
            } else {
               echo <<<EOT
&nbsp;&nbsp;
<a href="reshtml.php?scantime=$scantime&scantype=$scantype&fp=$resid">
<img alt="Mark as false positive" src="images/true.png" title="Mark as false positive" border=0></a>
EOT;
            }
         }

         echo "</td></tr>";
         $result1->MoveNext();
      }
      echo "</table>";
      $result->MoveNext();
   }




}

switch($disp) {



   case "html":
         generate_results($output);
         break;

   default:
         generate_results($output);
         break;

}


?>
