<?php
//
// $Id: respdf.php,v 1.11 2006/09/19 04:57:00 airwofl Exp $
//

/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/
#error_reporting(E_ALL);

define('FPDF_FONTPATH','inc/font/');
require('inc/InproTable.php');

require_once('config.php');
require_once('functions.inc');
#require_once('auth.php');
//include ('permissions.inc.php');

global $uname, $ip;

//php4 version of htmlspecialchars_decode which is only available in php5 upwards
if (!function_exists('htmlspecialchars_decode'))
{
    function htmlspecialchars_decode($str)
    {
        $str = preg_replace("/&gt;/",">",$str);
        $str = preg_replace("/&lt;/","<",$str);
        $str = preg_replace("/&quot;/","\"",$str);
        $str = preg_replace("/&#039;/","'",$str);
        $str = preg_replace("/&amp;/","&",$str);

        return $str;
    }
}


switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
    if (isset($_GET['scantime'])) { 
        $scantime=htmlspecialchars(mysql_escape_string(trim($_GET['scantime'])), ENT_QUOTES); 
    } else { $scantime=""; }
    if (isset($_GET['scantype'])) { 
        $scantype=htmlspecialchars(mysql_escape_string(trim($_GET['scantype'])), ENT_QUOTES); 
    } else { $scantype=""; }
    if (isset($_GET['key'])) { 
        $report_key=htmlspecialchars(mysql_escape_string(trim($_GET['key'])), ENT_QUOTES); 
    } else { $report_key=""; }
    if (isset($_GET['critical'])) { 
        $critical=htmlspecialchars(mysql_escape_string(trim($_GET['critical'])), ENT_QUOTES); 
    } else { $critical="0"; }        
    if (isset($_GET['filterip'])) { 
        $filterip=htmlspecialchars(mysql_escape_string(trim($_GET['filterip'])), ENT_QUOTES); 
    } else { $filterip=""; }    
    break;
}

// get user rights
/*
$admin=(strpos($_SESSION['roles'],"admin")) === FALSE ? FALSE : TRUE;
$reports=(strpos($_SESSION['roles'],"reports")) === FALSE ? FALSE : TRUE;
*/

online();

//Seperates the parts of the date so it doesn't just display it as one big number
$scanyear = substr($scantime, 0, 4);
$scanmonth = substr($scantime, 4, 2);
$scanday = substr($scantime, 6, 2);
$scanhour = substr($scantime, 8, 2);
$scanmin = substr($scantime, 10, 2);
$scansec = substr($scantime, 12);

//Generated date
$gendate = date("Y-m-d H:i:s");

//here you can set the preference for the table colors
$head_fill_color = array(100,149,237);
$head_text_color = 255;
$fill_color = array(224,235,255);
$text_color = 0;
$line_color = array(0,0,0);
$boarder_type = 1; #doesn't work yet, there's always a full boarder for now

//row height for the table
$row_height = 5;

$query_byuser = "";
$query_critical = "";
$query_host ="";
$wdata ="";
$fdata ="";
$udata = "";

if ( $uname == $ip ) {
    $query_byuser = "AND report_key='$report_key'"; # AND DATEDIFF ( $scantime, now ) <= 15 )";
    /*
    $curtime = gen_strtotime("now", "");
    $sqlScanTime = gen_strtotime($scantime);
    $days = datediff("d", $curtime, $sqlScanTime );
    if (  $days > 30 ) {
        die ("Email link access for requested report has expired: days [ $days ] "
            ."Please <a href=\"$sitename/\">login</a>" );
    }
    */
}

if ( $critical ) {
    $query_critical = "AND risk <= '$critical' ";
}
if ( $filterip ) {
    $query_host = "AND hostIP='$filterip'";
}

/* not sure we need this, maybe once the server gets more data???
ini_set("max_execution_time","360");
ini_set("memory_limit","64M");
*/

ini_set("max_execution_time","360");
ini_set("memory_limit","64M");

$query = "SELECT report_id FROM nessus_reports WHERE scantime='$scantime'
     AND scantype='$scantype' $query_byuser LIMIT 1";

$result=$dbconn->execute($query);
list ( $report_id ) = $result->fields;

if ( ! $report_id ) {
    logAccess( "ATTEMPT TO ACCESS INVALID PDF REPORT" );
    die("Report not found");
}

$query = "select count(scantime) from nessus_results
       where report_id='$report_id'";
$result=$dbconn->execute($query);
list ( $numofresults ) = $result->fields;

if ($numofresults<1) {
    logAccess( "PDF REPORT [ $report_id / NO RESULTS ] ACCESSED" );
    die("No vulnerabilities recorded");
}
    logAccess( "PDF REPORT [ $report_id ] ACCESSED" );

//include pdf libraries



set_time_limit(300);
//start pdf file, add page, set font
$pdf = new PDF();
$pdf->AddPage();
$pdf->SetFont('Helvetica', 'B', 15);
$pdf->Cell(0, 9, "$company - IT Security Compliance Audit", 1, 1, 'C', 0);

$pdf->SetFont('Helvetica', '', 10);

$pdf->Cell(95,6,"Scan time: $scanyear-$scanmonth-$scanday $scanhour:$scanmin:$scansec",1,0,'L');
$pdf->Cell(95,6,"Generated: $gendate",1,1,'L');

if ($report_id) {
    $query ="SELECT t1.username, t1.name, t2.name, t2.description, t3.description, 
    	meth_Wcheck, meth_Wfile, meth_Ucheck
        FROM I3_jobs t1
        LEFT JOIN nessus_settings t2 on t1.meth_VSET=t2.id
        LEFT JOIN I3_subnets t3 on t1.fk_name = t3.CIDR
        WHERE t1.report_id='$report_id' $query_host 
        order by t1.SCAN_END DESC";
    $result = $dbconn->execute($query);
    list ($query_uid, $job_name, $profile_name, $profile_desc, $sub_desc, $wCheck, $wfCheck, $uCheck ) = $result->fields;

    $arrW = split( "\n", $wCheck);
    $arrF = split( "\n", $wfCheck);
    $arrU = split( "\n", $uCheck);
    foreach ( $arrW as $file ) {
    	$wdata .= GetFilename($file) . "\n";
    }
    foreach ( $arrF as $file ) {
    	$fdata .= GetFilename($file) . "\n";
    }
    foreach ( $arrU as $file ) {
    	$udata .= GetFilename($file) . "\n";
    }    
    
    $pdf->Cell(120,6,"Profile: $profile_name - $profile_desc",1,0,'L');
    $pdf->Cell(70,6,"Owner: $query_uid",1,1,'L');
    $pdf->Cell(0, 6, "Job Name: $job_name", 1, 1, 'L');    
    $pdf->Cell(0, 6, "Windows Compliance Check: $wdata", 1, 1, 'L');
    $pdf->Cell(0, 6, "Windows File Contents Compliance Check: $fdata", 1, 1, 'L');
    $pdf->Cell(0, 6, "Unix Compliance Checks: $udata", 1, 0, 'L');
#    $pdf->Ln();

    $pdf->SetFont('Helvetica', '', 10);

    //get current possition so we can put the pie chart to the side
    $valX = $pdf->GetX();
    $valY = $pdf->GetY();
    $riskarray = array(); //array of risks for pie chart
    $colorarray=array(); //array of colors for pie chart

    $query = "SELECT DISTINCT hostIP, hostname FROM `nessus_results`
        where report_id='$report_id' AND record_type='C' $query_host $query_critical order BY hostIP";
    $result = $dbconn->execute($query);

    //initialise variable for number of hosts while loop
    $hosts = array();
    while ($row = $result->fields) {
       $hosts[$row['hostIP']]=$row['hostname'];
       $result->MoveNext();
    }

    $query = "SELECT count(risk) as count, risk FROM nessus_results
        where report_id='$report_id'  AND record_type='C' $query_host group by risk";
    $result = $dbconn->Execute($query);

    $index = 0;

    $pdf->Ln();
    $pdf->SetFont('Times', 'B', 12);
    $pdf->Cell(0, 6, "Total number of Policies Audited on " .sizeof($hosts). " system(s)",0,1,'C');
    $pdf->Rect(10,55,190,48);
    $pdf->Ln();
    $pdf->SetFont('Arial', '', 10);

    while ( list($riskcount, $risk) = $result->fields ) {
        $risk_name = getcrisk($risk) .": $riskcount";
        $riskArray [$risk_name] = $riskcount;
        $colorarray[$index] = getriskcolor($risk);
        $index++;
        $result->MoveNext();
    }
    $pdf->Ln();
    //make pie chart and put current possition below

    $pdf->Ln();

    
    $pdf->SetXY(85, 62); #$valY);
    $pdf->PieChart(140, 40, $riskArray, '%l', $colorarray);
    $pdf->SetXY($valX, $valY + 40);   

    //Host-Vulnerability Summary
    $pdf->Ln();

    $pdf->Ln();
    $pdf->Ln();
    $pdf->Ln();    
    $pdf->SetFont('Helvetica', 'B', 10);   
    $pdf->Cell(0, 6, "Total number of vulnerabilities identified per system",0,1,'C');    
    $pdf->Ln();   
    $pdf->SetFont('Helvetica', 'B', 10);
    $size= 12 + (6 * sizeof($hosts));
    $pdf->Rect(10,103,190,$size);


    
    $pdf->SetFont('Helvetica', '', 10);
    $pdf->Cell(28, 6, "HostIP",1,0,'C');
    $pdf->Cell(72, 6, "HostName",1,0,'C');
    $pdf->Cell(30, 6, "Failed",1,0,'C');
    $pdf->Cell(30, 6, "Error",1,0,'C');
    $pdf->Cell(30, 6, "Passed",1,0,'C');

    $pdf->Ln();

    foreach ($hosts as $hostIP=>$hostname) {
       $pdf->Cell(28, 6, $hostIP,1,0,'C');
       $pdf->Cell(72, 6, $hostname,1,0,'C');


       $query1 = "SELECT count(risk) as count, risk FROM `nessus_results`
            where report_id='$report_id' and hostIP='$hostIP'  AND record_type='C' $query_critical
            and falsepositive <> 'Y' group by hostIP, risk";
       $result1 = $dbconn->Execute($query1);

       $prevrisk=0;
       while(list($riskcount, $risk)=$result1->fields) {
          for ($k=0;$k<$risk-$prevrisk-1;$k++) {
             if ( $k == "2" || $k == "3" || $k == "6" ) {
          	 	$pdf->Cell(30, 6, "--" ,1,0,'C');
             }
          }
		  if ( $risk == "2" or $risk == "3" or $risk == "6" ) {
             $pdf->Cell(30, 6, "$riskcount" ,1,0,'C');
		  }
          $prevrisk=$risk;
          $result1->MoveNext();
       }


       $pdf->Ln();

   }


   $pdf->Ln();

   //build array of risks - join the hosts table to get the hostname
   //don't use ip to get hostname, if dhcp in use hostname can't be looked up by ip reliabley from the host table -duh
   //get hostname at the time of the scan, else may fall back to the host table for stuff that may not be resolved otherwise.
   //need some assurance it is not false, routers etc, should be flagged as static address on the devices added to the host table
   $query = "SELECT t1.hostIP, t1.hostname, t1.risk, t1.msg, t1.scriptid
             FROM nessus_results t1
             where report_id='$report_id'  AND record_type='C' $query_host $query_critical
             order by INET_ATON(t1.hostIP) ASC, t1.risk ASC";
   $result=$dbconn->Execute($query);

   $arrResults="";
   while( list($hostIP, $hostname, $risk, $msg, $scriptid) = $result->fields) {
      $arrResults[$hostIP][]=array('hostname' => $hostname,
                               'check' => getchecktype($scriptid),
                               'status' => getcrisk($risk), 
                               'msg' => $msg);
      $result->MoveNext();
   }

 //Vulnerability table configs
   $vcols = array('Check','Status','Description');
   //widths for columns
   $vwidth_array=array(55,15,120); // 196 total

   $count=0;
   $oldip="";
   // iterate through the IP is the results
   foreach ($arrResults as $hostIP=>$scanData) {
      $hostIP=htmlspecialchars_decode($hostIP);
      $hostname=htmlspecialchars_decode($hosts[$hostIP]);
      // new host record?
      if($oldip!=$hostIP) {
         $oldip=$hostIP;

         // don't print the table on the first host
         if($count==1) { 
            $pdf->InprotectTable($vcols, $all_results, $vwidth_array, $head_fill_color, $head_text_color, $fill_color,
                 $text_color, $line_color, $boarder_type, $row_height);
            $pdf->Ln();
         }

         //print out the host cell
         $pdf->SetFont('','B',10);
         $pdf->Cell(28, 6, $hostIP,1,0,'C');
         $pdf->Cell(57, 6, $hostname,1,0,'C');
         $pdf->Cell(105, 6, "",1,0,'C');
         $pdf->SetFont('','');
         $pdf->Ln();

      }

      // now iterate through the scan results for this IP
      $all_results = array();
      foreach($scanData as $vuln) {
         $check= $vuln['check'];
      	 $status= $vuln['status'];
         $msg=trim($vuln['msg']);
         $msg=htmlspecialchars_decode($msg);
         $msg=preg_replace('/^\n+/','',$msg);
         $msg= str_replace("&#039;","'", $msg);
         // append it to the results array
         $all_results[] = array( $check, $status, $msg );
      }
      // increment host counter
      $count=1;

   }
   // print out the final table
   if($count!=0) {
      $pdf->InprotectTable($vcols, $all_results, $vwidth_array, $head_fill_color, $head_text_color, $fill_color, $text_color,
          $line_color, $boarder_type, $row_height);
   }

    $pdf->Ln();

    $pdf->Cell(0,6, 'Inprotect - web interface for Nessus and Nmap scanners',0, 1, 'C', 0);

} #$pdf->Image('/var/www/html/images/Picture2.png',50,90,0,0,$type='',$link='');

//output the pdf, now we're done$pdf-
header('Content-Type: application/pdf');
//header("Content-disposition:  attachment; filename=scanresults-$uid-$scantime.pdf");
$pdf->Output("scanresults-$username-$scantime.pdf","I");


// prints out the table of risks
function printTable() {
    //build table
    $pdf->InprotectTable($cols, $all_results, $width_array, $head_fill_color, $head_text_color, $fill_color, $text_color, $line_color, $boarder_type, $row_height);

    $pdf->Ln();
}

//matches risks number with colors
function getriskcolor($risk)
{
    switch ($risk)
    {
    case 2:
        $risk=array(255,0,0);
        break;
    case 3:
        $risk=array(255,255,0);
        break;
    case 6:
        $risk=array(0,139,69);
        break;
    }
    return $risk;
}


function GetFilename($file) {
    $filename = substr($file, strrpos($file,'/')+1,strlen($file)-strrpos($file,'/'));
    return $filename;
}

function getchecktype($plugin) {
	$type ="";
    switch ($plugin)
    {
    case "21156":
        $type="Windows Compliance Checks";
        break;
    case "21157":
        $type="Windows File Contents Compliance Checks";
        break;
    case "24760":
        $type="UNIX Compliance Checks";
        break;
    }
    return $type;

} 


?>

