<?php
//
// $Id: servers.php,v 1.10 2006/09/19 04:57:01 airwofl Exp $
//
/***********************************************************/
/*                    Inprotect                            */
/* --------------------------------------------------------*/
/* Copyright (C) 2006 Inprotect                            */
/*                                                         */
/* This program is free software; you can redistribute it  */
/* and/or modify it under the terms of version 2 of the    */
/* GNU General Public License as published by the Free     */
/* Software Foundation.                                    */
/* This program is distributed in the hope that it will be */
/* useful, but WITHOUT ANY WARRANTY; without even the      */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE. See the GNU General Public License  */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 59 Temple Place, */
/* Suite 330, Boston, MA 02111-1307 USA                    */
/*                                                         */
/* Contact Information:                                    */
/* inprotect-devel@lists.sourceforge.net                   */
/* http://inprotect.sourceforge.net/                       */
/***********************************************************/
/* See the README.txt and/or help files for more           */
/* information on how to use & config.                     */
/* See the LICENSE.txt file for more information on the    */
/* License this software is distributed under.             */
/*                                                         */
/* This program is intended for use in an authorized       */
/* manner only, and the author can not be held liable for  */
/* anything done with this program, code, or items         */
/* discovered with this program's use.                     */
/***********************************************************/

$pageTitle = "Scanners";
require_once('config.php');
require_once('functions.inc');
require_once('auth.php');
require_once('header2.php');
//require_once('permissions.inc.php');

$getParams = array( "disp", "op", "nid" );
$postParams = array( "disp", "op", "nid", "nname", "ndescription", "nhostname", "nport", "ntype", 
               "nessususer", "nessuspassword", "nmaxscans", "enabled", "check", "confirm"
              );

switch ($_SERVER['REQUEST_METHOD'])
{
case "GET" :
   foreach($getParams as $gp) {
      if (isset($_GET[$gp])) { 
         $$gp=htmlspecialchars(mysql_real_escape_string(trim($_GET[$gp])), ENT_QUOTES); 
      } else { 
         $$gp=""; 
      }
   }
   break;
case "POST" :
   foreach($postParams as $pp) {
      if (isset($_POST[$pp])) { 
         $$pp=htmlspecialchars(mysql_real_escape_string(trim($_POST[$pp])), ENT_QUOTES); 
      } else { 
         $$pp=""; 
      }
   }
   break;
}

   if(isset($_POST['server_zones'])) {
      foreach($_POST['server_zones'] as $zone) {
         $zones[] = htmlspecialchars(mysql_real_escape_string(trim($zone)), ENT_QUOTES); 
      }
   }

if ($op=="forcecheck")
{
   if( isset($meta_info) && is_array($meta_info) )
   {
      $meta_info_count = count($meta_info);
   }
   else
   {
      $meta_info_count = 0;
   }
   $meta_info[$meta_info_count]["http-equiv"] = "refresh";
   $meta_url = "servers.php";
   $meta_info[$meta_info_count]["content"] = "20;url=".$meta_url;
}

//$acl=checkacl("zones", $dbconn);
/*
$zones = (strpos($_SESSION['roles'],"zones") === false) ? FALSE : TRUE;
*/

if (!$uroles['zones']) {
   echo "Access Denied!!!<br>";
   logAccess( "ACCESS DENIED" );
}

function navbar ( ) {
     global $nid, $dbconn;
     echo "<center><h3>Manage Nessus Scan Servers</h3>
          [ <a href=\"servers.php\">Main</a> ]";
     if ($nid) {
          $query = "SELECT name FROM nessus_servers WHERE id='$nid'";
          $result=$dbconn->Execute($query);
          list($servername) = $result->fields;

          echo " -> Edit Nessus Server [ <font color=red>$servername</font> ] ( ";

          echo "<a href=\"servers.php?disp=edit&nid=$nid\">EDIT</a>
               | <a href=\"servers.php?disp=editzones&nid=$nid\">EDIT ZONES</a> )";
     }
     echo "</center>";

}

function server_status( ) {
     global $check, $dbconn;

     navbar( );

     if ($check=="1") {

          $url = "servers.php";
          echo "<meta http-equiv=\"refresh\" content=\"20;
               URL=$url\" />";
          $query="Update nessus_servers set status='U', checkin_time=now()-interval 301 second";
          $result=$dbconn->Execute($query);
          echo "<I>This page will automatically refresh in 20 seconds with a new status update</I><FONT SIZE=\"1\"><BR><BR></FONT>";
     }

     $formTypes = array ( "G" => "Global", "P" => "Private", "S" => "Site");

     $query = "SELECT
          id, name, description, hostname,
          current_scans, type,
         max_scans, checkin_time, status, enabled
         FROM nessus_servers
         GROUP BY id";

#     $query = "SELECT
#          id, name, description, hostname,
#          count(nessus_scan.status) current_scans, type,
#         max_scans, checkin_time, nessus_servers.status
#         FROM nessus_servers
#         LEFT JOIN nessus_scan ON nessus_servers.id = nessus_scan.server_id
#               AND nessus_scan.status in ('P','R')
#         WHERE (owner='$username' OR type='G')
#         GROUP BY id";     

     $result=$dbconn->Execute($query);
     echo <<<EOT

<B>Nessus Servers</B>
          <br><br>
          <table border="1" width="100%">
          <tr>
          <td>Name</td>
          <td>Description</td>
          <td>Hostname</td>
          <td>Type</td>
          <td>Check-In Time</td>
          <td>Running Scans</td>
          <td>Max Scans</td>
          <td>Status</td>
          <td>Enabled</td>
          <td>&nbsp;</td>
EOT;

     while ( !$result->EOF ) {
         list($nid, $nname, $ndescription, $nhostname, $ncurrent, $ntype, $nmax, $checkin, $serv_status, $serv_enabled ) =
          $result->fields;

          echo "<tr>
               <td>$nname</td><td>$ndescription</td><td>$nhostname</td><td>";

               echo $formTypes["$ntype"];

               echo "</td><td>$checkin</td>
               <td>$ncurrent</td><td>$nmax</td>";

          if ( $serv_enabled ) { 
               $txt_enabled = "<td>ENABLED</td>"; 
          } else { 
               $txt_enabled = "<td style=\"background-color:red;\">DISABLED</td>"; 
          }

          switch ($serv_status) {
               case "N":
                    $srv_stat_desc= "OFFLINE";
                    break;
               case "C":
                    $srv_stat_desc= "CHECKING";
                    break;
               case "A":
                    $srv_stat_desc= "ONLINE";
                    break;
               default:
                    $srv_stat_desc= "UNKNOWN";
                    break;
          }
          echo <<<EOT
<td>$srv_stat_desc</td>$txt_enabled
<td align="center"><a href="servers.php?disp=edit&nid=$nid"><img src="images/pencil.png"></a>
    <a href="servers.php?disp=delete&nid=$nid" onclick="return confirmDelete();"><img src="images/delete.png"></a></td>
</tr>
EOT;
          $result->MoveNext();
     }

     echo "</table><BR>";
     echo "<a href=\"servers.php?disp=add\">Add New Nessus Server</A>";
     echo " | <a href=\"servers.php?check=1\">Force Servers Check</a>";

}

function add_server(){
     global $module_name, $db;

     navbar( );

 echo <<<EOT
<b>Add New Nessus Server</b><br>
<form method="POST" action="servers.php">
<input type="hidden" name="disp" value="save">
<table>
<tr><td>Server Name:</td>
<td><input type="text" name="nname" value=""></td>
</tr>
<tr><td>Server Description:</td>
<td><input type="text" name="ndescription" value=""></td>
</tr>
<tr><td>Server Hostname/IP address:</td>
<td><input type="text" name="nhostname" value=""></td>
</tr>
<tr>
<td>Server Port:</td>
<td><input type="text" name="nport" value="1241"></td>
</tr>
<tr><td>Server type:</td> 
<td><select name="ntype"> 
<option value="G" selected>Global
<option value="P">Private 
</select></td> 
</tr> 
<tr>
<td>Nessus Username:</td>
<td><input type="text" name="nessususer" value=""></td>
</tr>
<tr>
<td>Nessus Password:</td>
<td><input type="password" name="nessuspassword" value=""></td>
</tr></table>
<input type="submit" name="submit" value="Save">
</form>
EOT;

}

function delete_server($nid ){
     global $uroles, $username, $dbconn;

     navbar( );

    if ( $uroles['zones'] ) {

       $query = "SELECT name
         FROM nessus_servers
         WHERE id = '$nid'";

       $result=$dbconn->Execute($query);
       list($nname) = $result->fields;

       $query = "DELETE FROM nessus_server_zones WHERE nessusid = '$nid'";
       $result=$dbconn->Execute($query);

       $query = "DELETE FROM nessus_servers WHERE id = '$nid'";
       $result=$dbconn->Execute($query);

       echo "Deleted Server <i>\"$nname\"</i>";
       logAccess( "DELETED NESSUS SCAN SERVER $nname AND ASSOCIATED ZONES" );
    } else {
       echo "ACCESS DENIED";
       logAccess( "UNAUTHORIZED ATTEMPT TO DELETED NESSUS SCAN SERVER $nname" );
    }

}

function edit_server($nid, $op) {
     global $module_name, $dbconn;

     navbar( );


     $formTypes = array ( "G" => "Global", "P" => "Private", "S" => "Site" );

         $query="SELECT t1.id, t1.name, t1.description, t1.hostname, 
               t1.port, t1.user, t1.password, t1.max_scans, 
               count(t2.status), t1.current_scans, t1.type, t1.enabled FROM nessus_servers t1
               LEFT JOIN I3_jobs t2 ON t1.id = t2.scan_SERVER 
                    AND t2.status in ('P','R') 
          WHERE t1.id='$nid' GROUP BY t1.id";

     $result=$dbconn->Execute($query);

     list ($nid, $nname, $ndescription, $nhostname, $nport, $nusername, $npassword, 
          $nmaxscans, $currentscans, $ntype, $tiEnabled ) = $result->fields;

     logAccess( "EDIT SERVER [ $nname ]" );

     if ( $tiEnabled ) { 
          $enabled_checked = "checked ";
     } else {
          $enabled_checked = "";
     }

     echo <<<EOT

<B>Edit Nessus Server</b><br>
<form method="post" action="servers.php">
<input type="hidden" name="disp" value="save">
<input type="hidden" name="op" value="edit">
<input type="hidden" name="nid" value="$nid">
<table summary="Server Details" width="100%">
<tr><td width="35%">Server ID</td><td>$nid</td></tr>
<tr><td>Server Name:</td>
<td><input type="text" name="nname" value="$nname"></td>
</tr>
<tr><td>Server Description:</td>
<td><input type="text" name="ndescription" value="$ndescription"></td>
</tr>
<tr><td>Hostname/IP address</td>
<td><input type="text" name="nhostname" value="$nhostname"></td>
</tr>
<tr><td>Nessus Port:</td>
<td><input type="text" name="nport" value="$nport"></td>
</tr>
         <tr><td>Type:</td>
         <td><select name="ntype">";
EOT;

foreach ($formTypes as $typekey => $vText ) {
    if ( $typekey == $ntype ) {
         $selected = "SELECTED";
    } else {
         $selected = "";
    }
   echo "<option value='$typekey' $selected>$vText</option>";
}

echo <<<EOT
         </select></td>
         </tr>
<tr><td>Nessus Username:</td>
<td><input type="text" name="nessususer" value="$nusername"></td>
</tr>
<tr><td>Nessus Password:</td>
<td><input type="password" name="nessuspassword" value="$npassword"></td>
</tr>
<tr><td>RUN Max</td>
<td><input type="text" name="nmaxscans" value="$nmaxscans"></td>
</tr>
<tr><td>Current Scans</td><td>$currentscans</td></tr>
<tr><td align='right'>Enabled for Scanning</td>
     <td><input type="checkbox" name="enabled" value="1" $enabled_checked ></td>
</tr>
<tr><td align='right'>&nbsp;</td>
     <td><input type="submit" name="submit" value="Save"></td>
</tr>
</table>

</form>
EOT;


}

function manage_server_zones($nid) {
     global $module_name, $dbconn;

     navbar( );

     $query = "SELECT name FROM nessus_servers WHERE id='$nid'";
     $result=$dbconn->Execute($query);
     list($nname) = $result->fields;

     logAccess( "MANAGE ZONES FOR SERVER [ $nname ]" );

     echo <<<EOT
<br>
<form action="/servers.php" method="POST" onSubmit="selectAllOptions('assigned_zones');">
<TABLE width=100% border=0>

<TR>
     <TD colSpan=3>
     <h4> "$nname" - Zone Access:</h4>
     </TD>
</TR>
<TR>
<TD valign=top align=left width=150>Assigned<br>

    <input type="hidden" name="disp" value="updatezones">
    <input type="hidden" name="nid" value="$nid">
    <select name="server_zones[]" id="assigned_zones" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>
EOT;


     $query = "SELECT nessus_zones.id, nessus_zones.name FROM nessus_server_zones
          LEFT JOIN nessus_zones ON nessus_server_zones.zoneid = nessus_zones.id 
          WHERE nessus_server_zones.nessusid = '$nid'";
     $result=$dbconn->Execute($query);

     while ( !$result->EOF ) {
          list($zid, $zname) = $result->fields;
          echo "<OPTION value=\"$zid\">$zname</OPTION>\n";
          $result->MoveNext();
     }

     echo <<<EOT

</SELECT></td>
<td><input type='button' value='<< Add' onclick="move2(this.form.available_zones,this.form.assigned_zones)"><br/>
<input type='button' value='Remove >>' onclick="move2(this.form.assigned_zones,this.form.available_zones)"></td>
     <td valign=top align="left">
          <select name="all_available_zones[]" id="available_zones" style="WIDTH: 187px; HEIGHT: 200px" multiple="multiple" size=20>\n";
EOT;


     $query = "SELECT nessus_zones.id, nessus_zones.name FROM nessus_zones
          LEFT JOIN nessus_server_zones ON nessus_zones.id = nessus_server_zones.zoneid
          AND nessus_server_zones.nessusid = '$nid'
          WHERE nessus_server_zones.zoneid is Null";


     $result=$dbconn->Execute($query);

     while ( !$result->EOF ) {
          list($nid, $nname) = $result->fields;
          echo "<OPTION value=\"$nid\" >$nname</OPTION>\n";
          $result->MoveNext();
     }

     echo <<<EOT
</select>
</td></tr>
<tr><td colspan="3"><input type='submit' name='submit' value='Update Zones'></input></td></tr>
</TABLE></form>
EOT;

}

function save_server( $op, $nid, $nname, $ndescription, $nhostname, $nport, $ntype,
     $nessususer, $nessuspassword, $nmaxscans, $enabled ){
     global $username, $dbconn;

     $flag=1;
     $problemtext="";
	 $check = "";
          //check input
     if($nname=="" or $nhostname=="" or $nport=="" or $nessususer=="" or !is_numeric($nport)){
          $flag=0;
          $problemtext= "Please fill in all required fields.<br>";
     }

     if ($op == "edit" ) {
          $query="UPDATE nessus_servers 
               SET 
               name='$nname', description='$ndescription', 
               hostname='$nhostname', port='$nport', 
               user='$nessususer', password='$nessuspassword',
               max_scans='$nmaxscans', TYPE='$ntype', owner='$username', enabled='$enabled'
               WHERE id='$nid'";
          $result=$dbconn->Execute($query);
          echo "Updated $nid Nessus Server settings saved.<BR>";
          logAccess( "UPDATED SETTINGS FOR SERVER [ $nname ]" );


     } else {
          //check for duplicates
          $query="SELECT name
               FROM nessus_servers
               WHERE name='$nname'
               OR hostname='$nhostname'";

          $hostsfound = $dbconn->GetOne($query);

          if($hostsfound>0){
               $flag=0;
               $problemtext= "This Nessus server already defined";
          }

          if($flag==1){
               $query="INSERT INTO nessus_servers (
                    name, description, hostname,
                    port, type, owner, user, password,
                    checkin_time, status
                    ) values (
                    '$nname', '$ndescription', '$nhostname',
                    '$nport', '$ntype', '$username', '$nessususer', '$nessuspassword',
                    now()-interval 301 second, 'U')";

               $result = $dbconn->Execute($query);

               echo "Nessus Server settings saved.<BR>";
               logAccess( "ADDED SCAN SERVER [ $nname ]" );
          } else {
               echo "<center><b>ERROR</b></center><br><br>There was a problem saving configuration:<br />$problemtext<br>";
          }
     }

     server_status($check);

}


function update_zones($nid, $zones ){
     global $username, $dbconn;

     if ( $nid ) {
          $query = "delete from nessus_server_zones where nessusid=$nid";
          $result=$dbconn->Execute($query);
     }

     if ( $nid && $zones ) {

          $query = "SELECT name FROM nessus_servers WHERE id='$nid'";
          $result = $dbconn->Execute($query);
          list($nname) = $result->fields;
          echo "UPDATING ZONES FOR SERVER: [$nname]<br>";

          foreach( $zones as $zid ) {

               if ( $zid ) {
                    $query = "INSERT INTO nessus_server_zones (zoneid, nessusid)
                         VALUES ('$zid', '$nid' );";
                    $result = $dbconn->Execute($query);
                    logAccess( "MODIFIED SERVERS ZONES FOR SERVER [ $nname ]" );
               }
          }
     }

     echo "<br>";

     manage_server_zones($nid);
}

switch($disp) {

     case "add":
          add_server();
          break;

     case "delete":
          delete_server( $nid );
          break;

     case "edit":
          edit_server($nid, $op);
          break;

     case "editzones":
          manage_server_zones($nid);
          break;

     case "save":
          save_server($op, $nid,  $nname, $ndescription, $nhostname, $nport, $ntype, $nessususer, $nessuspassword, 
               $nmaxscans, $enabled );
          break;

     case "updatezones":
          update_zones( $nid, $zones );
          break;

    default:
          server_status( );
          break;

}


require_once('footer.php');
?>
