-- phpMyAdmin SQL Dump
-- version 2.11.6
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jul 20, 2008 at 02:28 PM
-- Server version: 5.0.45
-- PHP Version: 5.2.4

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `inprotect2`
--

-- --------------------------------------------------------

--
-- Table structure for table `contacts`
--

CREATE TABLE IF NOT EXISTS `contacts` (
  `id` int(11) NOT NULL auto_increment,
  `fk_uname` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pn_email` varchar(60) collate utf8_unicode_ci NOT NULL default '',
  `user_namef` varchar(25) collate utf8_unicode_ci NOT NULL,
  `user_namel` varchar(25) collate utf8_unicode_ci NOT NULL,
  `user_title` varchar(50) collate utf8_unicode_ci NOT NULL,
  `addr_line1` varchar(100) collate utf8_unicode_ci NOT NULL,
  `addr_line2` varchar(100) collate utf8_unicode_ci NOT NULL,
  `city` varchar(50) collate utf8_unicode_ci NOT NULL,
  `state` varchar(25) collate utf8_unicode_ci NOT NULL,
  `zipcode` varchar(10) collate utf8_unicode_ci NOT NULL,
  `phone` varchar(15) collate utf8_unicode_ci NOT NULL,
  `fax` varchar(15) collate utf8_unicode_ci NOT NULL,
  `cell` varchar(15) collate utf8_unicode_ci NOT NULL,
  `txtDesc` text collate utf8_unicode_ci NOT NULL,
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `fk_uname` (`fk_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `contacts`
--


-- --------------------------------------------------------

--
-- Table structure for table `dashboards`
--

CREATE TABLE IF NOT EXISTS `dashboards` (
  `dashID` int(10) unsigned NOT NULL auto_increment,
  `dashName` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `dashDesc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `dashModule` varchar(50) collate utf8_unicode_ci NOT NULL default '',
  `dashStatus` int(11) NOT NULL default '1',
  `dashLocation` varchar(25) collate utf8_unicode_ci NOT NULL default 'lcolumn',
  `dashURL` varchar(55) collate utf8_unicode_ci NOT NULL default '',
  `dashOrder` int(10) default NULL,
  PRIMARY KEY  (`dashID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=7 ;

--
-- Dumping data for table `dashboards`
--

INSERT INTO `dashboards` (`dashID`, `dashName`, `dashDesc`, `dashModule`, `dashStatus`, `dashLocation`, `dashURL`, `dashOrder`) VALUES
(1, 'dvt', 'Vulnerability Totals', 'dashDVT.inc', 1, 'rcolumn', 'dashDVT.inc', 2),
(2, 'dmt', 'My Totals', 'dashDMT.inc', 1, 'rcolumn', 'dashDMT.inc', 1),
(3, 'dss', 'System Stats', 'dashDSS.inc', 1, 'lcolumn', 'dashDSS.inc', 3),
(4, 'dpe', 'Pending Exceptions', 'dashDPE.inc', 1, 'lcolumn', 'dashDPE.inc', 5),
(5, 'dnw', 'News Items', 'dashDNW.inc', 1, 'rcolumn', 'dashDNW.inc', 6),
(6, 'dsb', 'BookMarks', 'dashDSB.inc', 1, 'lcolumn', 'dashDSB.inc', 4);

-- --------------------------------------------------------

--
-- Table structure for table `exceptions`
--

CREATE TABLE IF NOT EXISTS `exceptions` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `eid` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `submitDate` datetime default NULL,
  `lastModified` datetime default NULL,
  `closeDate` datetime default NULL,
  `submitter` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `lastEditor` varchar(20) collate utf8_unicode_ci NOT NULL default '',
  `approver` varchar(20) collate utf8_unicode_ci default NULL,
  `status` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `plugin` int(10) unsigned NOT NULL default '0',
  `type` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `application` varchar(45) collate utf8_unicode_ci default NULL,
  `os` varchar(45) collate utf8_unicode_ci NOT NULL default '',
  `justification` text collate utf8_unicode_ci NOT NULL,
  `comments` text collate utf8_unicode_ci,
  `evidence` blob,
  `secRqmts` text collate utf8_unicode_ci,
  `hostip` varchar(40) collate utf8_unicode_ci default NULL,
  `hostname` varchar(255) collate utf8_unicode_ci default NULL,
  `port` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `eid` (`eid`),
  KEY `ip` (`hostip`),
  KEY `hostname` (`hostname`),
  KEY `plugin` (`plugin`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='Vulnerability Exceptions' AUTO_INCREMENT=1 ;

--
-- Dumping data for table `exceptions`
--


-- --------------------------------------------------------

--
-- Table structure for table `groups`
--

CREATE TABLE IF NOT EXISTS `groups` (
  `gid` int(11) NOT NULL auto_increment,
  `groupName` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `groupDesc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`gid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=7 ;

--
-- Dumping data for table `groups`
--

INSERT INTO `groups` (`gid`, `groupName`, `groupDesc`) VALUES
(1, 'Admin', 'Administrators'),
(2, 'Users', 'Power users - all non-admin roles'),
(3, 'Scanners', 'Authorized to Scan'),
(4, 'SelfService', 'Authorized to use Subnet Scanner'),
(5, 'Developers', 'Developer Role'),
(6, 'SOC TEAM', 'SOC');

-- --------------------------------------------------------

--
-- Table structure for table `group_roles`
--

CREATE TABLE IF NOT EXISTS `group_roles` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `gid` int(10) unsigned NOT NULL default '0',
  `roleID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gid` (`gid`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=111 ;

--
-- Dumping data for table `group_roles`
--

INSERT INTO `group_roles` (`id`, `gid`, `roleID`) VALUES
(1, 1, 1),
(2, 1, 2),
(3, 1, 3),
(4, 1, 4),
(5, 1, 5),
(6, 1, 6),
(7, 1, 7),
(8, 1, 8),
(9, 1, 9),
(10, 1, 10),
(11, 1, 11),
(14, 2, 5),
(25, 4, 3),
(24, 3, 3),
(18, 2, 9),
(23, 2, 5),
(22, 2, 9),
(21, 3, 3),
(26, 4, 3),
(27, 1, 1),
(28, 1, 8),
(29, 1, 9),
(30, 1, 10),
(31, 1, 13),
(32, 1, 3),
(33, 1, 4),
(34, 1, 11),
(35, 1, 6),
(36, 1, 5),
(37, 1, 12),
(38, 1, 2),
(39, 1, 7),
(40, 1, 1),
(41, 1, 8),
(42, 1, 9),
(43, 1, 10),
(44, 1, 13),
(45, 1, 3),
(46, 1, 4),
(47, 1, 11),
(48, 1, 6),
(49, 1, 5),
(50, 1, 12),
(51, 1, 2),
(52, 1, 7),
(53, 3, 3),
(54, 4, 3),
(55, 4, 12),
(56, 2, 9),
(57, 2, 5),
(58, 4, 9),
(59, 4, 3),
(60, 4, 12),
(61, 5, 14),
(62, 1, 1),
(63, 1, 8),
(64, 1, 9),
(65, 1, 10),
(66, 1, 13),
(67, 1, 3),
(68, 1, 4),
(69, 1, 11),
(70, 1, 6),
(71, 1, 5),
(72, 1, 12),
(73, 1, 2),
(74, 1, 7),
(75, 6, 1),
(76, 6, 8),
(77, 6, 10),
(78, 6, 13),
(79, 6, 3),
(80, 6, 6),
(81, 6, 12),
(82, 6, 16),
(83, 4, 9),
(84, 4, 3),
(85, 4, 12),
(86, 3, 3),
(87, 5, 14),
(88, 5, 14),
(89, 5, 14),
(90, 5, 14),
(91, 5, 14),
(92, 1, 1),
(93, 1, 17),
(94, 1, 14),
(95, 1, 8),
(96, 1, 9),
(97, 1, 10),
(98, 1, 13),
(99, 1, 3),
(100, 1, 4),
(101, 1, 11),
(102, 1, 6),
(103, 1, 5),
(104, 1, 12),
(105, 1, 16),
(106, 1, 2),
(107, 1, 7),
(108, 5, 14),
(109, 5, 14),
(110, 5, 14);

-- --------------------------------------------------------

--
-- Table structure for table `hosts`
--

CREATE TABLE IF NOT EXISTS `hosts` (
  `id` int(11) NOT NULL auto_increment,
  `hostip` varchar(40) default NULL,
  `hostname` varchar(64) NOT NULL default '',
  `description` varchar(200) NOT NULL default '',
  `status` varchar(45) NOT NULL default '',
  `os` varchar(100) NOT NULL default '',
  `site_code` varchar(25) NOT NULL,
  `ORG` varchar(25) default NULL,
  `contact` varchar(45) NOT NULL default '',
  `scanstate` varchar(25) default NULL,
  `report_id` int(11) NOT NULL default '0',
  `creport_id` int(11) NOT NULL default '0',
  `lastscandate` datetime default NULL,
  `createdate` datetime default NULL,
  `inactive` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hostname` (`hostname`),
  KEY `hostip` (`hostip`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `hosts`
--


-- --------------------------------------------------------

--
-- Table structure for table `host_macs`
--

CREATE TABLE IF NOT EXISTS `host_macs` (
  `id` int(11) NOT NULL auto_increment,
  `host_id` int(11) NOT NULL default '0',
  `mac_address` varchar(20) NOT NULL default '',
  `hostip` varchar(45) NOT NULL,
  `DeviceName` varchar(64) NOT NULL default '',
  `Port` varchar(32) NOT NULL default '',
  `LastSeen` datetime NOT NULL default '0000-00-00 00:00:00',
  `createdate` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mac_address` (`mac_address`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `host_macs`
--


-- --------------------------------------------------------

--
-- Table structure for table `host_stats`
--

CREATE TABLE IF NOT EXISTS `host_stats` (
  `vs_id` int(10) unsigned NOT NULL auto_increment,
  `report_id` int(11) NOT NULL,
  `host_id` int(11) NOT NULL,
  `hostip` varchar(15) collate utf8_unicode_ci NOT NULL,
  `hostname` varchar(64) collate utf8_unicode_ci NOT NULL,
  `scantime` varchar(20) collate utf8_unicode_ci NOT NULL,
  `vSerious` int(4) default '0',
  `vHigh` int(4) default '0',
  `vMed` int(4) default '0',
  `vMedLow` int(4) default '0',
  `vLowMed` int(4) default '0',
  `vLow` int(4) default '0',
  `vInfo` int(4) default '0',
  PRIMARY KEY  (`vs_id`),
  KEY `report_id` (`report_id`),
  KEY `host_id` (`host_id`),
  KEY `ip` (`hostip`,`hostname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='Per Host Summary of latest vulnerability totals' AUTO_INCREMENT=1 ;

--
-- Dumping data for table `host_stats`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_assets_hardware`
--

CREATE TABLE IF NOT EXISTS `I3_assets_hardware` (
  `id` int(11) NOT NULL auto_increment,
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `SystemVendor` varchar(25) NOT NULL default '',
  `ServiceTag` varchar(20) NOT NULL default '',
  `SystemModel` varchar(50) NOT NULL default '',
  `UUID` varchar(50) NOT NULL default '',
  `OSBootDevice` varchar(25) NOT NULL default '',
  `OSBuildNumber` varchar(8) NOT NULL default '',
  `OSCaption` varchar(100) NOT NULL default '',
  `OSCSDVersion` varchar(25) NOT NULL default '',
  `OSCurrentTimeZone` varchar(25) NOT NULL default '',
  `OSDistributed` varchar(8) NOT NULL default '',
  `OSFreeDiskSpace` varchar(16) NOT NULL default '',
  `OSEncryptionLevel` varchar(16) NOT NULL default '',
  `OSFreePhysicalMemory` varchar(16) NOT NULL default '',
  `OSFreeSpaceInPagingFiles` varchar(16) NOT NULL default '',
  `OSFreeVirtualMemory` varchar(16) NOT NULL default '',
  `OSInstallDate` varchar(25) NOT NULL default '',
  `OSLastBootUpTime` varchar(25) NOT NULL default '',
  `OSLocalDateTime` varchar(25) NOT NULL default '',
  `OSNumberOfUsers` int(8) NOT NULL default '0',
  `OSOrganization` varchar(25) NOT NULL default '',
  `OSOSType` int(2) NOT NULL default '0',
  `OSSerialNumber` varchar(25) NOT NULL default '',
  `OSServicePackMajorVersion` int(2) NOT NULL default '0',
  `OSServicePackMinorVersion` varchar(8) NOT NULL default '',
  `OSSizeStoredInPagingFiles` varchar(25) NOT NULL default '',
  `OSSystemDevice` varchar(25) NOT NULL default '',
  `OSSystemDirectory` varchar(25) NOT NULL default '',
  `OSSystemDrive` varchar(8) NOT NULL default '',
  `OSTotalVirtualMemorySize` varchar(8) NOT NULL default '',
  `OSTotalVisibleMemorySize` varchar(8) NOT NULL default '',
  `OSVersion` varchar(16) NOT NULL default '',
  `OSWindowsDirectory` varchar(25) NOT NULL default '',
  `BoardName` varchar(50) NOT NULL default '',
  `BoardManufacturer` varchar(50) NOT NULL default '',
  `BoardProduct` varchar(50) NOT NULL default '',
  `BoardSerialNumber` varchar(25) NOT NULL default '',
  `BiosSerialNumber` varchar(25) NOT NULL default '',
  `BiosReleaseDate` varchar(25) NOT NULL default '',
  `BiosVersion` varchar(25) NOT NULL default '',
  `Biossmbiosversion` varchar(8) NOT NULL default '',
  `Biossmmajorversion` varchar(4) NOT NULL default '',
  `Biossmminorversion` varchar(4) NOT NULL default '',
  `ProcArchitecture` varchar(8) NOT NULL default '',
  `ProcCurrentClockSpeed` varchar(16) NOT NULL default '',
  `ProcMaxClockSpeed` varchar(16) NOT NULL default '',
  `ProcCurrentVoltage` varchar(16) NOT NULL default '',
  `ProcL2CacheSize` varchar(16) NOT NULL default '',
  `ProcManufacturer` varchar(25) NOT NULL default '',
  `ProcRevision` varchar(16) NOT NULL default '',
  `ProcVersion` varchar(25) NOT NULL default '',
  `FloppyDeviceID` varchar(25) default NULL,
  `FloppyName` varchar(25) default NULL,
  `CDRomDrive` varchar(4) default NULL,
  `CDRomName` varchar(25) default NULL,
  `SystemAdminPasswordStatus` varchar(8) NOT NULL default '',
  `SystemDescription` varchar(25) NOT NULL default '',
  `SystemDomain` varchar(25) NOT NULL default '',
  `SystemDomainRole` int(4) NOT NULL default '0',
  `SystemManufacturer` varchar(25) NOT NULL default '',
  `SystemNumberofProcessors` int(4) NOT NULL default '0',
  `SystemPartofDomain` varchar(8) default 'False',
  `SystemSystemStartupDelay` int(4) NOT NULL default '0',
  `SystemSystemType` varchar(25) NOT NULL default '',
  `SystemTotalPhysicalMemory` varchar(8) NOT NULL default '',
  `SystemUserName` varchar(25) default NULL,
  `DiskConfig` varchar(8) default NULL,
  `DiskIndex` varchar(8) default NULL,
  `DiskInterfaceType` varchar(8) default NULL,
  `DiskMediaLoaded` varchar(25) default NULL,
  `DiskMediaType` varchar(25) default NULL,
  `DiskModel` varchar(25) NOT NULL default '',
  `DiskName` varchar(25) NOT NULL default '',
  `DiskPartitions` int(8) NOT NULL default '1',
  `DiskSCSIBus` varchar(25) NOT NULL default '',
  `DiskSignature` varchar(25) NOT NULL default '',
  `DiskSize` varchar(25) NOT NULL default '',
  `MemoryCapacity` varchar(25) NOT NULL default '',
  `MemoryDeviceLocator` varchar(8) NOT NULL default '',
  `MemoryMemoryType` varchar(25) NOT NULL default '',
  `MemorySpeed` varchar(25) NOT NULL default '',
  `NetworkManufacturer` varchar(25) default NULL,
  `NetworkIPAddress` varchar(16) NOT NULL default '',
  `NetworkName` varchar(25) default NULL,
  `NetworkServiceName` varchar(16) default NULL,
  `NetworkDHCPEnabled` tinyint(2) default NULL,
  `NetworkDHCPServer` varchar(25) default NULL,
  `NetworkDNS1` varchar(16) default NULL,
  `NetworkDNS2` varchar(16) default NULL,
  `NetworkDNS3` varchar(16) default NULL,
  `dtLastUpdate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `MACAddress` (`MACAddress`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_assets_hardware`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_assets_process`
--

CREATE TABLE IF NOT EXISTS `I3_assets_process` (
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `Caption` varchar(255) NOT NULL default '',
  `ExecutablePath` varchar(255) NOT NULL default '',
  `Name` varchar(255) NOT NULL default '',
  KEY `Computer` (`MACAddress`,`ComputerName`),
  KEY `Process` (`Caption`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `I3_assets_process`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_assets_services`
--

CREATE TABLE IF NOT EXISTS `I3_assets_services` (
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `DisplayName` varchar(255) NOT NULL default '',
  `PathName` varchar(255) NOT NULL default '',
  `ServiceType` varchar(25) NOT NULL default '',
  `Started` varchar(8) NOT NULL default '',
  `StartMode` varchar(8) NOT NULL default '',
  `State` varchar(25) NOT NULL default '',
  KEY `Computer` (`MACAddress`,`ComputerName`),
  KEY `Service` (`DisplayName`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `I3_assets_services`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_assets_software`
--

CREATE TABLE IF NOT EXISTS `I3_assets_software` (
  `MACAddress` varchar(12) NOT NULL default '',
  `ComputerName` varchar(64) NOT NULL default '',
  `Publisher` varchar(50) NOT NULL default '',
  `DisplayName` varchar(255) NOT NULL default '',
  `DisplayVersion` varchar(25) NOT NULL default '',
  `InstallDate` varchar(8) NOT NULL default '',
  `URLUpdateInfo` varchar(255) NOT NULL default '',
  `NoModify` tinyint(1) NOT NULL default '0',
  `NoRepair` tinyint(1) NOT NULL default '0',
  `NoRemove` tinyint(1) NOT NULL default '0',
  KEY `Computer` (`MACAddress`,`ComputerName`),
  KEY `Software` (`DisplayName`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `I3_assets_software`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_credentials`
--

CREATE TABLE IF NOT EXISTS `I3_credentials` (
  `id` int(11) NOT NULL auto_increment,
  `pn_uname` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `smbaccount` varchar(255) collate utf8_unicode_ci default NULL,
  `smbpassword` varchar(255) collate utf8_unicode_ci default NULL,
  `smbdomain` varchar(255) collate utf8_unicode_ci default NULL,
  `password_type` varchar(255) collate utf8_unicode_ci default 'Password',
  `TYPE` enum('C','G','P','O') collate utf8_unicode_ci default 'C',
  `ORG` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `select_key` varchar(14) collate utf8_unicode_ci default NULL,
  `createdate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `expiredate` datetime default NULL,
  `dtLastUpdated` datetime default NULL,
  `expired` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_credentials`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_Incidents`
--

CREATE TABLE IF NOT EXISTS `I3_Incidents` (
  `id` int(11) NOT NULL auto_increment,
  `host_id` int(11) NOT NULL default '0',
  `result_id` int(11) NOT NULL default '0',
  `scriptid` varchar(40) NOT NULL default '',
  `service` varchar(40) NOT NULL default '',
  `risk` enum('1','2','3','4','5','6','7') NOT NULL default '7',
  `msg` text NOT NULL,
  `notes` text NOT NULL,
  `isCompCheck` enum('0','1') NOT NULL default '0',
  `exception_id` varchar(25) default NULL,
  `exception_approved` enum('0','1') NOT NULL default '0',
  `date_open` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_lastseen` datetime default NULL,
  `date_ack` datetime default NULL,
  `date_resolved` datetime default NULL,
  `status` varchar(8) NOT NULL default 'open',
  PRIMARY KEY  (`id`),
  KEY `host_id` (`host_id`,`scriptid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_Incidents`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_jobs`
--

CREATE TABLE IF NOT EXISTS `I3_jobs` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `username` varchar(25) NOT NULL default '',
  `fk_name` varchar(50) default NULL,
  `job_TYPE` char(1) NOT NULL default 'M',
  `meth_SCHED` char(1) NOT NULL default 'N',
  `meth_TARGET` text,
  `meth_CRED` int(11) default NULL,
  `meth_VSET` int(11) NOT NULL default '1',
  `meth_CUSTOM` enum('N','A','R') NOT NULL default 'N',
  `meth_CPLUGINS` text,
  `meth_Wcheck` text,
  `meth_Wfile` text,
  `meth_Ucheck` text,
  `meth_TIMEOUT` int(6) NOT NULL default '172800',
  `scan_ASSIGNED` varchar(25) default NULL,
  `scan_SERVER` int(11) NOT NULL default '0',
  `scan_START` datetime default NULL,
  `scan_END` datetime default NULL,
  `scan_SUBMIT` datetime default NULL,
  `scan_NEXT` varchar(14) default NULL,
  `scan_PID` int(11) NOT NULL default '0',
  `scan_PRIORITY` tinyint(1) NOT NULL default '3',
  `status` char(1) NOT NULL default 'S',
  `notify` varchar(255) NOT NULL default '',
  `report_id` int(11) NOT NULL default '0',
  `tracker_id` int(11) default NULL,
  `failed_attempts` tinyint(1) NOT NULL default '0',
  `authorized` tinyint(1) NOT NULL default '0',
  `author_uname` varchar(25) default NULL,
  PRIMARY KEY  (`id`,`name`),
  KEY `name` (`name`),
  KEY `scan_END` (`scan_END`),
  KEY `report_id` (`report_id`),
  KEY `subnet` (`fk_name`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 PACK_KEYS=0 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_jobs`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_job_schedule`
--

CREATE TABLE IF NOT EXISTS `I3_job_schedule` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `username` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `schedule_type` enum('D','W','M') collate utf8_unicode_ci NOT NULL default 'M',
  `day_of_week` enum('Su','Mo','Tu','We','Th','Fr','Sa') collate utf8_unicode_ci NOT NULL default 'Mo',
  `day_of_month` int(2) unsigned NOT NULL default '1',
  `time` time NOT NULL default '00:00:00',
  `email` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `meth_TARGET` text collate utf8_unicode_ci,
  `meth_CRED` int(11) default NULL,
  `meth_VSET` int(11) NOT NULL default '1',
  `meth_CUSTOM` enum('N','A','R') collate utf8_unicode_ci NOT NULL default 'N',
  `meth_CPLUGINS` text collate utf8_unicode_ci,
  `meth_Wcheck` text collate utf8_unicode_ci,
  `meth_Wfile` text collate utf8_unicode_ci,
  `meth_Ucheck` text collate utf8_unicode_ci,
  `meth_TIMEOUT` int(11) default '172800',
  `scan_ASSIGNED` varchar(25) collate utf8_unicode_ci default NULL,
  `next_CHECK` varchar(14) collate utf8_unicode_ci NOT NULL default '',
  `createdate` datetime default NULL,
  `enabled` enum('0','1') collate utf8_unicode_ci NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;


--
-- Dumping data for table `I3_job_schedule`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_orgs`
--

CREATE TABLE IF NOT EXISTS `I3_orgs` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `org_code` varchar(25) NOT NULL default '',
  `description` text NOT NULL,
  `poc` varchar(100) NOT NULL default '',
  `email_list` text,
  `website` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_orgs`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_org_sites`
--

CREATE TABLE IF NOT EXISTS `I3_org_sites` (
  `orgID` int(11) NOT NULL default '0',
  `siteID` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `I3_org_sites`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_org_users`
--

CREATE TABLE IF NOT EXISTS `I3_org_users` (
  `orgID` int(11) NOT NULL default '0',
  `pn_uname` varchar(255) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `I3_org_users`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_regions`
--

CREATE TABLE IF NOT EXISTS `I3_regions` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `reg_code` varchar(25) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_regions`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_region_states`
--

CREATE TABLE IF NOT EXISTS `I3_region_states` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `abSTATE` char(2) NOT NULL default '',
  `reg_code` varchar(25) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_region_states`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_scan_exclusions`
--

CREATE TABLE IF NOT EXISTS `I3_scan_exclusions` (
  `id` int(11) NOT NULL auto_increment,
  `sub_id` int(11) NOT NULL default '0',
  `ip_range` varchar(50) NOT NULL default '',
  `hostname` varchar(100) default NULL,
  `description` varchar(255) NOT NULL default '',
  `requestee` varchar(100) NOT NULL default '',
  `dtAdded` datetime NOT NULL default '0000-00-00 00:00:00',
  `dtModified` datetime default NULL,
  `updatedBy` varchar(25) default NULL,
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `sub_id` (`sub_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_scan_exclusions`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_sites`
--

CREATE TABLE IF NOT EXISTS `I3_sites` (
  `id` int(11) NOT NULL auto_increment,
  `nnoc_id` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `site_code` varchar(25) NOT NULL default '',
  `description` text NOT NULL,
  `addr_line1` varchar(100) NOT NULL default '',
  `addr_line2` varchar(100) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(25) NOT NULL default '',
  `zipcode` varchar(10) NOT NULL default '',
  `poc` varchar(100) NOT NULL default '',
  `nnoc_poc` text NOT NULL,
  `report_sent` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `site_code` (`site_code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_sites`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_site_users`
--

CREATE TABLE IF NOT EXISTS `I3_site_users` (
  `username` varchar(25) NOT NULL default '',
  `siteID` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `I3_site_users`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_subnets`
--

CREATE TABLE IF NOT EXISTS `I3_subnets` (
  `id` int(11) NOT NULL auto_increment,
  `nnoc_id` varchar(12) NOT NULL default '',
  `CIDR` varchar(20) NOT NULL default '',
  `site_code` varchar(25) NOT NULL default '',
  `ORG` varchar(25) default NULL,
  `start_ip` varchar(16) NOT NULL default '',
  `end_ip` varchar(16) NOT NULL default '',
  `restrict_start` time default NULL,
  `restrict_cutoff` time default NULL,
  `restrict_day` char(2) default NULL,
  `dtLastScanned` datetime NOT NULL default '0000-00-00 00:00:00',
  `dtLastNMAP` DATETIME NULL,
  `report_id` int(11) NOT NULL default '0',
  `creport_id` int(11) NOT NULL default '0',
  `iCntISVM` INT( 11 ) NOT NULL DEFAULT '0',
  `range_size` int(8) NOT NULL default '0',
  `location` varchar(50) default NULL,
  `address` varchar(255) default NULL,
  `stAbbrev` char(2) NOT NULL default '',
  `poc` varchar(255) default NULL,
  `poc_alt` varchar(100) default NULL,
  `description` text,
  `cntHosts` int(3) NOT NULL default '0',
  `tiScanApproval` tinyint(1) NOT NULL default '1',
  `tiReadReceipt` tinyint(1) NOT NULL default '0',
  `tiAutoEmail` tinyint(1) NOT NULL default '0',
  `status` varchar(12) NOT NULL default '',
  `isFirewalled` enum('0','1') NOT NULL default '0',
  `serial_flag` char(1) NOT NULL default 'N',
  `auditable` char(1) NOT NULL default 'N',
  `rt_lastupdate` varchar(10) NOT NULL default '',
  `updatedBy` varchar(25) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `CIDR` (`CIDR`),
  KEY `nnoc_id` (`nnoc_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_subnets`
--


-- --------------------------------------------------------

--
-- Table structure for table `I3_systems`
--

CREATE TABLE IF NOT EXISTS `I3_systems` (
  `id` int(11) NOT NULL auto_increment,
  `systemID` varchar(50) NOT NULL default '',
  `name` varchar(100) NOT NULL default '',
  `acronym` varchar(25) NOT NULL default '',
  `parent` varchar(25) NOT NULL default 'SELF',
  `site_code` varchar(25) NOT NULL default '',
  `system_type` varchar(25) NOT NULL default '',
  `status` varchar(25) NOT NULL default '',
  `description` text NOT NULL,
  `location` varchar(50) default NULL,
  `program` varchar(25) NOT NULL default '',
  `owner` varchar(50) NOT NULL default '',
  `owner_phone` varchar(15) default NULL,
  `owner_email` varchar(100) NOT NULL default '',
  `isso_poc` varchar(100) NOT NULL default '',
  `isso_phone` varchar(15) NOT NULL default '',
  `isso_email` varchar(100) NOT NULL default '',
  `isso_alt` varchar(100) NOT NULL default '',
  `da_authority` varchar(100) default NULL,
  `admin_sys` varchar(100) default NULL,
  `admin_network` varchar(100) default NULL,
  `dtLastScanned` datetime default NULL,
  `report_id` int(11) default NULL,
  `creport_id` int(11) NOT NULL default '0',
  `cntHosts` int(5) NOT NULL default '0',
  `tiScanApproval` enum('0','1') NOT NULL default '1',
  `tiReadReceipt` enum('0','1') NOT NULL default '0',
  `dtLastUpdated` datetime NOT NULL default '0000-00-00 00:00:00',
  `updatedBy` varchar(25) NOT NULL default '',
  `active` char(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `acronym` (`acronym`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_systems`
--

--
-- Table structure for table `I3_system_users`
--
DROP TABLE IF EXISTS `I3_system_users`;
CREATE TABLE IF NOT EXISTS `I3_system_users` (
`sysID` int( 11 ) NOT NULL default '0',
`pn_uname` varchar( 255 ) NOT NULL default ''
) ENGINE = MYISAM DEFAULT CHARSET = latin1;
-- --------------------------------------------------------
--
-- Dumping data for table `I3_system_users`
--

--
-- Table structure for table `I3_ISVM`
--

DROP TABLE IF EXISTS `I3_ISVM`;
CREATE TABLE IF NOT EXISTS `I3_ISVM` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) collate latin1_bin NOT NULL,
  `topic` varchar(100) collate latin1_bin NOT NULL,
  `priority` varchar(25) collate latin1_bin NOT NULL default 'High',
  `cve_ids` text collate latin1_bin NOT NULL,
  `iCntPlugs` INT( 11 ) NOT NULL DEFAULT '0',
  `iVulnHosts` INT( 11 ) NOT NULL DEFAULT '0',
  `soft_affected` text collate latin1_bin NOT NULL,
  `isvm_TYPE` varchar(25) collate latin1_bin default NULL,
  `isvm_LINK` varchar(255) collate latin1_bin default NULL,
  `req_ack` enum('0','1') collate latin1_bin NOT NULL default '1',
  `req_comp` enum('0','1') collate latin1_bin NOT NULL default '1',
  `dt_release` date NOT NULL,
  `dt_ackdue` date NOT NULL,
  `dt_compliance` date NOT NULL,
  `dt_ackon` date NOT NULL,
  `dt_complied` date NOT NULL,
  `rev_summary` varchar(100) collate latin1_bin NOT NULL,
  `overview` text collate latin1_bin NOT NULL,
  `action` text collate latin1_bin NOT NULL,
  `disclaimer` text collate latin1_bin NOT NULL,
  `notice_sent` enum('0','1') collate latin1_bin NOT NULL default '0',
  `description` text collate latin1_bin NOT NULL,
  `dtcreated` datetime NOT NULL,
  `archived` enum('0','1') collate latin1_bin NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_bin AUTO_INCREMENT=1 ;


--
-- Dumping data for table `I3_ISVM`
--

--
-- Table structure for table `I3_ISVM_plugins`
--

DROP TABLE IF EXISTS `I3_ISVM_plugins`;
CREATE TABLE IF NOT EXISTS `I3_ISVM_plugins` (
  `iid` int(11) NOT NULL,
  `nessus_id` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `I3_ISVM_plugins`
--



--
-- Dumping data for table `I3_ISVM_plugins`
--

--
-- Table structure for table `I3_system_hosts`
--
DROP TABLE IF EXISTS `I3_system_hosts`;
CREATE TABLE `I3_system_hosts` (
  `id` int(11) NOT NULL auto_increment,
  `sysID` int(11) NOT NULL default '0',
  `host_id` int(11) default NULL,
  `hostip` varchar(40) NOT NULL,
  `hostname` varchar(64) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
-- --------------------------------------------------------
--
-- Dumping data for table `I3_system_hosts`
--


--
-- Table structure for table `I3_top100`
--

CREATE TABLE IF NOT EXISTS `I3_top100` (
  `id` int(11) NOT NULL auto_increment,
  `dtID` date NOT NULL default '0000-00-00',
  `hostIP` varchar(40) NOT NULL default '',
  `hostname` varchar(100) NOT NULL default '',
  `vcount` int(4) NOT NULL default '0',
  `dtlastscanned` datetime NOT NULL default '0000-00-00 00:00:00',
  `isAlive` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `dtID` (`dtID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `I3_top100`
--


-- --------------------------------------------------------

--
-- Table structure for table `inprotect_features`
--

CREATE TABLE IF NOT EXISTS `inprotect_features` (
  `feature_id` int(10) unsigned NOT NULL auto_increment,
  `feature_name` varchar(55) collate utf8_unicode_ci NOT NULL default '',
  `feature_desc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `feature_status` int(11) NOT NULL default '1',
  PRIMARY KEY  (`feature_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=7 ;

--
-- Dumping data for table `inprotect_features`
--

INSERT INTO `inprotect_features` (`feature_id`, `feature_name`, `feature_desc`, `feature_status`) VALUES
(1, 'enableFP', 'Enables False Positive flagging in the reports and search results', 0),
(2, 'enableExceptions', 'Enable tracking of exceptions to vulnerabilities', 1),
(3, 'enableNotes', 'Enable ability to attach notes to individual vulnerabilities', 0),
(4, 'enablePS', 'Enable the ability to perform NMAP scans through InProtect', 0),
(5, 'enableIUpdates', 'Enable admin the ability to perform plugin updates from the console', 0),
(6, 'enablePasswordQuality', 'Enable password quality checks (only valid for account in the internal InProtect SQL DB).', 0);

-- --------------------------------------------------------

--
-- Table structure for table `inprotect_settings`
--

CREATE TABLE IF NOT EXISTS `inprotect_settings` (
  `settingID` int(11) NOT NULL auto_increment,
  `settingName` varchar(100) collate utf8_unicode_ci NOT NULL default '',
  `settingValue` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `settingDescription` varchar(255) collate utf8_unicode_ci default NULL,
  `settingSection` varchar(50) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`settingID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=74 ;

--
-- Dumping data for table `inprotect_settings`
--

INSERT INTO `inprotect_settings` (`settingID`, `settingName`, `settingValue`, `settingDescription`, `settingSection`) VALUES
(1, 'version', '1.00.0_alpha_21', 'InProtect Version', 'Base'),
(2, 'inprotect_path', '/opt/Inprotect/html', 'InProtect Web Root', 'Base'),
(3, 'inprotect_url', 'https://localhost/', 'InProtect URL', 'Base'),
(4, 'nessus_install_url', 'http://install.nessus.org/releases', 'Nessus Download URL', 'Base'),
(5, 'nessus_install_file', 'nessus-2.0.x.tgz', 'Nessus Download Filename', 'Base'),
(6, 'nessus_plugins_sig', 'all-2.0.sig', 'Nessus Plugins Signature Filename', 'Base'),
(7, 'nessus_plugins_md5', 'all-2.0.tar.gz.md5', 'Nessus Plugins MD5 Filename', 'Base'),
(8, 'nessus_plugins_file', 'all-2.0.tar.gz', 'Nessus Plugins Download Filename', 'Base'),
(9, 'nessus_plugins_url', 'http://www.nessus.org/nasl', 'Nessus Plugins Download URL', 'Base'),
(10, 'mailfrom', 'USER@HOST.COM', 'InProtect From: Email Address', 'Mail'),
(11, 'replyto', 'USER@HOST.COM', 'InProtect Reply To: Email Address', 'Mail'),
(12, 'scanrequestemail', 'USER@HOST.COM', 'Scan Request Submission Notification Email Address(es)', 'Mail'),
(13, 'scanapproveemail', 'USER@HOST.COM', 'Scan Request Approval Notification Email Address(es)', 'Mail'),
(14, 'suggestionemail', 'USER@HOST.COM', 'InProtect Suggestion Email Address', 'Mail'),
(15, 'minLength', '8', 'Minimum Password Length', 'Auth'),
(16, 'maxLength', '64', 'Maximum Password Length', 'Auth'),
(17, 'minAlpha', '1', 'Minimum alphanumeric characters in the password', 'Auth'),
(18, 'minLower', '1', 'Minumum Lower Case letters in the password', 'Auth'),
(19, 'minUpper', '2', 'Minimum Upper Case letters in the password', 'Auth'),
(20, 'minSpecial', '1', 'Minimum number of special characters in the password', 'Auth'),
(21, 'minNumber', '1', 'Minimum number of numeric characters in the password', 'Auth'),
(22, 'allowscan', '1', 'Enable users to scan any IP address', 'Base'),
(23, 'enableprivate', '1', 'Enable scanning of private IP addresses (192.168.x.x, 10.x.x.x, 172.16.x.x)', 'Base'),
(24, 'emailverify', '0', 'Verify users email address', 'Mail'),
(25, 'authLDAP', '0', 'Authenticate users against an LDAP directory?', 'LDAP'),
(26, 'authFailLocal', '1', 'Fail through to local SQL authentication if LDAP server is unavailable', 'LDAP'),
(27, 'authLDAP_host', 'ldap://localhost:389', 'LDAP host (can be a hostname or a full LDAP URI)', 'LDAP'),
(28, 'authLDAP_port', '', 'Port LDAP server is listening on', 'LDAP'),
(29, 'authLDAP_baseDN', 'dc=test,dc=lan', 'LDAP base DN', 'LDAP'),
(30, 'authLDAP_searchBase', 'ou=soc', 'LDAP search Base to use when searching for users (authLDAP_baseDN is automatically appended)', 'LDAP'),
(31, 'authLDAP_searchAttr', 'uid', 'LDAP attribute to use when searching for user', 'LDAP'),
(32, 'authLDAP_searchResults', 'dn', 'LDAP attributes to retun on successful authentication', 'LDAP'),
(33, 'maxScanAge', '180', 'Maximum scan age (in days) before last scan of host is considered too old', 'Maintainence'),
(34, 'nostatus', 'Decommissioned,Retired,Offline,Virtual,Alias', 'Host Status flag values to cause host entry to be ignored', 'Lists'),
(35, 'hostScanStateArray', 'Passed,Pending Scan,Pending Fixes,Pending Exceptions,Scan Out of Date, Fixes Applied - Pending ReScan', 'Comma separated list of possible scan states for a host', 'Lists'),
(36, 'serverLocationArray', 'Home, Away, Other', 'Possible locations of scan hosts', 'Lists'),
(37, 'serverNetworkArray', 'DMZ, Internal, Test, Lab, Other', 'Comma separate list of possible server networks', 'Lists'),
(38, 'serverStateArray', 'Production,Pending Production,Test,Development,UAT', 'Comma separated list of possibe server states', 'Lists'),
(39, 'requestStatusArray', 'Pending,Scheduled,Rejected', 'Comma separated list of possible scan request statuses', 'Lists'),
(40, 'exceptionStatusArray', 'Pending,Rejected,Approved', 'Comma separated list of possible exception statuses', 'Lists'),
(41, 'exceptionTypeArray', 'False Positive,AmbiguousVulnerability,TruePositive,Waiver', 'Comma separated list of possilble exception types', 'Lists'),
(42, 'enablessl', '1', 'Require SSL for all InProtect sessions', 'Base'),
(43, 'enablePS', '0', 'Enable the NMAP funcationality', 'Functions'),
(44, 'enableFP', '0', 'Enable the False Positive flagging', 'Functions'),
(45, 'enableException', '1', 'Enable tracking of vulnerability exceptions', 'Functions'),
(46, 'enableNotes', '1', 'Enable per-vulnerability notes', 'Functions'),
(47, 'enableUpdates', '0', 'Enable plugin updates from admin console (broken)', 'Functions'),
(48, 'admin_notifications', 'USER@HOST.COM', 'Admin Notification Email Address', 'Mail'),
(49, 'sitename', 'Inprotect Nessus', 'Site Name', 'BASE'),
(50, 'enableSub', '1', 'Enable Subnet Scanner', 'Functions'),
(51, 'enableADSubs', '1', 'Manage Subnets Internally ( external feed = 0 )', 'Subnets'),
(52, 'enableManZones', '1', 'Manage Zones Internally ( external feed = 0 )', 'Functions'),
(53, 'subnetStateArray', 'Available,Assigned,Reserved', 'Comma separated list of possibe subnet states', 'Lists'),
(54, 'enableDelProtect', '1', 'Prevent Profile/Report Deletion for Archival Purposes', 'Functions'),
(55, 'baselineNewSubnet', '1', 'Automatically Baseline Newly Created Subnets', 'Subnets'),
(56, 'company', '', 'Company Name', 'BASE'),
(57, 'siteLogo', 'images/logo-blue.png', 'Site Header Logo', 'BASE'),
(58, 'siteBranding', 'Inprotect', 'Portal Branding', 'BASE'),
(59, 'emailDomains', 'com|net|gov', 'Java Validation pattern for email validation (ex .Gov Only)', 'Mail'),
(60, 'mailSignature', 'SOC&lt;br&gt;&lt;br&gt;EMAIL&lt;br&gt;PHONE', 'Email Signature ( USE <BR> for multiline)', 'nessusBackend'),
(61, 'mailcc', 'root@localhost', 'Backend - CC on All EMAIL Notification', 'nessusBackend'),
(62, 'siteORG', 'SOC', 'Org Name representing Inprotect ( used on Backend Emails)', 'nessusBackend'),
(63, 'nameservers', '', 'Fallback Name Servers Comma Delimted', 'nessusBackend'),
(64, 'lockout_threshold', '3', 'Account Lockout Threshold', 'Auth'),
(65, 'lockout_duration', '20', 'Minutes Account is Locked out', 'Auth'),
(66, 'enComplianceChecks', '0', 'Compliance Checks (Direct/Professional Feed Users Only)', 'Compliance'),
(67, 'credAudit', '0', 'CredID for subnet Audits', 'Subnets'),
(68, 'unixAuditDir', '/opt/Inprotect/usr/share/Inprotect/compliance/unix', 'Location for Unix Audit Files', 'Compliance'),
(69, 'winAuditDir', '/opt/Inprotect/usr/share/Inprotect/compliance/win', 'Location for Win Audit Files', 'Compliance'),
(70, 'winFileAudits', '/opt/Inprotect/usr/share/Inprotect/compliance/win_file_contents', 'Location for File audits for windows', 'Compliance'),
(71, 'failedRetries', '3', 'Num Times to Requeue Failed Scans', 'nessusBackend'),
(72, 'defaultVSet', '1', 'Default ProfileID for Subnet Jobs', 'Subnets'),
(73, 'complainceVSet', '0', 'Default ProfileID for Compliance Jobs', 'Compliance'),
(74, 'maxHostAge', '90', 'How old host can be before Flagging Deleted', 'Maintainence'),
(75, 'enableISVM', '0', 'Enable Vulnerability Management', 'Functions' ),
(76, 'archiveNessus', '1', 'Archive Scan Data to a .nessus file', 'nessusBackend' );
-- --------------------------------------------------------

--
-- Table structure for table `log`
--

CREATE TABLE IF NOT EXISTS `log` (
  `id` int(11) NOT NULL auto_increment,
  `dtRecorded` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `ip` varchar(15) NOT NULL default '',
  `username` varchar(255) character set latin1 collate latin1_bin default NULL,
  `url` varchar(1024) NOT NULL,
  `action` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `log`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_audits`
--

CREATE TABLE IF NOT EXISTS `nessus_audits` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) default NULL,
  `check_type` varchar(25) NOT NULL default 'W',
  `type` char(1) NOT NULL default 'G',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `deleted` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_audits`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_audit_users`
--

CREATE TABLE IF NOT EXISTS `nessus_audit_users` (
  `cid` int(11) NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_audit_users`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_category`
--

CREATE TABLE IF NOT EXISTS `nessus_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `nname` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_category`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_checks`
--

CREATE TABLE IF NOT EXISTS `nessus_checks` (
  `id` int(11) NOT NULL auto_increment,
  `enabled` char(1) character set latin1 NOT NULL default 'Y',
  `name` varchar(255) character set latin1 default NULL,
  `created` varchar(14) collate latin1_bin default NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_bin AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_checks`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_checks_audits`
--

CREATE TABLE IF NOT EXISTS `nessus_checks_audits` (
  `id` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL,
  `enabled` char(1) NOT NULL default 'Y',
  `created` varchar(14) default NULL,
  `modified` varchar(14) default NULL,
  `deleted` varchar(14) default NULL,
  `value` varchar(255) NOT NULL,
  `auditfile` varchar(255) NOT NULL,
  `cce_id` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`cid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_checks_audits`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_family`
--

CREATE TABLE IF NOT EXISTS `nessus_family` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `nname` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_family`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_notes`
--

CREATE TABLE IF NOT EXISTS `nessus_notes` (
  `id` int(11) NOT NULL auto_increment,
  `pid` int(11) NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `note` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_notes`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_plugins`
--

CREATE TABLE IF NOT EXISTS `nessus_plugins` (
  `id` int(11) NOT NULL default '0',
  `enabled` char(1) NOT NULL default '',
  `version` varchar(255) default NULL,
  `created` varchar(14) default NULL,
  `modified` varchar(14) default NULL,
  `deleted` varchar(14) default NULL,
  `category` int(11) NOT NULL default '0',
  `family` int(11) NOT NULL default '0',
  `risk` int(11) NOT NULL default '0',
  `custom_risk` int(1) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_plugins`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_preferences`
--

CREATE TABLE IF NOT EXISTS `nessus_preferences` (
  `id` varchar(255) default NULL,
  `nessus_id` varchar(255) NOT NULL default '',
  `value` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `type` char(1) NOT NULL default '',
  PRIMARY KEY  (`nessus_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_preferences`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_preferences_defaults`
--

CREATE TABLE IF NOT EXISTS `nessus_preferences_defaults` (
  `nessus_id` varchar(255) NOT NULL default '',
  `nessusgroup` varchar(255) default NULL,
  `type` varchar(255) default NULL,
  `field` varchar(255) default NULL,
  `value` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `flag` char(1) default NULL,
  PRIMARY KEY  (`nessus_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_preferences_defaults`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_reports`
--

CREATE TABLE IF NOT EXISTS `nessus_reports` (
  `report_id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `fk_name` varchar(50) default NULL,
  `scantime` varchar(14) NOT NULL default '',
  `report_type` char(1) NOT NULL default 'N',
  `username` varchar(255) character set latin1 collate latin1_bin default NULL,
  `sid` int(11) default NULL,
  `scantype` char(1) NOT NULL default 'M',
  `server_ip` varchar(15) NOT NULL default '',
  `server_nversion` varchar(100) NOT NULL default '',
  `server_feedtype` varchar(32) NOT NULL default '',
  `server_feedversion` varchar(12) NOT NULL default '',
  `domain` varchar(255) NOT NULL default '',
  `report_key` varchar(16) NOT NULL default '',
  `report_path` varchar(255) default NULL,
  `cred_used` varchar(25) default NULL,
  `results_sent` tinyint(2) NOT NULL default '0',
  `deleted` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`report_id`),
  KEY `subnet` (`fk_name`),
  KEY `scantime` (`scantime`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_reports`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_report_stats`
--

CREATE TABLE IF NOT EXISTS `nessus_report_stats` (
  `id` int(11) NOT NULL auto_increment,
  `report_id` int(11) NOT NULL default '0',
  `name` varchar(25) NOT NULL default '',
  `iHostCnt` int(4) NOT NULL default '0',
  `dtLastScanned` datetime NOT NULL default '0000-00-00 00:00:00',
  `iScantime` decimal(4,0) NOT NULL default '0',
  `vSerious` int(4) NOT NULL default '0',
  `vHigh` int(4) NOT NULL default '0',
  `vMed` int(4) NOT NULL default '0',
  `vMedLow` int(4) NOT NULL default '0',
  `vLowMed` int(4) NOT NULL default '0',
  `vLow` int(4) NOT NULL default '0',
  `vInfo` int(4) NOT NULL default '0',
  `trend` int(4) NOT NULL default '0',
  `dtLastUpdated` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `report_id` (`report_id`),
  KEY `subnet` (`name`),
  KEY `dtLastScanned` (`dtLastScanned`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_report_stats`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_results`
--

CREATE TABLE IF NOT EXISTS `nessus_results` (
  `result_id` int(11) NOT NULL auto_increment,
  `report_id` int(11) NOT NULL default '0',
  `scantime` varchar(14) NOT NULL default '',
  `record_type` char(1) NOT NULL default 'N',
  `hostIP` varchar(40) NOT NULL default '',
  `hostname` varchar(100) default NULL,
  `service` varchar(40) NOT NULL default '',
  `port` int(11) default NULL,
  `protocol` varchar(5) default NULL,
  `app` varchar(20) default NULL,
  `scriptid` varchar(40) NOT NULL default '',
  `risk` enum('1','2','3','4','5','6','7') NOT NULL default '1',
  `msg` text,
  `falsepositive` char(1) default 'N',
  PRIMARY KEY  (`result_id`),
  KEY `report_id` (`report_id`),
  KEY `scantime` (`scantime`),
  KEY `scriptid` (`scriptid`),
  KEY `hostIP` (`hostIP`),
  KEY `risk` (`risk`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_results`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_servers`
--

CREATE TABLE IF NOT EXISTS `nessus_servers` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `hostname` varchar(255) NOT NULL default '',
  `port` int(11) NOT NULL default '1241',
  `user` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `PASSWORD` varchar(255) NOT NULL default '',
  `server_nversion` varchar(100) NOT NULL default '',
  `server_feedtype` varchar(32) NOT NULL default '',
  `server_feedversion` varchar(12) NOT NULL default '',
  `max_scans` int(11) NOT NULL default '10',
  `current_scans` int(11) NOT NULL default '0',
  `TYPE` char(1) NOT NULL default '',
  `site_code` varchar(25) NOT NULL default '',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `checkin_time` datetime default NULL,
  `status` char(1) default NULL,
  `enabled` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_servers`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_server_zones`
--

CREATE TABLE IF NOT EXISTS `nessus_server_zones` (
  `zoneid` int(11) NOT NULL default '0',
  `nessusid` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_server_zones`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_settings`
--

CREATE TABLE IF NOT EXISTS `nessus_settings` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) default NULL,
  `autoenable` char(1) NOT NULL default 'N',
  `type` char(1) NOT NULL default 'G',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `auto_cat_status` int(10) NOT NULL default '4',
  `auto_fam_status` int(10) NOT NULL default '4',
  `update_host_tracker` tinyint(1) NOT NULL default '0',
  `deleted` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_settings`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_settings_category`
--

CREATE TABLE IF NOT EXISTS `nessus_settings_category` (
  `sid` int(11) NOT NULL default '0',
  `cid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_settings_category`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_settings_family`
--

CREATE TABLE IF NOT EXISTS `nessus_settings_family` (
  `sid` int(11) NOT NULL default '0',
  `fid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_settings_family`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_settings_plugins`
--

CREATE TABLE IF NOT EXISTS `nessus_settings_plugins` (
  `id` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `enabled` char(1) NOT NULL default 'Y',
  `category` int(11) NOT NULL default '0',
  `family` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_settings_plugins`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_settings_preferences`
--

CREATE TABLE IF NOT EXISTS `nessus_settings_preferences` (
  `sid` int(11) NOT NULL default '0',
  `id` varchar(255) default NULL,
  `nessus_id` varchar(255) NOT NULL default '',
  `value` varchar(255) default NULL,
  `category` varchar(255) default NULL,
  `type` char(1) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nessus_settings_preferences`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_settings_users`
--

CREATE TABLE IF NOT EXISTS `nessus_settings_users` (
  `id` int(11) NOT NULL auto_increment,
  `sid` int(11) NOT NULL default '0',
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_settings_users`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_user_zones`
--

CREATE TABLE IF NOT EXISTS `nessus_user_zones` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `zid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_user_zones`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_zones`
--

CREATE TABLE IF NOT EXISTS `nessus_zones` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `TYPE` char(1) NOT NULL default 'G',
  `owner` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `locked` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_zones`
--


-- --------------------------------------------------------

--
-- Table structure for table `nessus_zone_ranges`
--

CREATE TABLE IF NOT EXISTS `nessus_zone_ranges` (
  `id` int(11) NOT NULL auto_increment,
  `zoneid` int(11) NOT NULL default '0',
  `range_start` int(11) unsigned NOT NULL default '0',
  `range_end` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `nessus_zone_ranges`
--


-- --------------------------------------------------------

--
-- Table structure for table `plugins`
--

CREATE TABLE IF NOT EXISTS `plugins` (
  `id` int(11) NOT NULL,
  `name` varchar(255) collate utf8_unicode_ci default NULL,
  `family` varchar(255) collate utf8_unicode_ci default NULL,
  `category` varchar(255) collate utf8_unicode_ci default NULL,
  `copyright` varchar(255) collate utf8_unicode_ci default NULL,
  `summary` varchar(255) collate utf8_unicode_ci default NULL,
  `description` blob,
  `version` varchar(255) collate utf8_unicode_ci default NULL,
  `cve_id` varchar(255) collate utf8_unicode_ci default NULL,
  `bugtraq_id` varchar(255) collate utf8_unicode_ci default NULL,
  `xref` blob,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `plugins`
--


-- --------------------------------------------------------

--
-- Table structure for table `portscan`
--

CREATE TABLE IF NOT EXISTS `portscan` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `userip` varchar(15) NOT NULL default '',
  `submittime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `scanip` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `ports` char(1) NOT NULL default 'T',
  `portstart` smallint(5) unsigned default NULL,
  `portend` smallint(5) unsigned default NULL,
  `common` char(1) NOT NULL default 'Y',
  `scancomplete` char(1) NOT NULL default 'N',
  `options` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `portscan`
--


-- --------------------------------------------------------

--
-- Table structure for table `portscan_os`
--

CREATE TABLE IF NOT EXISTS `portscan_os` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(15) default NULL,
  `os` varchar(255) default NULL,
  `details` varchar(255) default NULL,
  `devtype` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `portscan_os`
--


-- --------------------------------------------------------

--
-- Table structure for table `portscan_results`
--

CREATE TABLE IF NOT EXISTS `portscan_results` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(15) default NULL,
  `port` int(11) NOT NULL default '0',
  `type` char(3) NOT NULL default '',
  `status` varchar(8) NOT NULL default '',
  `description` varchar(40) default NULL,
  `version` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `portscan_results`
--


-- --------------------------------------------------------

--
-- Table structure for table `risk_level`
--

CREATE TABLE IF NOT EXISTS `risk_level` (
  `id` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `risk_level`
--

INSERT INTO `risk_level` (`id`, `description`) VALUES
(1, 'Serious'),
(2, 'High'),
(3, 'Medium'),
(4, 'Medium/Low'),
(5, 'Low/Medium'),
(6, 'Low'),
(7, 'Info');

-- --------------------------------------------------------

--
-- Table structure for table `roles`
--

CREATE TABLE IF NOT EXISTS `roles` (
  `roleID` int(10) unsigned NOT NULL auto_increment,
  `roleName` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `roleDesc` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`roleID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci PACK_KEYS=0 AUTO_INCREMENT=20 ;

--
-- Dumping data for table `roles`
--

INSERT INTO `roles` (`roleID`, `roleName`, `roleDesc`) VALUES
(1, 'admin', 'Administrator incl. users'),
(2, 'uadmin', 'User Administration'),
(3, 'nessus', 'Run Nessus scans'),
(4, 'nmap', 'Run Nmap scans'),
(5, 'scanRequest', 'Submit Scan Requests'),
(6, 'reports', 'View all scan reports'),
(7, 'zones', 'Edit Network Zones'),
(8, 'eapprove', 'Approve Exceptions'),
(9, 'esubmit', 'Submit Exception Requests'),
(10, 'eview', 'View Exceptions'),
(11, 'profile', 'Edit Nessus Scan Profiles'),
(12, 'selfservice', 'Scan Own Subnets'),
(13, 'infrastructure', 'Manage Infrastructure'),
(14, 'debug', 'Developer Role to Troubleshoot SQL'),
(15, 'vpnadmin', 'Manage SOC VPN Devices'),
(16, 'sys_access', 'Manage Systems'),
(17, 'credscans', 'Scan With Credentials'),
(18, 'compAudit', 'Allowed to Run Compliance Audits'),
(19, 'auditAll', 'Allowed to audit all Subnets'),
(20, 'isvmView', 'View/Review ISVM'),
(21, 'isvmAdmin', 'Edit/Update ISVM'),
( 22 , 'plugoverride', 'Allowed to Run Custom Plugin Lists' );

-- --------------------------------------------------------

--
-- Table structure for table `sessions`
--

CREATE TABLE IF NOT EXISTS `sessions` (
  `uname` varchar(25) collate utf8_unicode_ci NOT NULL default '',
  `time` varchar(14) collate utf8_unicode_ci NOT NULL default '',
  `host_addr` varchar(48) collate utf8_unicode_ci NOT NULL default '',
  `guest` int(1) NOT NULL default '0',
  KEY `time` (`time`),
  KEY `guest` (`guest`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `sessions`
--


-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `pn_uname` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  `pn_email` varchar(60) collate utf8_unicode_ci NOT NULL default '',
  `pn_pass` varchar(40) collate utf8_unicode_ci NOT NULL default '',
  `pass_lastchanged` datetime NOT NULL,
  `expire` varchar(8) collate utf8_unicode_ci default NULL,
  `locked` int(11) NOT NULL default '0',
  `lockout_reset` datetime default NULL,
  `created` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastaccessed` datetime NOT NULL default '0000-00-00 00:00:00',
  `owniponly` char(1) collate utf8_unicode_ci NOT NULL default 'N',
  `sc_now` char(1) collate utf8_unicode_ci NOT NULL default 'N',
  `sc_once` char(1) collate utf8_unicode_ci NOT NULL default 'N',
  `sc_daily` char(1) collate utf8_unicode_ci NOT NULL default 'N',
  `sc_weekly` char(1) collate utf8_unicode_ci NOT NULL default 'N',
  `sc_monthly` char(1) collate utf8_unicode_ci NOT NULL default 'N',
  PRIMARY KEY  (`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`pn_uname`, `pn_email`, `pn_pass`, `pass_lastchanged`, `expire`, `locked`, `lockout_reset`, `created`, `lastaccessed`, `owniponly`, `sc_now`, `sc_once`, `sc_daily`, `sc_weekly`, `sc_monthly`) VALUES
('admin', 'root@localhost', '5f4dcc3b5aa765d61d8327deb882cf99', '0000-00-00 00:00:00', '', 0, NULL, '2008-06-05 07:20:40', '0000-00-00 00:00:00', 'N', 'N', 'N', 'N', 'N', 'N');

-- --------------------------------------------------------

--
-- Table structure for table `user_dashboards`
--

CREATE TABLE IF NOT EXISTS `user_dashboards` (
  `udID` int(10) unsigned NOT NULL auto_increment,
  `dashID` int(10) NOT NULL default '0',
  `dashStatus` int(10) NOT NULL default '1',
  `dashLocation` varchar(25) collate utf8_unicode_ci NOT NULL default 'lcolumn',
  `dashOrder` int(10) default NULL,
  `pn_uname` varchar(55) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`udID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=6 ;

--
-- Dumping data for table `user_dashboards`
--

INSERT INTO `user_dashboards` (`udID`, `dashID`, `dashStatus`, `dashLocation`, `dashOrder`, `pn_uname`) VALUES
(1, 1, 0, 'rcolumn', 2, 'admin'),
(2, 2, 1, 'rcolumn', 1, 'admin'),
(3, 3, 1, 'lcolumn', 3, 'admin'),
(4, 4, 1, 'lcolumn', 4, 'admin'),
(5, 5, 0, 'lcolumn', 5, 'admin');

-- --------------------------------------------------------

--
-- Table structure for table `user_groups`
--

CREATE TABLE IF NOT EXISTS `user_groups` (
  `ugID` int(10) unsigned NOT NULL auto_increment,
  `pn_uname` varchar(55) collate utf8_unicode_ci NOT NULL default '',
  `gid` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ugID`),
  KEY `pn_uname` (`pn_uname`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=4 ;

--
-- Dumping data for table `user_groups`
--

INSERT INTO `user_groups` (`ugID`, `pn_uname`, `gid`) VALUES
(1, 'admin', 1),
(2, 'admin', 3),
(3, 'admin', 6);

-- --------------------------------------------------------

--
-- Table structure for table `user_roles`
--

CREATE TABLE IF NOT EXISTS `user_roles` (
  `urID` int(10) unsigned NOT NULL auto_increment,
  `roleID` int(10) unsigned NOT NULL default '0',
  `pn_uname` varchar(255) collate utf8_unicode_ci NOT NULL default '',
  PRIMARY KEY  (`urID`),
  KEY `role` (`roleID`,`pn_uname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `user_roles`
--

