

 ALTER TABLE I3_site_users CHANGE uid username VARCHAR( 25 ) NOT NULL DEFAULT '';

CREATE TABLE IF NOT EXISTS `portscan` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(255) character set latin1 collate latin1_bin NOT NULL default '',
  `userip` varchar(15) NOT NULL default '',
  `submittime` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `scanip` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `ports` char(1) NOT NULL default 'T',
  `portstart` smallint(5) unsigned default NULL,
  `portend` smallint(5) unsigned default NULL,
  `common` char(1) NOT NULL default 'Y',
  `scancomplete` char(1) NOT NULL default 'N',
  `options` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `portscan_os` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(15) default NULL,
  `os` varchar(255) default NULL,
  `details` varchar(255) default NULL,
  `devtype` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

CREATE TABLE IF NOT EXISTS `portscan_results` (
  `id` int(11) NOT NULL default '0',
  `host` varchar(15) default NULL,
  `port` int(11) NOT NULL default '0',
  `type` char(3) NOT NULL default '',
  `status` varchar(8) NOT NULL default '',
  `description` varchar(40) default NULL,
  `version` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;


UPDATE inprotect_settings SET settingValue='1.00.0_alpha_12' WHERE settingName='version';